/**
 * tdesign v1.12.0
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

var capitalize = require('./dep-7ed5d19e.js');
var _createCompounder = require('./dep-2f0c3d6d.js');

/**
 * Converts `string` to [camel case](https://en.wikipedia.org/wiki/CamelCase).
 *
 * @static
 * @memberOf _
 * @since 3.0.0
 * @category String
 * @param {string} [string=''] The string to convert.
 * @returns {string} Returns the camel cased string.
 * @example
 *
 * _.camelCase('Foo Bar');
 * // => 'fooBar'
 *
 * _.camelCase('--foo-bar--');
 * // => 'fooBar'
 *
 * _.camelCase('__FOO_BAR__');
 * // => 'fooBar'
 */
var camelCase = _createCompounder.createCompounder(function (result, word, index) {
  word = word.toLowerCase();
  return result + (index ? capitalize.capitalize(word) : word);
});
var camelCase$1 = camelCase;

exports.camelCase = camelCase$1;
//# sourceMappingURL=dep-f0f28315.js.map
