/**
 * tdesign v1.12.0
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var _defineProperty = require('@babel/runtime/helpers/defineProperty');
var _common_js_log_log = require('../log/log.js');
var pick = require('../../../_chunks/dep-9a8d9286.js');
var isBoolean = require('../../../_chunks/dep-a3139c33.js');
var omit = require('../../../_chunks/dep-11856238.js');
var isUndefined = require('../../../_chunks/dep-caea5f4e.js');
require('../../../_chunks/dep-76dea031.js');
require('../../../_chunks/dep-36c57efe.js');
require('@babel/runtime/helpers/typeof');
require('../../../_chunks/dep-0f4ac92d.js');
require('../../../_chunks/dep-31fa06d0.js');
require('../../../_chunks/dep-f4d07ab0.js');
require('../../../_chunks/dep-49887b48.js');
require('../../../_chunks/dep-89b9f4de.js');
require('../../../_chunks/dep-1c1cc34f.js');
require('../../../_chunks/dep-ba816077.js');
require('../../../_chunks/dep-852fc6a9.js');
require('../../../_chunks/dep-f8b182e9.js');
require('../../../_chunks/dep-27d04ffe.js');
require('../../../_chunks/dep-11382958.js');
require('../../../_chunks/dep-c272f99f.js');
require('../../../_chunks/dep-9a119db9.js');
require('../../../_chunks/dep-56240b5e.js');
require('../../../_chunks/dep-c9d43e30.js');
require('../../../_chunks/dep-bc3ec918.js');
require('../../../_chunks/dep-bd4b64b6.js');
require('../../../_chunks/dep-d3e77112.js');
require('../../../_chunks/dep-fcdc23bb.js');
require('../../../_chunks/dep-7ec0f498.js');
require('../../../_chunks/dep-b5cedeaa.js');
require('../../../_chunks/dep-d59c4646.js');
require('../../../_chunks/dep-23d55f82.js');
require('../../../_chunks/dep-f97b0058.js');
require('../../../_chunks/dep-07989e63.js');
require('../../../_chunks/dep-b520fc3a.js');
require('../../../_chunks/dep-f2e07584.js');
require('../../../_chunks/dep-0982adb4.js');
require('../../../_chunks/dep-76d8c62c.js');
require('../../../_chunks/dep-59f3051f.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var _defineProperty__default = /*#__PURE__*/_interopDefaultLegacy(_defineProperty);

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty__default["default"](e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function getExposedProps(node) {
  var props = pick.pick(node, ["value", "label", "data", "actived", "expanded", "checked", "indeterminate", "loading"]);
  return props;
}
function createNodeModel(node) {
  var props = getExposedProps(node);
  var model = _objectSpread(_objectSpread({}, props), {}, {
    getLevel: function getLevel() {
      return node.getLevel();
    },
    getIndex: function getIndex() {
      return node.getIndex();
    },
    isFirst: function isFirst() {
      return node.isFirst();
    },
    isLast: function isLast() {
      return node.isLast();
    },
    isLeaf: function isLeaf() {
      return node.isLeaf();
    },
    insertBefore: function insertBefore(newData) {
      return node.insertBefore(newData);
    },
    insertAfter: function insertAfter(newData) {
      return node.insertAfter(newData);
    },
    appendData: function appendData(data) {
      return node.append(data);
    },
    getPath: function getPath() {
      var nodes = node.getPath();
      return nodes.map(function (item) {
        return item.getModel();
      });
    },
    getParent: function getParent() {
      var _node$parent;
      return (_node$parent = node.parent) === null || _node$parent === void 0 ? void 0 : _node$parent.getModel();
    },
    getParents: function getParents() {
      var nodes = node.getParents();
      return nodes.map(function (item) {
        return item.getModel();
      });
    },
    getRoot: function getRoot() {
      var root = node.getRoot();
      return root === null || root === void 0 ? void 0 : root.getModel();
    },
    getSiblings: function getSiblings() {
      var nodes = node.getSiblings();
      return nodes.map(function (item) {
        return item.getModel();
      });
    },
    getChildren: function getChildren(deep) {
      var childrenModel = false;
      var children = node.children;
      if (Array.isArray(children)) {
        if (children.length > 0) {
          if (deep) {
            var nodes = node.walk();
            nodes.shift();
            childrenModel = nodes.map(function (item) {
              return item.getModel();
            });
          } else {
            childrenModel = children.map(function (item) {
              return item.getModel();
            });
          }
        } else {
          childrenModel = false;
        }
      } else if (isBoolean.isBoolean(children)) {
        childrenModel = children;
      }
      return childrenModel;
    },
    remove: function remove(value) {
      if (!value) {
        node.remove();
        return;
      }
      var tree = node.tree;
      var targetNode = tree.getNode(value);
      if (!targetNode) {
        _common_js_log_log["default"].warnOnce("Tree", "`".concat(value, "` is not exist"));
        return;
      }
      var parents = targetNode.getParents();
      var parentValues = parents.map(function (pnode) {
        return pnode.value;
      });
      if (parentValues.indexOf(node.value) < 0) {
        _common_js_log_log["default"].warnOnce("Tree", "`".concat(value, "` is not a childNode of current node"));
        return;
      }
      targetNode.remove();
    },
    setData: function setData(data) {
      var _data = omit.omit(data, ["children", "value", "label"]);
      var keys = node.tree.config.keys;
      var dataValue = data[(keys === null || keys === void 0 ? void 0 : keys.value) || "value"];
      var dataLabel = data[(keys === null || keys === void 0 ? void 0 : keys.label) || "label"];
      if (!isUndefined.isUndefined(dataValue)) _data.value = dataValue;
      if (!isUndefined.isUndefined(dataLabel)) _data.label = dataLabel;
      Object.assign(node.data, _data);
      Object.assign(node, _data);
    }
  });
  return model;
}
function updateNodeModel(model, node) {
  var props = getExposedProps(node);
  Object.assign(model, props);
}

exports.createNodeModel = createNodeModel;
exports.updateNodeModel = updateNodeModel;
//# sourceMappingURL=tree-node-model.js.map
