/**
 * tdesign v1.12.0
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var _defineProperty = require('@babel/runtime/helpers/defineProperty');
var loading_index = require('../loading/index.js');
var button_props = require('./props.js');
var utils_renderTnode = require('../utils/render-tnode.js');
var utils_ripple = require('../utils/ripple.js');
var configProvider_configReceiver = require('../config-provider/config-receiver.js');
var utils_mixins = require('../utils/mixins.js');
require('../loading/directive.js');
require('../loading/plugin.js');
require('vue');
require('../loading/loading.js');
require('../loading/icon/gradient.js');
require('../_common/js/loading/circle-adapter.js');
require('../_common/js/utils/setStyle.js');
require('../_common/js/utils/helper.js');
require('@babel/runtime/helpers/toConsumableArray');
require('@babel/runtime/helpers/objectWithoutProperties');
require('@babel/runtime/helpers/slicedToArray');
require('../_chunks/dep-caea5f4e.js');
require('../_chunks/dep-1fe4c69b.js');
require('../_chunks/dep-2e662da4.js');
require('../_chunks/dep-31fa06d0.js');
require('@babel/runtime/helpers/typeof');
require('../_chunks/dep-36c57efe.js');
require('../_chunks/dep-f4d07ab0.js');
require('../_chunks/dep-260a7245.js');
require('../utils/dom.js');
require('raf');
require('../utils/easing.js');
require('../utils/transfer-dom.js');
require('../loading/props.js');
require('../config.js');
require('../_chunks/dep-65c8d021.js');
require('../_common/js/global-config/default-config.js');
require('../_common/js/global-config/locale/zh_CN.js');
require('../_chunks/dep-bc99824f.js');
require('../_chunks/dep-4effc6c4.js');
require('dayjs');
require('../_chunks/dep-d59c4646.js');
require('../_chunks/dep-11382958.js');
require('../_chunks/dep-c272f99f.js');
require('../_chunks/dep-89b9f4de.js');
require('../_chunks/dep-1c1cc34f.js');
require('../_chunks/dep-ba816077.js');
require('../_chunks/dep-852fc6a9.js');
require('../_chunks/dep-c9d43e30.js');
require('../_chunks/dep-23d55f82.js');
require('../_chunks/dep-bc3ec918.js');
require('../_chunks/dep-f97b0058.js');
require('../_chunks/dep-9a119db9.js');
require('../_chunks/dep-49887b48.js');
require('../_chunks/dep-06c569d8.js');
require('../_chunks/dep-4d554a6f.js');
require('../_chunks/dep-7ec0f498.js');
require('../_chunks/dep-fcdc23bb.js');
require('../_chunks/dep-59f3051f.js');
require('../_chunks/dep-b86e0f9e.js');
require('@babel/runtime/helpers/readOnlyError');
require('@vue/composition-api');
require('../_chunks/dep-f0f28315.js');
require('../_chunks/dep-7ed5d19e.js');
require('../_chunks/dep-f8b182e9.js');
require('../_chunks/dep-0f4ac92d.js');
require('../_chunks/dep-2f28fbd7.js');
require('../_chunks/dep-76d8c62c.js');
require('../_chunks/dep-2f0c3d6d.js');
require('../_chunks/dep-b08014cb.js');
require('../_chunks/dep-029c3522.js');
require('../_chunks/dep-c63385b6.js');
require('../_chunks/dep-ab17e69e.js');
require('../_chunks/dep-87dae4a0.js');
require('../_chunks/dep-07989e63.js');
require('../_chunks/dep-d3e77112.js');
require('../_chunks/dep-b520fc3a.js');
require('../_chunks/dep-f2e07584.js');
require('../_chunks/dep-9a183e68.js');
require('../_chunks/dep-5c93d051.js');
require('../_chunks/dep-76dea031.js');
require('../_chunks/dep-56240b5e.js');
require('../_chunks/dep-81ddbae0.js');
require('../utils/withInstall.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var _defineProperty__default = /*#__PURE__*/_interopDefaultLegacy(_defineProperty);

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty__default["default"](e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var keepAnimationMixins = configProvider_configReceiver.getKeepAnimationMixins();
var classPrefixMixins = configProvider_configReceiver.getClassPrefixMixins("button");
var TButton = utils_mixins["default"](keepAnimationMixins, classPrefixMixins).extend({
  name: "TButton",
  props: button_props["default"],
  directives: {
    ripple: utils_ripple["default"]
  },
  render: function render(h) {
    var _this = this;
    var buttonContent = utils_renderTnode.renderContent(this, "default", "content");
    var icon = this.loading ? h(loading_index.Loading, {
      "attrs": {
        "inheritColor": true
      }
    }) : utils_renderTnode.renderTNodeJSX(this, "icon");
    var disabled = this.disabled || this.loading;
    var suffix = this.suffix || this.$scopedSlots.suffix ? h("span", {
      "class": "".concat(this.componentName, "__suffix")
    }, [utils_renderTnode.renderTNodeJSX(this, "suffix")]) : null;
    var theme = this.theme;
    if (!this.theme) {
      if (this.variant === "base") {
        theme = "primary";
      } else {
        theme = "default";
      }
    }
    var buttonClass = ["".concat(this.componentName), "".concat(this.componentName, "--variant-").concat(this.variant), "".concat(this.componentName, "--theme-").concat(theme), _defineProperty__default["default"](_defineProperty__default["default"](_defineProperty__default["default"](_defineProperty__default["default"](_defineProperty__default["default"](_defineProperty__default["default"]({}, this.commonSizeClassName[this.size], this.size !== "medium"), this.commonStatusClassName.disabled, this.disabled), this.commonStatusClassName.loading, this.loading), "".concat(this.componentName, "--shape-").concat(this.shape), this.shape !== "rectangle"), "".concat(this.componentName, "--ghost"), this.ghost), this.commonSizeClassName.block, this.block)];
    buttonContent = buttonContent ? h("span", {
      "class": "".concat(this.componentName, "__text")
    }, [buttonContent]) : "";
    if (icon) {
      buttonContent = [icon, buttonContent];
    }
    if (suffix) {
      buttonContent = [buttonContent].concat(suffix);
    }
    var on = _objectSpread({}, this.$listeners);
    if (typeof this.onClick === "function") {
      on.click = this.onClick;
    }
    var buttonAttrs = {
      type: this.type,
      disabled: disabled,
      href: this.href || void 0
    };
    var renderTag = function renderTag() {
      if (!_this.tag && _this.href) return "a";
      return _this.tag || "button";
    };
    return h(renderTag(), {
      "class": buttonClass,
      attrs: buttonAttrs,
      on: on,
      directives: [{
        name: "ripple",
        value: this.keepAnimation.ripple
      }]
    }, [buttonContent]);
  }
});

exports["default"] = TButton;
//# sourceMappingURL=button.js.map
