/**
 * tdesign v1.12.0
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var helper = require('../_chunks/dep-27ac0b8c.js');
var _defineProperty = require('@babel/runtime/helpers/defineProperty');
var VueCompositionAPI = require('@vue/composition-api');
var configProvider_useConfig = require('../config-provider/useConfig.js');
var hooks_useCommonClassName = require('../hooks/useCommonClassName.js');
var utils_renderTnode = require('../utils/render-tnode.js');
var loading_index = require('../loading/index.js');
var card_props = require('./props.js');
require('../_chunks/dep-65c8d021.js');
require('../_common/js/global-config/default-config.js');
require('../_common/js/global-config/locale/zh_CN.js');
require('../_chunks/dep-bc99824f.js');
require('@babel/runtime/helpers/typeof');
require('../_chunks/dep-4effc6c4.js');
require('dayjs');
require('../_chunks/dep-d59c4646.js');
require('../_chunks/dep-11382958.js');
require('../_chunks/dep-c272f99f.js');
require('../_chunks/dep-89b9f4de.js');
require('../_chunks/dep-1c1cc34f.js');
require('../_chunks/dep-31fa06d0.js');
require('../_chunks/dep-ba816077.js');
require('../_chunks/dep-852fc6a9.js');
require('../_chunks/dep-c9d43e30.js');
require('../_chunks/dep-f4d07ab0.js');
require('../_chunks/dep-36c57efe.js');
require('../_chunks/dep-23d55f82.js');
require('../_chunks/dep-bc3ec918.js');
require('../_chunks/dep-f97b0058.js');
require('../_chunks/dep-9a119db9.js');
require('../_chunks/dep-49887b48.js');
require('../_chunks/dep-06c569d8.js');
require('../_chunks/dep-4d554a6f.js');
require('../_chunks/dep-7ec0f498.js');
require('../_chunks/dep-fcdc23bb.js');
require('../_chunks/dep-59f3051f.js');
require('../_chunks/dep-b86e0f9e.js');
require('@babel/runtime/helpers/readOnlyError');
require('vue');
require('../_chunks/dep-f0f28315.js');
require('../_chunks/dep-7ed5d19e.js');
require('../_chunks/dep-f8b182e9.js');
require('../_chunks/dep-0f4ac92d.js');
require('../_chunks/dep-2f28fbd7.js');
require('../_chunks/dep-76d8c62c.js');
require('../_chunks/dep-2f0c3d6d.js');
require('../_chunks/dep-b08014cb.js');
require('../loading/directive.js');
require('../loading/plugin.js');
require('../loading/loading.js');
require('../loading/icon/gradient.js');
require('../_common/js/loading/circle-adapter.js');
require('../_common/js/utils/setStyle.js');
require('../_common/js/utils/helper.js');
require('@babel/runtime/helpers/toConsumableArray');
require('@babel/runtime/helpers/objectWithoutProperties');
require('@babel/runtime/helpers/slicedToArray');
require('../_chunks/dep-caea5f4e.js');
require('../_chunks/dep-1fe4c69b.js');
require('../_chunks/dep-2e662da4.js');
require('../_chunks/dep-260a7245.js');
require('../config-provider/config-receiver.js');
require('../utils/mixins.js');
require('../utils/dom.js');
require('raf');
require('../utils/easing.js');
require('../utils/transfer-dom.js');
require('../loading/props.js');
require('../config.js');
require('../_chunks/dep-029c3522.js');
require('../_chunks/dep-c63385b6.js');
require('../_chunks/dep-ab17e69e.js');
require('../_chunks/dep-87dae4a0.js');
require('../_chunks/dep-07989e63.js');
require('../_chunks/dep-d3e77112.js');
require('../_chunks/dep-b520fc3a.js');
require('../_chunks/dep-f2e07584.js');
require('../_chunks/dep-9a183e68.js');
require('../_chunks/dep-5c93d051.js');
require('../_chunks/dep-76dea031.js');
require('../_chunks/dep-56240b5e.js');
require('../_chunks/dep-81ddbae0.js');
require('../utils/withInstall.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var _defineProperty__default = /*#__PURE__*/_interopDefaultLegacy(_defineProperty);

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty__default["default"](e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var _Card = VueCompositionAPI.defineComponent({
  name: "TCard",
  props: _objectSpread({}, card_props["default"]),
  components: {
    TLoading: loading_index.Loading
  },
  setup: function setup(props2, _ref) {
    var slots = _ref.slots;
    var _useCommonClassName = hooks_useCommonClassName["default"](),
      sizeClassNames = _useCommonClassName.sizeClassNames;
    var COMPONENT_NAME = configProvider_useConfig.usePrefixClass("card");
    var baseCls = VueCompositionAPI.computed(function () {
      var defaultClass = [COMPONENT_NAME.value];
      if (props2.size === "small") defaultClass.push("".concat(sizeClassNames[props2.size]));
      if (props2.bordered) defaultClass.push("".concat(COMPONENT_NAME.value, "--bordered"));
      if (props2.shadow) defaultClass.push("".concat(COMPONENT_NAME.value, "--shadow"));
      if (props2.hoverShadow) defaultClass.push("".concat(COMPONENT_NAME.value, "--shadow-hover"));
      return defaultClass;
    });
    var headerCls = VueCompositionAPI.computed(function () {
      var defaultClass = ["".concat(COMPONENT_NAME.value, "__header")];
      return props2.headerBordered ? defaultClass.concat("".concat(COMPONENT_NAME.value, "__title--bordered")) : ["".concat(COMPONENT_NAME.value, "__header")];
    });
    var headerWrapperCls = configProvider_useConfig.usePrefixClass("card__header-wrapper");
    var headerAvatarCls = configProvider_useConfig.usePrefixClass("card__avatar");
    var headerTitleCls = configProvider_useConfig.usePrefixClass("card__title");
    var headerSubTitleCls = configProvider_useConfig.usePrefixClass("card__subtitle");
    var headerDescriptionCls = configProvider_useConfig.usePrefixClass("card__description");
    var actionsCls = configProvider_useConfig.usePrefixClass("card__actions");
    var bodyCls = configProvider_useConfig.usePrefixClass("card__body");
    var coverCls = configProvider_useConfig.usePrefixClass("card__cover");
    var footerCls = configProvider_useConfig.usePrefixClass("card__footer");
    var footerWrapperCls = configProvider_useConfig.usePrefixClass("card__footer-wrapper");
    var isPoster2 = VueCompositionAPI.computed(function () {
      return props2.theme === "poster2";
    });
    var showTitle = VueCompositionAPI.computed(function () {
      return props2.title || slots.title;
    });
    var showHeader = VueCompositionAPI.computed(function () {
      return props2.header || slots.header;
    });
    var showSubtitle = VueCompositionAPI.computed(function () {
      return props2.subtitle || slots.subtitle;
    });
    var showAvatar = VueCompositionAPI.computed(function () {
      return props2.avatar || slots.avatar;
    });
    var showDescription = VueCompositionAPI.computed(function () {
      return props2.description || slots.description;
    });
    var showStatus = VueCompositionAPI.computed(function () {
      return props2.status || slots.status;
    });
    var showActions = VueCompositionAPI.computed(function () {
      return props2.actions || slots.actions;
    });
    var showFooter = VueCompositionAPI.computed(function () {
      return props2.footer || slots.footer;
    });
    var showCover = VueCompositionAPI.computed(function () {
      return props2.cover || slots.cover;
    });
    var showLoading = VueCompositionAPI.computed(function () {
      return props2.loading || slots.loading;
    });
    var showContent = VueCompositionAPI.computed(function () {
      return props2.content || slots.content || props2["default"] || slots["default"];
    });
    var isHeaderRender = VueCompositionAPI.computed(function () {
      return showHeader.value || showTitle.value || showSubtitle.value || showDescription.value || showAvatar.value || showStatus.value && isPoster2.value || showActions.value && !isPoster2.value;
    });
    var isFooterRender = VueCompositionAPI.computed(function () {
      return showFooter.value || showActions.value && isPoster2.value;
    });
    return {
      isHeaderRender: isHeaderRender,
      isFooterRender: isFooterRender,
      isPoster2: isPoster2,
      showLoading: showLoading,
      showHeader: showHeader,
      showTitle: showTitle,
      showSubtitle: showSubtitle,
      showDescription: showDescription,
      showAvatar: showAvatar,
      showActions: showActions,
      showStatus: showStatus,
      showContent: showContent,
      showCover: showCover,
      showFooter: showFooter,
      baseCls: baseCls,
      bodyCls: bodyCls,
      footerCls: footerCls,
      footerWrapperCls: footerWrapperCls,
      coverCls: coverCls,
      actionsCls: actionsCls,
      headerCls: headerCls,
      headerWrapperCls: headerWrapperCls,
      headerAvatarCls: headerAvatarCls,
      headerTitleCls: headerTitleCls,
      headerSubTitleCls: headerSubTitleCls,
      headerDescriptionCls: headerDescriptionCls,
      COMPONENT_NAME: COMPONENT_NAME
    };
  },
  methods: {
    renderLoading: function renderLoading() {},
    renderCover: function renderCover() {
      var h = this.$createElement;
      var textCover = typeof this.cover === "string";
      return h("div", {
        "class": this.coverCls
      }, [textCover ? h("img", {
        "attrs": {
          "src": this.cover
        }
      }) : utils_renderTnode.renderTNodeJSX(this, "cover")]);
    },
    renderHeader: function renderHeader() {
      var h = this.$createElement;
      if (this.showHeader) return h("div", {
        "class": this.headerCls
      }, [utils_renderTnode.renderTNodeJSX(this, "header")]);
      return h("div", {
        "class": this.headerCls
      }, [h("div", {
        "class": this.headerWrapperCls
      }, [this.showAvatar && h("div", {
        "class": this.headerAvatarCls
      }, [utils_renderTnode.renderTNodeJSX(this, "avatar")]), h("div", [this.showTitle && h("div", {
        "class": this.headerTitleCls
      }, [utils_renderTnode.renderTNodeJSX(this, "title")]), this.showSubtitle && h("div", {
        "class": this.headerSubTitleCls
      }, [utils_renderTnode.renderTNodeJSX(this, "subtitle")]), this.showDescription && h("p", {
        "class": this.headerDescriptionCls
      }, [utils_renderTnode.renderTNodeJSX(this, "description")])])]), this.showActions && !this.isPoster2 && h("div", {
        "class": this.actionsCls
      }, [utils_renderTnode.renderTNodeJSX(this, "actions")]), this.showStatus && h("div", {
        "class": this.actionsCls
      }, [utils_renderTnode.renderTNodeJSX(this, "status")])]);
    }
  },
  render: function render() {
    var h = arguments[0];
    var content = h("div", {
      "class": this.baseCls
    }, [this.isHeaderRender ? this.renderHeader() : null, this.showCover ? this.renderCover() : null, this.showContent && h("div", {
      "class": this.bodyCls
    }, [utils_renderTnode.renderContent(this, "default", "content")]), this.isFooterRender && h("div", {
      "class": this.footerCls
    }, [h("div", {
      "class": this.footerWrapperCls
    }, [utils_renderTnode.renderTNodeJSX(this, "footer")]), this.showActions && this.isPoster2 && h("div", {
      "class": this.actionsCls
    }, [utils_renderTnode.renderTNodeJSX(this, "actions")])])]);
    if (this.loading) {
      return utils_renderTnode.renderTNodeJSX(this, "loading", {
        defaultNode: h("t-loading", helper.helper([{}, {
          "props": this.loadingProps
        }]), [content])
      });
    }
    return content;
  }
});

exports["default"] = _Card;
//# sourceMappingURL=card.js.map
