import { PropType } from '@vue/composition-api';
import { TdColorHandler } from '../../../color-picker/interfaces';
import { Color, type ColorFormat } from '../../utils';
import type { TdSelectInputProps } from '../../../select-input/type';
declare const _default: import("vue").ComponentOptions<import("vue").default, import("@vue/composition-api").ShallowUnwrapRef<{
    formatModel: import("@vue/composition-api").Ref<"HEX" | "HEX8" | "RGB" | "RGBA" | "HSL" | "HSLA" | "HSV" | "HSVA" | "CMYK" | "CSS">;
    baseClassName: import("@vue/composition-api").ComputedRef<string>;
    handleModeChange: (v: ColorFormat) => void;
}> & import("@vue/composition-api").Data, {}, {}, {
    color: {
        type: PropType<Color>;
    };
    handleFormatInputChange: {
        type: PropType<TdColorHandler>;
        default: () => () => void;
    };
    borderless: BooleanConstructor;
    clearable: BooleanConstructor;
    colorModes: {
        type: import("vue").PropType<("monochrome" | "linear-gradient")[]>;
        default: () => ("monochrome" | "linear-gradient")[];
    };
    disabled: {
        type: BooleanConstructor;
        default: any;
    };
    enableAlpha: BooleanConstructor;
    enableMultipleGradient: {
        type: BooleanConstructor;
        default: boolean;
    };
    format: {
        type: import("vue").PropType<"HEX" | "HEX8" | "RGB" | "RGBA" | "HSL" | "HSLA" | "HSV" | "HSVA" | "CMYK" | "CSS">;
        default: "HEX" | "HEX8" | "RGB" | "RGBA" | "HSL" | "HSLA" | "HSV" | "HSVA" | "CMYK" | "CSS";
        validator(val: "HEX" | "HEX8" | "RGB" | "RGBA" | "HSL" | "HSLA" | "HSV" | "HSVA" | "CMYK" | "CSS"): boolean;
    };
    inputProps: {
        type: import("vue").PropType<import("../../../input").InputProps<import("../../../input").InputValue>>;
    };
    popupProps: {
        type: import("vue").PropType<import("../../..").TdPopupProps>;
    };
    recentColors: {
        type: import("vue").PropType<boolean | string[]>;
        default: () => boolean | string[];
    };
    defaultRecentColors: {
        type: import("vue").PropType<boolean | string[]>;
        default: () => boolean | string[];
    };
    selectInputProps: {
        type: import("vue").PropType<TdSelectInputProps>;
    };
    showPrimaryColorPreview: {
        type: BooleanConstructor;
        default: boolean;
    };
    size: {
        type: import("vue").PropType<import("../../..").SizeEnum>;
        default: import("../../..").SizeEnum;
        validator(val: import("../../..").SizeEnum): boolean;
    };
    swatchColors: {
        type: import("vue").PropType<string[]>;
        default: any;
    };
    value: {
        type: StringConstructor;
        default: string;
    };
    defaultValue: {
        type: StringConstructor;
        default: string;
    };
    onChange: import("vue").PropType<(value: string, context: {
        color: import("../../type").ColorObject;
        trigger: import("../../type").ColorPickerChangeTrigger;
    }) => void>;
    onClear: import("vue").PropType<(context: {
        e: MouseEvent;
    }) => void>;
    onPaletteBarChange: import("vue").PropType<(context: {
        color: import("../../type").ColorObject;
    }) => void>;
    onRecentColorsChange: import("vue").PropType<(value: string[]) => void>;
}, import("@vue/composition-api").ExtractPropTypes<{
    color: {
        type: PropType<Color>;
    };
    handleFormatInputChange: {
        type: PropType<TdColorHandler>;
        default: () => () => void;
    };
    borderless: BooleanConstructor;
    clearable: BooleanConstructor;
    colorModes: {
        type: import("vue").PropType<("monochrome" | "linear-gradient")[]>;
        default: () => ("monochrome" | "linear-gradient")[];
    };
    disabled: {
        type: BooleanConstructor;
        default: any;
    };
    enableAlpha: BooleanConstructor;
    enableMultipleGradient: {
        type: BooleanConstructor;
        default: boolean;
    };
    format: {
        type: import("vue").PropType<"HEX" | "HEX8" | "RGB" | "RGBA" | "HSL" | "HSLA" | "HSV" | "HSVA" | "CMYK" | "CSS">;
        default: "HEX" | "HEX8" | "RGB" | "RGBA" | "HSL" | "HSLA" | "HSV" | "HSVA" | "CMYK" | "CSS";
        validator(val: "HEX" | "HEX8" | "RGB" | "RGBA" | "HSL" | "HSLA" | "HSV" | "HSVA" | "CMYK" | "CSS"): boolean;
    };
    inputProps: {
        type: import("vue").PropType<import("../../../input").InputProps<import("../../../input").InputValue>>;
    };
    popupProps: {
        type: import("vue").PropType<import("../../..").TdPopupProps>;
    };
    recentColors: {
        type: import("vue").PropType<boolean | string[]>;
        default: () => boolean | string[];
    };
    defaultRecentColors: {
        type: import("vue").PropType<boolean | string[]>;
        default: () => boolean | string[];
    };
    selectInputProps: {
        type: import("vue").PropType<TdSelectInputProps>;
    };
    showPrimaryColorPreview: {
        type: BooleanConstructor;
        default: boolean;
    };
    size: {
        type: import("vue").PropType<import("../../..").SizeEnum>;
        default: import("../../..").SizeEnum;
        validator(val: import("../../..").SizeEnum): boolean;
    };
    swatchColors: {
        type: import("vue").PropType<string[]>;
        default: any;
    };
    value: {
        type: StringConstructor;
        default: string;
    };
    defaultValue: {
        type: StringConstructor;
        default: string;
    };
    onChange: import("vue").PropType<(value: string, context: {
        color: import("../../type").ColorObject;
        trigger: import("../../type").ColorPickerChangeTrigger;
    }) => void>;
    onClear: import("vue").PropType<(context: {
        e: MouseEvent;
    }) => void>;
    onPaletteBarChange: import("vue").PropType<(context: {
        color: import("../../type").ColorObject;
    }) => void>;
    onRecentColorsChange: import("vue").PropType<(value: string[]) => void>;
}>> & Omit<import("vue").VueConstructor<import("vue").default>, never> & (new (...args: any[]) => import("@vue/composition-api").ComponentRenderProxy<{
    value: string;
    disabled: boolean;
    size: import("../../..").SizeEnum;
    defaultValue: string;
    format: "HEX" | "HEX8" | "RGB" | "RGBA" | "HSL" | "HSLA" | "HSV" | "HSVA" | "CMYK" | "CSS";
    borderless: boolean;
    clearable: boolean;
    colorModes: ("monochrome" | "linear-gradient")[];
    recentColors: boolean | string[];
    defaultRecentColors: boolean | string[];
    swatchColors: string[];
    enableAlpha: boolean;
    enableMultipleGradient: boolean;
    showPrimaryColorPreview: boolean;
    handleFormatInputChange: TdColorHandler;
} & {
    color?: Color;
    onChange?: (value: string, context: {
        color: import("../../type").ColorObject;
        trigger: import("../../type").ColorPickerChangeTrigger;
    }) => void;
    onClear?: (context: {
        e: MouseEvent;
    }) => void;
    inputProps?: unknown;
    popupProps?: unknown;
    selectInputProps?: unknown;
    onPaletteBarChange?: (context: {
        color: import("../../type").ColorObject;
    }) => void;
    onRecentColorsChange?: (value: string[]) => void;
}, import("@vue/composition-api").ShallowUnwrapRef<{
    formatModel: import("@vue/composition-api").Ref<"HEX" | "HEX8" | "RGB" | "RGBA" | "HSL" | "HSLA" | "HSV" | "HSVA" | "CMYK" | "CSS">;
    baseClassName: import("@vue/composition-api").ComputedRef<string>;
    handleModeChange: (v: ColorFormat) => void;
}>, import("@vue/composition-api").Data, {}, {}, {}, {}, {}, {
    value: string;
    disabled: boolean;
    size: import("../../..").SizeEnum;
    defaultValue: string;
    format: "HEX" | "HEX8" | "RGB" | "RGBA" | "HSL" | "HSLA" | "HSV" | "HSVA" | "CMYK" | "CSS";
    borderless: boolean;
    clearable: boolean;
    colorModes: ("monochrome" | "linear-gradient")[];
    recentColors: boolean | string[];
    defaultRecentColors: boolean | string[];
    swatchColors: string[];
    enableAlpha: boolean;
    enableMultipleGradient: boolean;
    showPrimaryColorPreview: boolean;
    handleFormatInputChange: TdColorHandler;
} & {
    color?: Color;
    onChange?: (value: string, context: {
        color: import("../../type").ColorObject;
        trigger: import("../../type").ColorPickerChangeTrigger;
    }) => void;
    onClear?: (context: {
        e: MouseEvent;
    }) => void;
    inputProps?: unknown;
    popupProps?: unknown;
    selectInputProps?: unknown;
    onPaletteBarChange?: (context: {
        color: import("../../type").ColorObject;
    }) => void;
    onRecentColorsChange?: (value: string[]) => void;
}, {
    value: string;
    disabled: boolean;
    size: import("../../..").SizeEnum;
    defaultValue: string;
    format: "HEX" | "HEX8" | "RGB" | "RGBA" | "HSL" | "HSLA" | "HSV" | "HSVA" | "CMYK" | "CSS";
    borderless: boolean;
    clearable: boolean;
    colorModes: ("monochrome" | "linear-gradient")[];
    recentColors: boolean | string[];
    defaultRecentColors: boolean | string[];
    swatchColors: string[];
    enableAlpha: boolean;
    enableMultipleGradient: boolean;
    showPrimaryColorPreview: boolean;
    handleFormatInputChange: TdColorHandler;
}, true>);
export default _default;
