/**
 * tdesign v1.12.0
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var _defineProperty = require('@babel/runtime/helpers/defineProperty');
var VueCompositionAPI = require('@vue/composition-api');
var colorPicker_props = require('../../props.js');
var select_index = require('../../../select/index.js');
var input_index = require('../../../input/index.js');
var colorPicker_panel_format_inputs = require('./inputs.js');
var colorPicker_hooks = require('../../hooks.js');
var _common_js_colorPicker_format = require('../../../_common/js/color-picker/format.js');
require('../../../select/select.js');
require('@babel/runtime/helpers/objectWithoutProperties');
require('@babel/runtime/helpers/toConsumableArray');
require('@babel/runtime/helpers/typeof');
require('@babel/runtime/helpers/slicedToArray');
require('../../../hooks/useDefaultValue.js');
require('../../../hooks/useVModel.js');
require('../../../_chunks/dep-b08014cb.js');
require('../../../_chunks/dep-2f0c3d6d.js');
require('../../../_chunks/dep-f8b182e9.js');
require('../../../_chunks/dep-31fa06d0.js');
require('../../../_chunks/dep-36c57efe.js');
require('../../../_chunks/dep-0f4ac92d.js');
require('../../../_chunks/dep-f4d07ab0.js');
require('../../../hooks/tnode.js');
require('../../../hooks/render-tnode.js');
require('../../../_chunks/dep-ba816077.js');
require('../../../_chunks/dep-2e662da4.js');
require('../../../_chunks/dep-f0f28315.js');
require('../../../_chunks/dep-7ed5d19e.js');
require('../../../_chunks/dep-2f28fbd7.js');
require('../../../_chunks/dep-76d8c62c.js');
require('../../../_chunks/dep-1c1cc34f.js');
require('../../../_chunks/dep-1974f455.js');
require('../../../_chunks/dep-b520fc3a.js');
require('../../../_chunks/dep-23d55f82.js');
require('../../../_chunks/dep-bc3ec918.js');
require('../../../_chunks/dep-f97b0058.js');
require('../../../_chunks/dep-89b9f4de.js');
require('../../../_chunks/dep-f2e07584.js');
require('../../../_chunks/dep-c9d43e30.js');
require('../../../config-provider/useConfig.js');
require('../../../_chunks/dep-65c8d021.js');
require('../../../_common/js/global-config/default-config.js');
require('../../../_common/js/global-config/locale/zh_CN.js');
require('../../../_chunks/dep-bc99824f.js');
require('../../../_chunks/dep-4effc6c4.js');
require('dayjs');
require('../../../_chunks/dep-d59c4646.js');
require('../../../_chunks/dep-11382958.js');
require('../../../_chunks/dep-c272f99f.js');
require('../../../_chunks/dep-852fc6a9.js');
require('../../../_chunks/dep-9a119db9.js');
require('../../../_chunks/dep-49887b48.js');
require('../../../_chunks/dep-06c569d8.js');
require('../../../_chunks/dep-4d554a6f.js');
require('../../../_chunks/dep-7ec0f498.js');
require('../../../_chunks/dep-fcdc23bb.js');
require('../../../_chunks/dep-59f3051f.js');
require('../../../_chunks/dep-b86e0f9e.js');
require('../../../select/props.js');
require('../../../loading/index.js');
require('../../../loading/directive.js');
require('../../../loading/plugin.js');
require('vue');
require('../../../loading/loading.js');
require('../../../loading/icon/gradient.js');
require('../../../_common/js/loading/circle-adapter.js');
require('../../../_common/js/utils/setStyle.js');
require('../../../_common/js/utils/helper.js');
require('../../../_chunks/dep-caea5f4e.js');
require('../../../_chunks/dep-1fe4c69b.js');
require('../../../_chunks/dep-260a7245.js');
require('../../../config-provider/config-receiver.js');
require('../../../utils/mixins.js');
require('../../../utils/dom.js');
require('raf');
require('../../../utils/easing.js');
require('../../../utils/render-tnode.js');
require('@babel/runtime/helpers/readOnlyError');
require('../../../utils/transfer-dom.js');
require('../../../loading/props.js');
require('../../../config.js');
require('../../../_chunks/dep-029c3522.js');
require('../../../_chunks/dep-c63385b6.js');
require('../../../_chunks/dep-ab17e69e.js');
require('../../../_chunks/dep-87dae4a0.js');
require('../../../_chunks/dep-07989e63.js');
require('../../../_chunks/dep-d3e77112.js');
require('../../../_chunks/dep-9a183e68.js');
require('../../../_chunks/dep-5c93d051.js');
require('../../../_chunks/dep-76dea031.js');
require('../../../_chunks/dep-56240b5e.js');
require('../../../_chunks/dep-81ddbae0.js');
require('../../../utils/withInstall.js');
require('../../../popup/index.js');
require('../../../popup/popup.js');
require('@popperjs/core');
require('../../../utils/helper.js');
require('../../../popup/props.js');
require('../../../popup/container.js');
require('../../../utils/event.js');
require('../../../popup/utils.js');
require('../../../_chunks/dep-e9318595.js');
require('../../../_chunks/dep-50b0a969.js');
require('../../../utils/map-props.js');
require('../../../popup/plugin.js');
require('../../../_common/js/log/log.js');
require('../../../tag/index.js');
require('../../../tag/tag.js');
require('tdesign-icons-vue');
require('tinycolor2');
require('../../../tag/props.js');
require('../../../tag/check-tag.js');
require('../../../_chunks/dep-27ac0b8c.js');
require('../../../tag/check-tag-props.js');
require('../../../hooks/useConfig.js');
require('../../../_common/js/common.js');
require('../../../tag/check-tag-group.js');
require('../../../tag/check-tag-group-props.js');
require('../../../select-input/index.js');
require('../../../select-input/select-input.js');
require('../../../select-input/props.js');
require('../../../select-input/useSingle.js');
require('../../../_chunks/dep-9a8d9286.js');
require('../../../_chunks/dep-27d04ffe.js');
require('../../../_chunks/dep-bd4b64b6.js');
require('../../../input/input.js');
require('../../../input/props.js');
require('../../../input/input-group.js');
require('../../../select-input/useMultiple.js');
require('../../../tag-input/index.js');
require('../../../tag-input/tag-input.js');
require('../../../tag-input/props.js');
require('../../../tag-input/hooks/useTagScroll.js');
require('../../../tag-input/useTagList.js');
require('../../../tag-input/hooks/useHover.js');
require('../../../tag-input/hooks/useDragSorter.js');
require('../../../hooks/useGlobalIcon.js');
require('../../../select-input/useOverlayInnerStyle.js');
require('../../../common-components/fake-arrow.js');
require('../../../select/option.js');
require('../../../utils/ripple.js');
require('../../../select/option-props.js');
require('../../../checkbox/index.js');
require('../../../checkbox/group.js');
require('../../../checkbox/checkbox.js');
require('../../../checkbox/props.js');
require('../../../checkbox/constants.js');
require('../../../checkbox/store.js');
require('@babel/runtime/helpers/classCallCheck');
require('@babel/runtime/helpers/createClass');
require('../../../checkbox/hooks/useKeyboardEvent.js');
require('../../../hooks/useFormDisabled.js');
require('../../../hooks/useElementLazyRender.js');
require('../../../_common/js/utils/observe.js');
require('../../../checkbox/checkbox-group-props.js');
require('../../../_chunks/dep-49944b19.js');
require('../../../_chunks/dep-195eea38.js');
require('../../../hooks/slots.js');
require('../../../hooks/useLazyLoad.js');
require('../../../select/util.js');
require('../../../_chunks/dep-bdfb7a98.js');
require('../../../_chunks/dep-b5cedeaa.js');
require('../../../hooks/useCommonClassName.js');
require('../../../select/select-panel.js');
require('../../../select/optionGroup.js');
require('../../../select/option-group-props.js');
require('../../../hooks/useVirtualScroll.js');
require('../../../select/hooks/useSelectOptions.js');
require('../../../_chunks/dep-11856238.js');
require('../../../_chunks/dep-0982adb4.js');
require('../../../input-number/index.js');
require('../../../input-number/input-number.js');
require('../../../button/index.js');
require('../../../button/button.js');
require('../../../button/props.js');
require('../../../input-number/props.js');
require('../../../input-number/useInputNumber.js');
require('../../../_common/js/input-number/number.js');
require('../../../_common/js/input-number/large-number.js');
require('../../../_chunks/dep-b286149a.js');
require('../../../_common/js/color-picker/color.js');
require('../../../_common/js/color-picker/cmyk.js');
require('../../../_common/js/color-picker/constants.js');
require('../../../_common/js/color-picker/gradient.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var _defineProperty__default = /*#__PURE__*/_interopDefaultLegacy(_defineProperty);

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty__default["default"](e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var FormatPanel = VueCompositionAPI.defineComponent({
  name: "FormatPanel",
  components: {
    TSelect: select_index.Select,
    TInput: input_index.Input,
    TOption: select_index.Option,
    FormatInputs: colorPicker_panel_format_inputs["default"]
  },
  inheritAttrs: false,
  props: _objectSpread(_objectSpread({}, colorPicker_props["default"]), {}, {
    color: {
      type: Object
    },
    handleFormatInputChange: {
      type: Function,
      "default": function _default() {
        return function () {};
      }
    }
  }),
  setup: function setup(props2) {
    var baseClassName = colorPicker_hooks.useBaseClassName();
    var formatModel = VueCompositionAPI.ref(props2.format);
    VueCompositionAPI.watch(function () {
      return [props2.format];
    }, function () {
      return formatModel.value = props2.format;
    });
    var handleModeChange = function handleModeChange(v) {
      formatModel.value = v;
    };
    return {
      formatModel: formatModel,
      baseClassName: baseClassName,
      handleModeChange: handleModeChange
    };
  },
  render: function render(h) {
    var _this = this;
    var baseClassName = this.baseClassName,
      handleModeChange = this.handleModeChange;
    var newProps = _objectSpread(_objectSpread({}, this.$props), {}, {
      format: this.formatModel
    });
    var selectInputProps = _objectSpread({}, this.selectInputProps || {});
    return h("div", {
      "class": "".concat(baseClassName, "__format")
    }, [h("div", {
      "class": "".concat(baseClassName, "__format--item")
    }, [h("t-select", {
      "attrs": {
        "size": "small",
        "selectInputProps": _objectSpread({}, selectInputProps),
        "popupProps": _objectSpread({
          overlayClassName: "".concat(baseClassName, "__select-options")
        }, selectInputProps.popupProps),
        "disabled": this.disabled
      },
      "class": "".concat(baseClassName, "__format-mode-select"),
      "on": {
        "change": handleModeChange
      },
      "model": {
        value: _this.formatModel,
        callback: function callback($$v) {
          _this.formatModel = $$v;
        }
      }
    }, [_common_js_colorPicker_format.getColorFormatOptions(this.enableAlpha).map(function (item) {
      return h("t-option", {
        "key": item,
        "attrs": {
          "value": item,
          "label": item
        },
        "style": {
          fontSize: "12px"
        }
      });
    })])]), h("div", {
      "class": "".concat(baseClassName, "__format--item")
    }, [h("format-inputs", {
      props: newProps
    })])]);
  }
});

exports["default"] = FormatPanel;
//# sourceMappingURL=index.js.map
