import { TdColorPickerProps } from './type';
import { PropType } from 'vue';
declare const _default: {
    borderless: BooleanConstructor;
    clearable: BooleanConstructor;
    colorModes: {
        type: PropType<("monochrome" | "linear-gradient")[]>;
        default: () => TdColorPickerProps['colorModes'];
    };
    disabled: {
        type: BooleanConstructor;
        default: any;
    };
    enableAlpha: BooleanConstructor;
    enableMultipleGradient: {
        type: BooleanConstructor;
        default: boolean;
    };
    format: {
        type: PropType<"HEX" | "HEX8" | "RGB" | "RGBA" | "HSL" | "HSLA" | "HSV" | "HSVA" | "CMYK" | "CSS">;
        default: "HEX" | "HEX8" | "RGB" | "RGBA" | "HSL" | "HSLA" | "HSV" | "HSVA" | "CMYK" | "CSS";
        validator(val: TdColorPickerProps['format']): boolean;
    };
    inputProps: {
        type: PropType<import("..").InputProps<import("..").InputValue>>;
    };
    popupProps: {
        type: PropType<import("..").TdPopupProps>;
    };
    recentColors: {
        type: PropType<boolean | string[]>;
        default: () => TdColorPickerProps['recentColors'];
    };
    defaultRecentColors: {
        type: PropType<boolean | string[]>;
        default: () => TdColorPickerProps['defaultRecentColors'];
    };
    selectInputProps: {
        type: PropType<import("..").TdSelectInputProps>;
    };
    showPrimaryColorPreview: {
        type: BooleanConstructor;
        default: boolean;
    };
    size: {
        type: PropType<import("..").SizeEnum>;
        default: import("..").SizeEnum;
        validator(val: TdColorPickerProps['size']): boolean;
    };
    swatchColors: {
        type: PropType<string[]>;
        default: any;
    };
    value: {
        type: StringConstructor;
        default: string;
    };
    defaultValue: {
        type: StringConstructor;
        default: string;
    };
    onChange: PropType<(value: string, context: {
        color: import("./type").ColorObject;
        trigger: import("./type").ColorPickerChangeTrigger;
    }) => void>;
    onClear: PropType<(context: {
        e: MouseEvent;
    }) => void>;
    onPaletteBarChange: PropType<(context: {
        color: import("./type").ColorObject;
    }) => void>;
    onRecentColorsChange: PropType<(value: string[]) => void>;
};
export default _default;
