/**
 * tdesign v1.12.0
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var dayjs = require('dayjs');
var _common_js_datePicker_utils = require('../../_common/js/date-picker/utils.js');
var isObject = require('../../_chunks/dep-ba816077.js');
require('@babel/runtime/helpers/slicedToArray');
require('@babel/runtime/helpers/objectDestructuringEmpty');
require('@babel/runtime/helpers/extends');
require('@babel/runtime/helpers/defineProperty');
require('../../_chunks/dep-4effc6c4.js');
require('../../_chunks/dep-423cb508.js');
require('../../_common/js/date-picker/format.js');
require('../../_common/js/log/log.js');
require('../../_chunks/dep-2e662da4.js');
require('../../_chunks/dep-31fa06d0.js');
require('@babel/runtime/helpers/typeof');
require('../../_chunks/dep-36c57efe.js');
require('../../_chunks/dep-f4d07ab0.js');
require('../../_chunks/dep-1c1cc34f.js');
require('../../_chunks/dep-76d8c62c.js');
require('../../_chunks/dep-b86e0f9e.js');
require('../../_chunks/dep-852fc6a9.js');
require('../../_chunks/dep-bc3ec918.js');
require('../../_chunks/dep-9a119db9.js');
require('../../_chunks/dep-2ab94c6c.js');
require('../../_chunks/dep-50b0a969.js');
require('../../_chunks/dep-0f4ac92d.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var dayjs__default = /*#__PURE__*/_interopDefaultLegacy(dayjs);

function useDisableDate(props) {
  var _disableDate = props.disableDate,
    format = props.format,
    mode = props.mode,
    start = props.start,
    end = props.end;
  return {
    disableDate: function disableDate(value) {
      return !_common_js_datePicker_utils.isEnabledDate({
        disableDate: _disableDate,
        format: format,
        mode: mode,
        value: value
      });
    },
    minDate: isObject.isObject(_disableDate) && "before" in _disableDate ? new Date(dayjs__default["default"](_disableDate.before).startOf("day").format()) : start,
    maxDate: isObject.isObject(_disableDate) && "after" in _disableDate ? new Date(dayjs__default["default"](_disableDate.after).endOf("day").format()) : end
  };
}

exports["default"] = useDisableDate;
//# sourceMappingURL=useDisableDate.js.map
