/**
 * tdesign v1.12.0
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var _defineProperty = require('@babel/runtime/helpers/defineProperty');
var VueCompositionAPI = require('@vue/composition-api');
var dayjs = require('dayjs');
var hooks_useConfig = require('../../hooks/useConfig.js');
var _common_js_datePicker_format = require('../../_common/js/date-picker/format.js');
var datePicker_hooks_useSingleValue = require('./useSingleValue.js');
var omit = require('../../_chunks/dep-11856238.js');
require('../../config-provider/useConfig.js');
require('../../_chunks/dep-65c8d021.js');
require('../../_common/js/global-config/default-config.js');
require('../../_common/js/global-config/locale/zh_CN.js');
require('../../_chunks/dep-bc99824f.js');
require('@babel/runtime/helpers/typeof');
require('../../_chunks/dep-4effc6c4.js');
require('../../_chunks/dep-d59c4646.js');
require('../../_chunks/dep-11382958.js');
require('../../_chunks/dep-c272f99f.js');
require('../../_chunks/dep-89b9f4de.js');
require('../../_chunks/dep-1c1cc34f.js');
require('../../_chunks/dep-31fa06d0.js');
require('../../_chunks/dep-ba816077.js');
require('../../_chunks/dep-852fc6a9.js');
require('../../_chunks/dep-c9d43e30.js');
require('../../_chunks/dep-f4d07ab0.js');
require('../../_chunks/dep-36c57efe.js');
require('../../_chunks/dep-23d55f82.js');
require('../../_chunks/dep-bc3ec918.js');
require('../../_chunks/dep-f97b0058.js');
require('../../_chunks/dep-9a119db9.js');
require('../../_chunks/dep-49887b48.js');
require('../../_chunks/dep-06c569d8.js');
require('../../_chunks/dep-4d554a6f.js');
require('../../_chunks/dep-7ec0f498.js');
require('../../_chunks/dep-fcdc23bb.js');
require('../../_chunks/dep-59f3051f.js');
require('../../_chunks/dep-b86e0f9e.js');
require('../../_common/js/log/log.js');
require('../../_chunks/dep-2e662da4.js');
require('@babel/runtime/helpers/slicedToArray');
require('../../hooks/useVModel.js');
require('../../_chunks/dep-b08014cb.js');
require('../../_chunks/dep-2f0c3d6d.js');
require('../../_chunks/dep-f8b182e9.js');
require('../../_chunks/dep-0f4ac92d.js');
require('../../_chunks/dep-b5cedeaa.js');
require('../../_chunks/dep-07989e63.js');
require('../../_chunks/dep-d3e77112.js');
require('../../_chunks/dep-b520fc3a.js');
require('../../_chunks/dep-f2e07584.js');
require('../../_chunks/dep-76dea031.js');
require('../../_chunks/dep-0982adb4.js');
require('../../_chunks/dep-76d8c62c.js');
require('../../_chunks/dep-bd4b64b6.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var _defineProperty__default = /*#__PURE__*/_interopDefaultLegacy(_defineProperty);
var dayjs__default = /*#__PURE__*/_interopDefaultLegacy(dayjs);

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty__default["default"](e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function useSingle(props, _ref) {
  var emit = _ref.emit;
  var COMPONENT_NAME = hooks_useConfig.usePrefixClass("date-picker");
  var inputRef = VueCompositionAPI.ref();
  var _useSingleValue = datePicker_hooks_useSingleValue["default"](props),
    value = _useSingleValue.value,
    onChange = _useSingleValue.onChange,
    time = _useSingleValue.time,
    month = _useSingleValue.month,
    year = _useSingleValue.year,
    cacheValue = _useSingleValue.cacheValue;
  var formatRef = VueCompositionAPI.computed(function () {
    return _common_js_datePicker_format.getDefaultFormat({
      mode: props.mode,
      format: props.format,
      valueType: props.valueType,
      enableTimePicker: props.multiple ? false : props.enableTimePicker
    });
  });
  var popupVisible = VueCompositionAPI.ref(false);
  var isHoverCell = VueCompositionAPI.ref(false);
  var inputValue = VueCompositionAPI.ref(_common_js_datePicker_format.formatDate(value.value, {
    format: formatRef.value.format
  }));
  var inputProps = VueCompositionAPI.computed(function () {
    var inputProps2 = _objectSpread(_objectSpread({}, props.inputProps), {}, {
      ref: inputRef,
      borderless: props.borderless,
      size: props.size,
      prefixIcon: props.prefixIcon,
      "class": [_defineProperty__default["default"]({}, "".concat(COMPONENT_NAME.value, "__input--placeholder"), isHoverCell.value)],
      onClear: function onClear(context) {
        var _context$e;
        context === null || context === void 0 || (_context$e = context.e) === null || _context$e === void 0 || _context$e.stopPropagation();
        popupVisible.value = false;
        onChange === null || onChange === void 0 || onChange("", {
          dayjsValue: dayjs__default["default"](),
          trigger: "clear"
        });
        emit("clear", "", {
          dayjsValue: dayjs__default["default"](),
          trigger: "clear"
        });
      },
      onBlur: function onBlur(val, context) {
        var _props$onBlur;
        (_props$onBlur = props.onBlur) === null || _props$onBlur === void 0 || _props$onBlur.call(props, {
          value: val,
          e: context.e
        });
        emit("blur", {
          value: val,
          e: context.e
        });
      },
      onFocus: function onFocus(_, _ref3) {
        var _props$onFocus;
        var e = _ref3.e;
        (_props$onFocus = props.onFocus) === null || _props$onFocus === void 0 || _props$onFocus.call(props, {
          value: value.value,
          e: e
        });
        emit("focus", {
          value: value.value,
          e: e
        });
      },
      onChange: function onChange(val) {
        inputValue.value = val;
        if (!_common_js_datePicker_format.isValidDate(val, formatRef.value.format)) return;
        cacheValue.value = val;
        var newMonth = _common_js_datePicker_format.parseToDayjs(val, formatRef.value.format).month();
        var newYear = _common_js_datePicker_format.parseToDayjs(val, formatRef.value.format).year();
        var newTime = _common_js_datePicker_format.formatTime(val, formatRef.value.format, formatRef.value.timeFormat, props.defaultTime);
        !Number.isNaN(newYear) && (year.value = newYear);
        !Number.isNaN(newMonth) && (month.value = newMonth);
        !Number.isNaN(newTime) && (time.value = newTime);
      },
      onEnter: function onEnter(val) {
        if (!val) {
          onChange === null || onChange === void 0 || onChange("", {
            dayjsValue: dayjs__default["default"](),
            trigger: "enter"
          });
          popupVisible.value = false;
          return;
        }
        if (!_common_js_datePicker_format.isValidDate(val, formatRef.value.format) && !_common_js_datePicker_format.isValidDate(value.value, formatRef.value.format)) return;
        popupVisible.value = false;
        if (_common_js_datePicker_format.isValidDate(val, formatRef.value.format)) {
          onChange === null || onChange === void 0 || onChange(_common_js_datePicker_format.formatDate(val, {
            format: formatRef.value.format,
            targetFormat: formatRef.value.valueType
          }), {
            dayjsValue: _common_js_datePicker_format.parseToDayjs(val, formatRef.value.format),
            trigger: "enter"
          });
        } else if (_common_js_datePicker_format.isValidDate(value.value, formatRef.value.format)) {
          inputValue.value = _common_js_datePicker_format.formatDate(value.value, {
            format: formatRef.value.format
          });
        } else {
          inputValue.value = "";
        }
      }
    });
    return props.multiple ? _objectSpread({}, omit.omit(inputProps2, ["ref", "class"])) : inputProps2;
  });
  var popupProps = VueCompositionAPI.computed(function () {
    var _props$popupProps$ove, _props$popupProps, _props$popupProps2;
    return _objectSpread(_objectSpread({
      expandAnimation: true
    }, props.popupProps), {}, {
      trigger: "click",
      overlayInnerStyle: (_props$popupProps$ove = (_props$popupProps = props.popupProps) === null || _props$popupProps === void 0 ? void 0 : _props$popupProps.overlayInnerStyle) !== null && _props$popupProps$ove !== void 0 ? _props$popupProps$ove : {
        width: "auto"
      },
      overlayClassName: [(_props$popupProps2 = props.popupProps) === null || _props$popupProps2 === void 0 ? void 0 : _props$popupProps2.overlayClassName, "".concat(COMPONENT_NAME.value, "__panel-container")],
      onVisibleChange: function onVisibleChange(visible, context) {
        var _props$popupProps3, _props$popupProps3$on;
        (_props$popupProps3 = props.popupProps) === null || _props$popupProps3 === void 0 || (_props$popupProps3$on = _props$popupProps3.onVisibleChange) === null || _props$popupProps3$on === void 0 || _props$popupProps3$on.call(_props$popupProps3, visible, context);
        if (context.trigger === "trigger-element-click") {
          popupVisible.value = true;
          return;
        }
        popupVisible.value = visible;
      }
    });
  });
  VueCompositionAPI.watch(value, function (value2) {
    if (!value2) {
      inputValue.value = "";
      return;
    }
    if (!_common_js_datePicker_format.isValidDate(value2, formatRef.value.format)) return;
    inputValue.value = _common_js_datePicker_format.formatDate(value2, {
      format: formatRef.value.format
    });
  }, {
    immediate: true
  });
  return {
    year: year,
    month: month,
    value: value,
    time: time,
    inputValue: inputValue,
    popupVisible: popupVisible,
    inputProps: inputProps,
    popupProps: popupProps,
    inputRef: inputRef,
    cacheValue: cacheValue,
    isHoverCell: isHoverCell,
    onChange: onChange
  };
}

exports["default"] = useSingle;
//# sourceMappingURL=useSingle.js.map
