/**
 * tdesign v1.12.0
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var _defineProperty = require('@babel/runtime/helpers/defineProperty');
var _slicedToArray = require('@babel/runtime/helpers/slicedToArray');
var VueCompositionAPI = require('@vue/composition-api');
var hooks_useConfig = require('../../hooks/useConfig.js');
var datePicker_panel_PanelContent = require('./PanelContent.js');
var datePicker_panel_ExtraContent = require('./ExtraContent.js');
var _common_js_datePicker_format = require('../../_common/js/date-picker/format.js');
var datePicker_hooks_useTableData = require('../hooks/useTableData.js');
var datePicker_hooks_useDisableDate = require('../hooks/useDisableDate.js');
var datePicker_utils = require('../utils.js');
var configProvider_useConfig = require('../../config-provider/useConfig.js');
var isFunction = require('../../_chunks/dep-1c1cc34f.js');
require('../../_chunks/dep-65c8d021.js');
require('../../_common/js/global-config/default-config.js');
require('../../_common/js/global-config/locale/zh_CN.js');
require('../../_chunks/dep-bc99824f.js');
require('@babel/runtime/helpers/typeof');
require('../../_chunks/dep-4effc6c4.js');
require('dayjs');
require('../../_chunks/dep-d59c4646.js');
require('../../_chunks/dep-11382958.js');
require('../../_chunks/dep-c272f99f.js');
require('../../_chunks/dep-89b9f4de.js');
require('../../_chunks/dep-31fa06d0.js');
require('../../_chunks/dep-ba816077.js');
require('../../_chunks/dep-852fc6a9.js');
require('../../_chunks/dep-c9d43e30.js');
require('../../_chunks/dep-f4d07ab0.js');
require('../../_chunks/dep-36c57efe.js');
require('../../_chunks/dep-23d55f82.js');
require('../../_chunks/dep-bc3ec918.js');
require('../../_chunks/dep-f97b0058.js');
require('../../_chunks/dep-9a119db9.js');
require('../../_chunks/dep-49887b48.js');
require('../../_chunks/dep-06c569d8.js');
require('../../_chunks/dep-4d554a6f.js');
require('../../_chunks/dep-7ec0f498.js');
require('../../_chunks/dep-fcdc23bb.js');
require('../../_chunks/dep-59f3051f.js');
require('../../_chunks/dep-b86e0f9e.js');
require('../../_chunks/dep-27ac0b8c.js');
require('../base/Header.js');
require('@babel/runtime/helpers/toConsumableArray');
require('../../pagination/index.js');
require('../../pagination/pagination.js');
require('tdesign-icons-vue');
require('../../utils/mixins.js');
require('vue');
require('../../config-provider/config-receiver.js');
require('../../input-number/index.js');
require('../../input-number/input-number.js');
require('../../button/index.js');
require('../../button/button.js');
require('../../loading/index.js');
require('../../loading/directive.js');
require('../../loading/plugin.js');
require('../../loading/loading.js');
require('../../loading/icon/gradient.js');
require('../../_common/js/loading/circle-adapter.js');
require('../../_common/js/utils/setStyle.js');
require('../../_common/js/utils/helper.js');
require('@babel/runtime/helpers/objectWithoutProperties');
require('../../_chunks/dep-caea5f4e.js');
require('../../_chunks/dep-1fe4c69b.js');
require('../../_chunks/dep-2e662da4.js');
require('../../_chunks/dep-260a7245.js');
require('../../utils/dom.js');
require('raf');
require('../../utils/easing.js');
require('../../utils/render-tnode.js');
require('@babel/runtime/helpers/readOnlyError');
require('../../_chunks/dep-f0f28315.js');
require('../../_chunks/dep-7ed5d19e.js');
require('../../_chunks/dep-f8b182e9.js');
require('../../_chunks/dep-0f4ac92d.js');
require('../../_chunks/dep-2f28fbd7.js');
require('../../_chunks/dep-76d8c62c.js');
require('../../_chunks/dep-2f0c3d6d.js');
require('../../_chunks/dep-b08014cb.js');
require('../../utils/transfer-dom.js');
require('../../loading/props.js');
require('../../config.js');
require('../../_chunks/dep-029c3522.js');
require('../../_chunks/dep-c63385b6.js');
require('../../_chunks/dep-ab17e69e.js');
require('../../_chunks/dep-87dae4a0.js');
require('../../_chunks/dep-07989e63.js');
require('../../_chunks/dep-d3e77112.js');
require('../../_chunks/dep-b520fc3a.js');
require('../../_chunks/dep-f2e07584.js');
require('../../_chunks/dep-9a183e68.js');
require('../../_chunks/dep-5c93d051.js');
require('../../_chunks/dep-76dea031.js');
require('../../_chunks/dep-56240b5e.js');
require('../../_chunks/dep-81ddbae0.js');
require('../../utils/withInstall.js');
require('../../button/props.js');
require('../../utils/ripple.js');
require('../../input/index.js');
require('../../input/input.js');
require('../../utils/helper.js');
require('../../utils/event.js');
require('../../input/props.js');
require('../../_common/js/log/log.js');
require('../../input/input-group.js');
require('../../utils/map-props.js');
require('../../input-number/props.js');
require('../../input-number/useInputNumber.js');
require('../../hooks/useCommonClassName.js');
require('../../hooks/useVModel.js');
require('../../_common/js/input-number/number.js');
require('../../_common/js/input-number/large-number.js');
require('../../hooks/useFormDisabled.js');
require('../../hooks/useGlobalIcon.js');
require('../../select/index.js');
require('../../select/select.js');
require('../../hooks/useDefaultValue.js');
require('../../hooks/tnode.js');
require('../../hooks/render-tnode.js');
require('../../_chunks/dep-1974f455.js');
require('../../select/props.js');
require('../../popup/index.js');
require('../../popup/popup.js');
require('@popperjs/core');
require('../../popup/props.js');
require('../../popup/container.js');
require('../../popup/utils.js');
require('../../_chunks/dep-e9318595.js');
require('../../_chunks/dep-50b0a969.js');
require('../../popup/plugin.js');
require('../../tag/index.js');
require('../../tag/tag.js');
require('tinycolor2');
require('../../tag/props.js');
require('../../tag/check-tag.js');
require('../../tag/check-tag-props.js');
require('../../_common/js/common.js');
require('../../tag/check-tag-group.js');
require('../../tag/check-tag-group-props.js');
require('../../select-input/index.js');
require('../../select-input/select-input.js');
require('../../select-input/props.js');
require('../../select-input/useSingle.js');
require('../../_chunks/dep-9a8d9286.js');
require('../../_chunks/dep-27d04ffe.js');
require('../../_chunks/dep-bd4b64b6.js');
require('../../select-input/useMultiple.js');
require('../../tag-input/index.js');
require('../../tag-input/tag-input.js');
require('../../tag-input/props.js');
require('../../tag-input/hooks/useTagScroll.js');
require('../../tag-input/useTagList.js');
require('../../tag-input/hooks/useHover.js');
require('../../tag-input/hooks/useDragSorter.js');
require('../../select-input/useOverlayInnerStyle.js');
require('../../common-components/fake-arrow.js');
require('../../select/option.js');
require('../../select/option-props.js');
require('../../checkbox/index.js');
require('../../checkbox/group.js');
require('../../checkbox/checkbox.js');
require('../../checkbox/props.js');
require('../../checkbox/constants.js');
require('../../checkbox/store.js');
require('@babel/runtime/helpers/classCallCheck');
require('@babel/runtime/helpers/createClass');
require('../../checkbox/hooks/useKeyboardEvent.js');
require('../../hooks/useElementLazyRender.js');
require('../../_common/js/utils/observe.js');
require('../../checkbox/checkbox-group-props.js');
require('../../_chunks/dep-49944b19.js');
require('../../_chunks/dep-195eea38.js');
require('../../hooks/slots.js');
require('../../hooks/useLazyLoad.js');
require('../../select/util.js');
require('../../_chunks/dep-bdfb7a98.js');
require('../../_chunks/dep-b5cedeaa.js');
require('../../select/select-panel.js');
require('../../select/optionGroup.js');
require('../../select/option-group-props.js');
require('../../hooks/useVirtualScroll.js');
require('../../select/hooks/useSelectOptions.js');
require('../../_chunks/dep-11856238.js');
require('../../_chunks/dep-0982adb4.js');
require('../../input-adornment/index.js');
require('../../input-adornment/input-adornment.js');
require('../../input-adornment/props.js');
require('../../pagination/props.js');
require('../../pagination/pagination-mini.js');
require('../../pagination/pagination-mini-props.js');
require('../base/Table.js');
require('../base/Cell.js');
require('../../_common/js/date-picker/utils.js');
require('@babel/runtime/helpers/objectDestructuringEmpty');
require('@babel/runtime/helpers/extends');
require('../../_chunks/dep-423cb508.js');
require('../../_chunks/dep-2ab94c6c.js');
require('../../time-picker/panel/time-picker-panel.js');
require('../../_common/js/time-picker/const.js');
require('../../time-picker/panel/props.js');
require('../../time-picker/props.js');
require('../../time-picker/panel/single-panel.js');
require('../../_common/js/time-picker/utils.js');
require('../base/Footer.js');
require('../../_chunks/dep-ebbfcd2e.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var _defineProperty__default = /*#__PURE__*/_interopDefaultLegacy(_defineProperty);
var _slicedToArray__default = /*#__PURE__*/_interopDefaultLegacy(_slicedToArray);

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty__default["default"](e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var TRangePanel = VueCompositionAPI.defineComponent({
  name: "TRangePanel",
  props: {
    hoverValue: Array,
    activeIndex: Number,
    isFirstValueSelected: Boolean,
    disableDate: [Object, Array, Function],
    disableTime: Function,
    mode: {
      type: String,
      "default": "date"
    },
    format: String,
    presetsPlacement: {
      type: String,
      "default": "bottom"
    },
    value: Array,
    timePickerProps: Object,
    presets: Object,
    enableTimePicker: Boolean,
    firstDayOfWeek: Number,
    panelPreselection: Boolean,
    hidePreselection: {
      type: Boolean,
      defaultValue: true
    },
    popupVisible: Boolean,
    year: Array,
    month: Array,
    time: Array,
    cancelRangeSelectLimit: Boolean,
    onClick: Function,
    onCellClick: Function,
    onCellMouseEnter: Function,
    onCellMouseLeave: Function,
    onJumperClick: Function,
    onConfirmClick: Function,
    onPresetClick: Function,
    onYearChange: Function,
    onMonthChange: Function,
    onTimePickerChange: Function
  },
  setup: function setup(props) {
    var COMPONENT_NAME = hooks_useConfig.usePrefixClass("date-range-picker__panel");
    var _useConfig = configProvider_useConfig.useConfig("datePicker"),
      global = _useConfig.global;
    var _getDefaultFormat = _common_js_datePicker_format.getDefaultFormat({
        mode: props.mode,
        format: props.format,
        enableTimePicker: props.enableTimePicker
      }),
      format = _getDefaultFormat.format;
    var hidePreselection = !props.panelPreselection && props.value.length === 2;
    var disableDateOptions = VueCompositionAPI.computed(function () {
      return datePicker_hooks_useDisableDate["default"]({
        format: format,
        mode: props.mode,
        disableDate: props.disableDate,
        start: props.isFirstValueSelected && props.activeIndex === 1 ? new Date(_common_js_datePicker_format.parseToDayjs(props.value[0], format, "start").toDate().setHours(0, 0, 0)) : void 0,
        end: props.isFirstValueSelected && props.activeIndex === 0 ? new Date(_common_js_datePicker_format.parseToDayjs(props.value[1], format).toDate().setHours(23, 59, 59)) : void 0
      });
    });
    var disableTime = function disableTime(h, m, s, context) {
      if (!isFunction.isFunction(props.disableTime)) {
        return {};
      }
      var _ref = props.value || [],
        _ref2 = _slicedToArray__default["default"](_ref, 2),
        startTime = _ref2[0],
        endTime = _ref2[1];
      if (context.partial) {
        return props.disableTime([datePicker_utils.parseToDateTime(startTime, format, [h, m, s]), datePicker_utils.parseToDateTime(endTime, format)], context);
      }
      return props.disableTime([datePicker_utils.parseToDateTime(startTime, format), datePicker_utils.parseToDateTime(endTime, format, [h, m, s])], context);
    };
    var startTableData = VueCompositionAPI.computed(function () {
      return datePicker_hooks_useTableData["default"](_objectSpread(_objectSpread({
        isRange: true,
        start: props.value[0] ? _common_js_datePicker_format.parseToDayjs(props.value[0], format).toDate() : void 0,
        end: props.value[1] ? _common_js_datePicker_format.parseToDayjs(props.value[1], format).toDate() : void 0,
        hoverStart: !hidePreselection && props.hoverValue[0] ? _common_js_datePicker_format.parseToDayjs(props.hoverValue[0], format).toDate() : void 0,
        hoverEnd: !hidePreselection && props.hoverValue[1] ? _common_js_datePicker_format.parseToDayjs(props.hoverValue[1], format).toDate() : void 0,
        year: props.year[0],
        month: props.month[0],
        mode: props.mode,
        firstDayOfWeek: props.firstDayOfWeek || global.value.firstDayOfWeek
      }, disableDateOptions.value), {}, {
        cancelRangeSelectLimit: props.cancelRangeSelectLimit
      }));
    });
    var endTableData = VueCompositionAPI.computed(function () {
      return datePicker_hooks_useTableData["default"](_objectSpread(_objectSpread({
        isRange: true,
        start: props.value[0] ? _common_js_datePicker_format.parseToDayjs(props.value[0], format).toDate() : void 0,
        end: props.value[1] ? _common_js_datePicker_format.parseToDayjs(props.value[1], format).toDate() : void 0,
        hoverStart: !hidePreselection && props.hoverValue[0] ? _common_js_datePicker_format.parseToDayjs(props.hoverValue[0], format).toDate() : void 0,
        hoverEnd: !hidePreselection && props.hoverValue[1] ? _common_js_datePicker_format.parseToDayjs(props.hoverValue[1], format).toDate() : void 0,
        year: props.year[1],
        month: props.month[1],
        mode: props.mode,
        firstDayOfWeek: props.firstDayOfWeek || global.value.firstDayOfWeek
      }, disableDateOptions.value), {}, {
        cancelRangeSelectLimit: props.cancelRangeSelectLimit
      }));
    });
    var panelContentProps = VueCompositionAPI.computed(function () {
      return {
        format: format,
        mode: props.mode,
        firstDayOfWeek: props.firstDayOfWeek || global.value.firstDayOfWeek,
        popupVisible: props.popupVisible,
        enableTimePicker: props.enableTimePicker,
        timePickerProps: _objectSpread({
          disableTime: disableTime
        }, props.timePickerProps),
        onMonthChange: props.onMonthChange,
        onYearChange: props.onYearChange,
        onJumperClick: props.onJumperClick,
        onCellClick: props.onCellClick,
        onCellMouseEnter: props.onCellMouseEnter,
        onCellMouseLeave: props.onCellMouseLeave,
        onTimePickerChange: props.onTimePickerChange
      };
    });
    return {
      COMPONENT_NAME: COMPONENT_NAME,
      startTableData: startTableData,
      endTableData: endTableData,
      panelContentProps: panelContentProps
    };
  },
  render: function render() {
    var _this = this;
    var h = arguments[0];
    var COMPONENT_NAME = this.COMPONENT_NAME,
      startTableData = this.startTableData,
      endTableData = this.endTableData,
      panelContentProps = this.panelContentProps;
    return h("div", {
      "class": [COMPONENT_NAME, _defineProperty__default["default"]({}, "".concat(COMPONENT_NAME, "--direction-row"), ["left", "right"].includes(this.presetsPlacement))],
      "on": {
        "click": function click(e) {
          var _this$onClick;
          return (_this$onClick = _this.onClick) === null || _this$onClick === void 0 ? void 0 : _this$onClick.call(_this, {
            e: e
          });
        }
      }
    }, [["top", "left"].includes(this.presetsPlacement) ? h(datePicker_panel_ExtraContent["default"], {
      "props": _objectSpread({}, {
        presets: this.presets,
        selectedValue: this.value[this.activeIndex],
        enableTimePicker: this.enableTimePicker,
        onPresetClick: this.onPresetClick,
        onConfirmClick: this.onConfirmClick,
        presetsPlacement: this.presetsPlacement
      })
    }) : null, h("div", {
      "class": "".concat(COMPONENT_NAME, "-content-wrapper")
    }, [!this.enableTimePicker ? [h(datePicker_panel_PanelContent["default"], {
      "key": "startPanel",
      "props": _objectSpread({}, _objectSpread({
        partial: "start",
        year: this.year[0],
        month: this.month[0],
        time: this.time[0],
        value: this.value,
        tableData: startTableData
      }, panelContentProps))
    }), h(datePicker_panel_PanelContent["default"], {
      "key": "endPanel",
      "props": _objectSpread({}, _objectSpread({
        partial: "end",
        year: this.year[1],
        month: this.month[1],
        time: this.time[1],
        value: this.value,
        tableData: endTableData
      }, panelContentProps))
    })] : h(datePicker_panel_PanelContent["default"], {
      "key": "start",
      "props": _objectSpread({}, _objectSpread({
        partial: this.activeIndex ? "end" : "start",
        year: this.activeIndex ? this.year[1] : this.year[0],
        month: this.activeIndex ? this.month[1] : this.month[0],
        time: this.activeIndex ? this.time[1] : this.time[0],
        value: this.value,
        tableData: this.activeIndex ? endTableData : startTableData
      }, panelContentProps))
    })]), ["bottom", "right"].includes(this.presetsPlacement) ? h(datePicker_panel_ExtraContent["default"], {
      "props": _objectSpread({}, {
        presets: this.presets,
        selectedValue: this.value[this.activeIndex],
        enableTimePicker: this.enableTimePicker,
        onPresetClick: this.onPresetClick,
        onConfirmClick: this.onConfirmClick,
        presetsPlacement: this.presetsPlacement
      })
    }) : null]);
  }
});

exports["default"] = TRangePanel;
//# sourceMappingURL=RangePanel.js.map
