/**
 * tdesign v1.12.0
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var _defineProperty = require('@babel/runtime/helpers/defineProperty');
var VueCompositionAPI = require('@vue/composition-api');
var hooks_tnode = require('../hooks/tnode.js');
var hooks_useConfig = require('../hooks/useConfig.js');
var descriptions_props = require('./props.js');
var descriptions_const_index = require('./const/index.js');
var descriptions_descriptionsBody = require('./descriptions-body.js');
var descriptions_utils_index = require('./utils/index.js');
var descriptions_interface = require('./interface.js');
var isArray = require('../_chunks/dep-36c57efe.js');
var isNil = require('../_chunks/dep-ebbfcd2e.js');
var hooks_slots = require('../hooks/slots.js');
require('../hooks/render-tnode.js');
require('../_chunks/dep-ba816077.js');
require('@babel/runtime/helpers/typeof');
require('../_chunks/dep-2e662da4.js');
require('../_chunks/dep-31fa06d0.js');
require('../_chunks/dep-f4d07ab0.js');
require('../_chunks/dep-f0f28315.js');
require('../_chunks/dep-7ed5d19e.js');
require('../_chunks/dep-f8b182e9.js');
require('../_chunks/dep-0f4ac92d.js');
require('../_chunks/dep-2f28fbd7.js');
require('../_chunks/dep-76d8c62c.js');
require('../_chunks/dep-2f0c3d6d.js');
require('../_chunks/dep-b08014cb.js');
require('../_chunks/dep-1c1cc34f.js');
require('../_chunks/dep-1974f455.js');
require('../_chunks/dep-b520fc3a.js');
require('../_chunks/dep-23d55f82.js');
require('../_chunks/dep-bc3ec918.js');
require('../_chunks/dep-f97b0058.js');
require('../_chunks/dep-89b9f4de.js');
require('../_chunks/dep-f2e07584.js');
require('../_chunks/dep-c9d43e30.js');
require('../config-provider/useConfig.js');
require('../_chunks/dep-65c8d021.js');
require('../_common/js/global-config/default-config.js');
require('../_common/js/global-config/locale/zh_CN.js');
require('../_chunks/dep-bc99824f.js');
require('../_chunks/dep-4effc6c4.js');
require('dayjs');
require('../_chunks/dep-d59c4646.js');
require('../_chunks/dep-11382958.js');
require('../_chunks/dep-c272f99f.js');
require('../_chunks/dep-852fc6a9.js');
require('../_chunks/dep-9a119db9.js');
require('../_chunks/dep-49887b48.js');
require('../_chunks/dep-06c569d8.js');
require('../_chunks/dep-4d554a6f.js');
require('../_chunks/dep-7ec0f498.js');
require('../_chunks/dep-fcdc23bb.js');
require('../_chunks/dep-59f3051f.js');
require('../_chunks/dep-b86e0f9e.js');
require('../_chunks/dep-27ac0b8c.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var _defineProperty__default = /*#__PURE__*/_interopDefaultLegacy(_defineProperty);

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty__default["default"](e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var _Descriptions = VueCompositionAPI.defineComponent({
  name: "TDescriptions",
  props: descriptions_props["default"],
  setup: function setup(props2) {
    var COMPONENT_NAME = hooks_useConfig.usePrefixClass("descriptions");
    var getChildByName = hooks_slots.useChildComponentSlots();
    var itemsType = VueCompositionAPI.ref(descriptions_interface.ItemsType.props);
    var renderTNodeJSX = hooks_tnode.useTNodeJSX();
    var renderTitle = renderTNodeJSX("title");
    var getRows = function getRows() {
      var column = props2.column,
        layout = props2.layout;
      var items = [];
      if (isArray.isArray(props2.items)) {
        items = props2.items.map(function (item) {
          return {
            label: descriptions_utils_index.renderCustomNode(item.label),
            content: descriptions_utils_index.renderCustomNode(item.content),
            span: item.span || 1
          };
        });
        itemsType.value = descriptions_interface.ItemsType.props;
      } else {
        var slots = getChildByName("TDescriptionsItem");
        if (slots.length !== 0) {
          items = slots;
          itemsType.value = descriptions_interface.ItemsType.slots;
        }
      }
      if (layout === "vertical") {
        return [items];
      }
      var temp = [];
      var reset = column;
      var res = [];
      items.forEach(function (item, index) {
        var span = 1;
        if (descriptions_utils_index.itemTypeIsProps(itemsType.value)) {
          span = isNil.isNil(item.span) ? span : item.span;
        } else {
          var propsData = item.componentOptions.propsData || {};
          span = isNil.isNil(propsData === null || propsData === void 0 ? void 0 : propsData.span) ? span : propsData.span;
          propsData.span = span;
          Object.assign(item.componentOptions, _objectSpread(_objectSpread({}, item.componentOptions), {}, {
            propsData: propsData
          }));
        }
        if (reset >= span) {
          temp.push(item);
          reset -= span;
        } else {
          res.push(temp);
          temp = [item];
          reset = column - span;
        }
        if (index === items.length - 1) {
          if (descriptions_utils_index.itemTypeIsProps(itemsType.value)) {
            Object.assign(item, {
              span: item.span + reset
            });
          } else {
            var _propsData = item.componentOptions.propsData || {};
            _propsData.span += reset;
            Object.assign(item.componentOptions, _objectSpread(_objectSpread({}, item.componentOptions), {}, {
              propsData: _propsData
            }));
          }
          res.push(temp);
        }
      });
      return res;
    };
    VueCompositionAPI.provide(descriptions_const_index["default"], props2);
    return {
      renderTitle: renderTitle,
      getRows: getRows,
      itemsType: itemsType,
      COMPONENT_NAME: COMPONENT_NAME
    };
  },
  render: function render() {
    var _this = this;
    var h = arguments[0];
    var renderHeader = function renderHeader() {
      return _this.renderTitle ? h("div", {
        "class": "".concat(_this.COMPONENT_NAME, "__header")
      }, [_this.renderTitle]) : "";
    };
    return h("div", {
      "class": this.COMPONENT_NAME
    }, [renderHeader(), h(descriptions_descriptionsBody["default"], {
      "attrs": {
        "item-type": this.itemsType,
        "rows": this.getRows()
      }
    })]);
  }
});

exports["default"] = _Descriptions;
//# sourceMappingURL=descriptions.js.map
