/**
 * tdesign v1.12.0
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var _defineProperty = require('@babel/runtime/helpers/defineProperty');
var VueCompositionAPI = require('@vue/composition-api');
var dropdown_dropdownItemProps = require('./dropdown-item-props.js');
var hooks_tnode = require('../hooks/tnode.js');
var hooks_useConfig = require('../hooks/useConfig.js');
var utils_helper = require('../utils/helper.js');
var utils_ripple = require('../utils/ripple.js');
var configProvider_configReceiver = require('../config-provider/config-receiver.js');
require('../hooks/render-tnode.js');
require('../_chunks/dep-ba816077.js');
require('@babel/runtime/helpers/typeof');
require('../_chunks/dep-2e662da4.js');
require('../_chunks/dep-31fa06d0.js');
require('../_chunks/dep-36c57efe.js');
require('../_chunks/dep-f4d07ab0.js');
require('../_chunks/dep-f0f28315.js');
require('../_chunks/dep-7ed5d19e.js');
require('../_chunks/dep-f8b182e9.js');
require('../_chunks/dep-0f4ac92d.js');
require('../_chunks/dep-2f28fbd7.js');
require('../_chunks/dep-76d8c62c.js');
require('../_chunks/dep-2f0c3d6d.js');
require('../_chunks/dep-b08014cb.js');
require('../_chunks/dep-1c1cc34f.js');
require('../_chunks/dep-1974f455.js');
require('../_chunks/dep-b520fc3a.js');
require('../_chunks/dep-23d55f82.js');
require('../_chunks/dep-bc3ec918.js');
require('../_chunks/dep-f97b0058.js');
require('../_chunks/dep-89b9f4de.js');
require('../_chunks/dep-f2e07584.js');
require('../_chunks/dep-c9d43e30.js');
require('../config-provider/useConfig.js');
require('../_chunks/dep-65c8d021.js');
require('../_common/js/global-config/default-config.js');
require('../_common/js/global-config/locale/zh_CN.js');
require('../_chunks/dep-bc99824f.js');
require('../_chunks/dep-4effc6c4.js');
require('dayjs');
require('../_chunks/dep-d59c4646.js');
require('../_chunks/dep-11382958.js');
require('../_chunks/dep-c272f99f.js');
require('../_chunks/dep-852fc6a9.js');
require('../_chunks/dep-9a119db9.js');
require('../_chunks/dep-49887b48.js');
require('../_chunks/dep-06c569d8.js');
require('../_chunks/dep-4d554a6f.js');
require('../_chunks/dep-7ec0f498.js');
require('../_chunks/dep-fcdc23bb.js');
require('../_chunks/dep-59f3051f.js');
require('../_chunks/dep-b86e0f9e.js');
require('@babel/runtime/helpers/objectWithoutProperties');
require('@babel/runtime/helpers/slicedToArray');
require('../_common/js/utils/setStyle.js');
require('../config.js');
require('vue');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var _defineProperty__default = /*#__PURE__*/_interopDefaultLegacy(_defineProperty);

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty__default["default"](e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var keepAnimationMixins = configProvider_configReceiver.getKeepAnimationMixins();
var _DropdownItem = VueCompositionAPI.defineComponent({
  name: "TDropdownItem",
  mixins: [keepAnimationMixins],
  directives: {
    ripple: utils_ripple["default"]
  },
  props: _objectSpread(_objectSpread({}, dropdown_dropdownItemProps["default"]), {}, {
    maxColumnWidth: {
      type: [String, Number],
      "default": 100
    },
    minColumnWidth: {
      type: [String, Number],
      "default": 10
    },
    isSubmenu: Boolean
  }),
  setup: function setup(props, _ref) {
    var emit = _ref.emit;
    var itemRef = VueCompositionAPI.ref();
    var dropdownItemClass = hooks_useConfig.usePrefixClass("dropdown__item");
    var handleItemClick = function handleItemClick(e) {
      var _props$onClick;
      (_props$onClick = props.onClick) === null || _props$onClick === void 0 || _props$onClick.call(props, props.value, {
        e: e
      });
      emit("click", props.value, {
        e: e
      });
    };
    return {
      itemRef: itemRef,
      dropdownItemClass: dropdownItemClass,
      handleItemClick: handleItemClick
    };
  },
  render: function render() {
    var h = arguments[0];
    var classes = [this.dropdownItemClass, "".concat(this.dropdownItemClass, "--theme-").concat(this.theme), _defineProperty__default["default"](_defineProperty__default["default"]({}, "".concat(this.dropdownItemClass, "--active"), this.active), "".concat(this.dropdownItemClass, "--disabled"), this.disabled)];
    var renderTNodeJSX = hooks_tnode.useTNodeJSX();
    var prefixIcon = renderTNodeJSX("prefixIcon");
    return h("li", {
      "class": classes,
      "on": {
        "click": this.handleItemClick
      },
      "style": {
        maxWidth: utils_helper.pxCompat(this.maxColumnWidth),
        minWidth: utils_helper.pxCompat(this.minColumnWidth)
      },
      "directives": [{
        name: "ripple",
        value: !this.isSubmenu && this.keepAnimation.ripple
      }],
      "ref": this.itemRef
    }, [this.prefixIcon ? h("div", {
      "class": "".concat(this.dropdownItemClass, "-icon")
    }, [prefixIcon]) : null, renderTNodeJSX("default")]);
  }
});

exports["default"] = _DropdownItem;
//# sourceMappingURL=dropdown-item.js.map
