/**
 * tdesign v1.12.0
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var helper = require('../_chunks/dep-27ac0b8c.js');
var VueCompositionAPI = require('@vue/composition-api');
var configProvider_useConfig = require('../config-provider/useConfig.js');
var hooks_useConfig = require('../hooks/useConfig.js');
var empty_props = require('./props.js');
var image_index = require('../image/index.js');
var utils_renderTnode = require('../utils/render-tnode.js');
var empty_assets_MaintenanceSvg = require('./assets/MaintenanceSvg.js');
var empty_assets_NetworkErrorSvg = require('./assets/NetworkErrorSvg.js');
var empty_assets_EmptySvg = require('./assets/EmptySvg.js');
var empty_assets_FailSvg = require('./assets/FailSvg.js');
var empty_assets_SuccessSvg = require('./assets/SuccessSvg.js');
var isString = require('../_chunks/dep-2e662da4.js');
var isPlainObject = require('../_chunks/dep-59f3051f.js');
require('../_chunks/dep-65c8d021.js');
require('../_common/js/global-config/default-config.js');
require('../_common/js/global-config/locale/zh_CN.js');
require('../_chunks/dep-bc99824f.js');
require('@babel/runtime/helpers/typeof');
require('../_chunks/dep-4effc6c4.js');
require('dayjs');
require('../_chunks/dep-d59c4646.js');
require('../_chunks/dep-11382958.js');
require('../_chunks/dep-c272f99f.js');
require('../_chunks/dep-89b9f4de.js');
require('../_chunks/dep-1c1cc34f.js');
require('../_chunks/dep-31fa06d0.js');
require('../_chunks/dep-ba816077.js');
require('../_chunks/dep-852fc6a9.js');
require('../_chunks/dep-c9d43e30.js');
require('../_chunks/dep-f4d07ab0.js');
require('../_chunks/dep-36c57efe.js');
require('../_chunks/dep-23d55f82.js');
require('../_chunks/dep-bc3ec918.js');
require('../_chunks/dep-f97b0058.js');
require('../_chunks/dep-9a119db9.js');
require('../_chunks/dep-49887b48.js');
require('../_chunks/dep-06c569d8.js');
require('../_chunks/dep-4d554a6f.js');
require('../_chunks/dep-7ec0f498.js');
require('../_chunks/dep-fcdc23bb.js');
require('../_chunks/dep-b86e0f9e.js');
require('../image/image.js');
require('@babel/runtime/helpers/slicedToArray');
require('tdesign-icons-vue');
require('../_common/js/utils/observe.js');
require('../image/props.js');
require('../space/index.js');
require('../space/space.js');
require('@babel/runtime/helpers/defineProperty');
require('../space/props.js');
require('../_common/js/utils/helper.js');
require('@babel/runtime/helpers/toConsumableArray');
require('@babel/runtime/helpers/objectWithoutProperties');
require('../_chunks/dep-caea5f4e.js');
require('../_chunks/dep-1fe4c69b.js');
require('../_chunks/dep-260a7245.js');
require('@babel/runtime/helpers/readOnlyError');
require('vue');
require('../_chunks/dep-f0f28315.js');
require('../_chunks/dep-7ed5d19e.js');
require('../_chunks/dep-f8b182e9.js');
require('../_chunks/dep-0f4ac92d.js');
require('../_chunks/dep-2f28fbd7.js');
require('../_chunks/dep-76d8c62c.js');
require('../_chunks/dep-2f0c3d6d.js');
require('../_chunks/dep-b08014cb.js');
require('../utils/withInstall.js');
require('../_chunks/dep-11856238.js');
require('../_chunks/dep-b5cedeaa.js');
require('../_chunks/dep-07989e63.js');
require('../_chunks/dep-d3e77112.js');
require('../_chunks/dep-b520fc3a.js');
require('../_chunks/dep-f2e07584.js');
require('../_chunks/dep-76dea031.js');
require('../_chunks/dep-0982adb4.js');
require('../_chunks/dep-bd4b64b6.js');
require('../hooks/useImagePreviewUrl.js');
require('../_common/js/upload/utils.js');
require('../_common/js/log/log.js');
require('../utils/map-props.js');

var _Empty = VueCompositionAPI.defineComponent({
  name: "TEmpty",
  components: {
    TImage: image_index.Image
  },
  props: empty_props["default"],
  setup: function setup(props2, _ref) {
    var slots = _ref.slots;
    var _toRefs = VueCompositionAPI.toRefs(props2),
      size = _toRefs.size,
      propsImage = _toRefs.image,
      propsDescription = _toRefs.description,
      propsTitle = _toRefs.title,
      type = _toRefs.type;
    var _useConfig = configProvider_useConfig.useConfig("empty"),
      globalConfig = _useConfig.globalConfig;
    var componentName = configProvider_useConfig.usePrefixClass("empty");
    var showAction = VueCompositionAPI.computed(function () {
      return props2.action || slots.action;
    });
    var _useCommonClassName = hooks_useConfig.useCommonClassName(),
      SIZE = _useCommonClassName.SIZE;
    var defaultMaps = {
      maintenance: {
        image: globalConfig.value.image.maintenance || empty_assets_MaintenanceSvg["default"],
        title: globalConfig.value.titleText.maintenance
      },
      success: {
        image: globalConfig.value.image.success || empty_assets_SuccessSvg["default"],
        title: globalConfig.value.titleText.success
      },
      fail: {
        image: globalConfig.value.image.fail || empty_assets_FailSvg["default"],
        title: globalConfig.value.titleText.fail
      },
      "network-error": {
        image: globalConfig.value.image.networkError || empty_assets_NetworkErrorSvg["default"],
        title: globalConfig.value.titleText.networkError
      },
      empty: {
        image: globalConfig.value.image.empty || empty_assets_EmptySvg["default"],
        title: globalConfig.value.titleText.empty
      }
    };
    var emptyClasses = VueCompositionAPI.computed(function () {
      return [componentName.value, SIZE.value[size.value]];
    });
    var titleClasses = ["".concat(componentName.value, "__title")];
    var imageClasses = ["".concat(componentName.value, "__image")];
    var descriptionClasses = ["".concat(componentName.value, "__description")];
    var actionClass = ["".concat(componentName.value, "__action")];
    var typeImageProps = VueCompositionAPI.computed(function () {
      var _defaultMaps$type$val;
      return (_defaultMaps$type$val = defaultMaps[type.value]) !== null && _defaultMaps$type$val !== void 0 ? _defaultMaps$type$val : null;
    });
    var showImage = VueCompositionAPI.computed(function () {
      var _typeImageProps$value;
      return propsImage.value || slots.image || ((_typeImageProps$value = typeImageProps.value) === null || _typeImageProps$value === void 0 ? void 0 : _typeImageProps$value.image);
    });
    var showTitle = VueCompositionAPI.computed(function () {
      var _typeImageProps$value2;
      return propsTitle.value || slots.title || ((_typeImageProps$value2 = typeImageProps.value) === null || _typeImageProps$value2 === void 0 ? void 0 : _typeImageProps$value2.title);
    });
    var showDescription = VueCompositionAPI.computed(function () {
      return propsDescription.value || slots.description;
    });
    return {
      emptyClasses: emptyClasses,
      imageClasses: imageClasses,
      titleClasses: titleClasses,
      descriptionClasses: descriptionClasses,
      actionClass: actionClass,
      showImage: showImage,
      showTitle: showTitle,
      showDescription: showDescription,
      showAction: showAction
    };
  },
  methods: {
    renderTitle: function renderTitle() {
      var h = this.$createElement;
      if (!this.showTitle) {
        return null;
      }
      return h("div", {
        "class": this.titleClasses
      }, [this.showTitle]);
    },
    renderDescription: function renderDescription() {
      var h = this.$createElement;
      if (!this.showDescription) {
        return null;
      }
      return h("div", {
        "class": this.descriptionClasses
      }, [this.showDescription]);
    },
    getImageIns: function getImageIns() {
      var h = this.$createElement;
      var data = this.showImage;
      var result = null;
      if (isString.isString(data)) {
        result = h(image_index.Image, {
          "attrs": {
            "src": data
          }
        });
      } else if (data && Reflect.has(data, "render")) {
        result = h(data);
      } else if (isPlainObject.isPlainObject(data)) {
        result = h(image_index.Image, helper.helper([{}, data]));
      }
      return data ? result : null;
    }
  },
  render: function render() {
    var h = arguments[0];
    return h("div", {
      "class": this.emptyClasses
    }, [this.showImage ? h("div", {
      "class": this.imageClasses,
      "style": this.imageStyle
    }, [this.$slots.image ? utils_renderTnode.renderTNodeJSX(this, "image") : this.getImageIns()]) : null, this.renderTitle(), this.renderDescription(), this.showAction ? h("div", {
      "class": this.actionClass
    }, [utils_renderTnode.renderTNodeJSX(this, "action")]) : null]);
  }
});

exports["default"] = _Empty;
//# sourceMappingURL=empty.js.map
