/**
 * tdesign v1.12.0
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var VueCompositionAPI = require('@vue/composition-api');
var hooks_renderTnode = require('./render-tnode.js');
var isFunction = require('../_chunks/dep-1c1cc34f.js');
var camelCase = require('../_chunks/dep-f0f28315.js');
var kebabCase = require('../_chunks/dep-b08014cb.js');
var isEmpty = require('../_chunks/dep-1974f455.js');
require('../_chunks/dep-ba816077.js');
require('@babel/runtime/helpers/typeof');
require('../_chunks/dep-2e662da4.js');
require('../_chunks/dep-31fa06d0.js');
require('../_chunks/dep-36c57efe.js');
require('../_chunks/dep-f4d07ab0.js');
require('../_chunks/dep-7ed5d19e.js');
require('../_chunks/dep-f8b182e9.js');
require('../_chunks/dep-0f4ac92d.js');
require('../_chunks/dep-2f28fbd7.js');
require('../_chunks/dep-76d8c62c.js');
require('../_chunks/dep-2f0c3d6d.js');
require('../_chunks/dep-b520fc3a.js');
require('../_chunks/dep-23d55f82.js');
require('../_chunks/dep-bc3ec918.js');
require('../_chunks/dep-f97b0058.js');
require('../_chunks/dep-89b9f4de.js');
require('../_chunks/dep-f2e07584.js');
require('../_chunks/dep-c9d43e30.js');

function handleSlots(slots, name, params) {
  var _slots$camelCase, _slots$kebabCase;
  var finaleParams = VueCompositionAPI.h;
  if (params) {
    Object.assign(finaleParams, params);
  }
  var node = (_slots$camelCase = slots[camelCase.camelCase(name)]) === null || _slots$camelCase === void 0 ? void 0 : _slots$camelCase.call(slots, finaleParams);
  if (node) return node;
  node = (_slots$kebabCase = slots[kebabCase.kebabCase(name)]) === null || _slots$kebabCase === void 0 ? void 0 : _slots$kebabCase.call(slots, finaleParams);
  if (node) return node;
  return null;
}
var useTNodeJSX = function useTNodeJSX() {
  var instance = VueCompositionAPI.getCurrentInstance();
  return function (name, options) {
    var params = hooks_renderTnode.getParams(options);
    var defaultNode = hooks_renderTnode.getDefaultNode(options);
    var slots = instance.setupContext.slots;
    var propsNode;
    if (Object.keys(instance.props).includes(name)) {
      propsNode = instance.props[name];
    }
    if (propsNode === false) return;
    if (propsNode === true) {
      return handleSlots(slots, name, params) || defaultNode;
    }
    if (isFunction.isFunction(propsNode)) return propsNode(VueCompositionAPI.h, params);
    var isPropsEmpty = [void 0, params, ""].includes(propsNode);
    if (isPropsEmpty && (slots[camelCase.camelCase(name)] || slots[kebabCase.kebabCase(name)])) {
      return handleSlots(slots, name, params);
    }
    return propsNode;
  };
};
var useTNodeDefault = function useTNodeDefault() {
  var renderTNodeJSX = useTNodeJSX();
  return function (name, options) {
    var defaultNode = hooks_renderTnode.getDefaultNode(options);
    return renderTNodeJSX(name, options) || defaultNode;
  };
};
var useContent = function useContent() {
  var renderTNodeJSX = useTNodeJSX();
  return function (name1, name2, options) {
    var params = hooks_renderTnode.getParams(options);
    var defaultNode = hooks_renderTnode.getDefaultNode(options);
    var toParams = params ? {
      params: params
    } : void 0;
    var node1 = renderTNodeJSX(name1, toParams);
    var node2 = renderTNodeJSX(name2, toParams);
    var res = isEmpty.isEmpty(node1) ? node2 : node1;
    return isEmpty.isEmpty(res) ? defaultNode : res;
  };
};

exports.useContent = useContent;
exports.useTNodeDefault = useTNodeDefault;
exports.useTNodeJSX = useTNodeJSX;
//# sourceMappingURL=tnode.js.map
