/**
 * tdesign v1.12.0
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var _defineProperty = require('@babel/runtime/helpers/defineProperty');
var VueCompositionAPI = require('@vue/composition-api');
var tdesignIconsVue = require('tdesign-icons-vue');
var configProvider_useConfig = require('../../config-provider/useConfig.js');
var imageViewer_hooks = require('../hooks.js');
var utils_helper = require('../../utils/helper.js');
var hooks_useImagePreviewUrl = require('../../hooks/useImagePreviewUrl.js');
require('../../_chunks/dep-65c8d021.js');
require('../../_common/js/global-config/default-config.js');
require('../../_common/js/global-config/locale/zh_CN.js');
require('../../_chunks/dep-bc99824f.js');
require('@babel/runtime/helpers/typeof');
require('../../_chunks/dep-4effc6c4.js');
require('dayjs');
require('../../_chunks/dep-d59c4646.js');
require('../../_chunks/dep-11382958.js');
require('../../_chunks/dep-c272f99f.js');
require('../../_chunks/dep-89b9f4de.js');
require('../../_chunks/dep-1c1cc34f.js');
require('../../_chunks/dep-31fa06d0.js');
require('../../_chunks/dep-ba816077.js');
require('../../_chunks/dep-852fc6a9.js');
require('../../_chunks/dep-c9d43e30.js');
require('../../_chunks/dep-f4d07ab0.js');
require('../../_chunks/dep-36c57efe.js');
require('../../_chunks/dep-23d55f82.js');
require('../../_chunks/dep-bc3ec918.js');
require('../../_chunks/dep-f97b0058.js');
require('../../_chunks/dep-9a119db9.js');
require('../../_chunks/dep-49887b48.js');
require('../../_chunks/dep-06c569d8.js');
require('../../_chunks/dep-4d554a6f.js');
require('../../_chunks/dep-7ec0f498.js');
require('../../_chunks/dep-fcdc23bb.js');
require('../../_chunks/dep-59f3051f.js');
require('../../_chunks/dep-b86e0f9e.js');
require('../const.js');
require('@babel/runtime/helpers/objectWithoutProperties');
require('@babel/runtime/helpers/slicedToArray');
require('../../_chunks/dep-f0f28315.js');
require('../../_chunks/dep-7ed5d19e.js');
require('../../_chunks/dep-f8b182e9.js');
require('../../_chunks/dep-0f4ac92d.js');
require('../../_chunks/dep-2f28fbd7.js');
require('../../_chunks/dep-76d8c62c.js');
require('../../_chunks/dep-2f0c3d6d.js');
require('../../_common/js/upload/utils.js');
require('../../_common/js/log/log.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var _defineProperty__default = /*#__PURE__*/_interopDefaultLegacy(_defineProperty);

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty__default["default"](e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var TImageItem = VueCompositionAPI.defineComponent({
  name: "TImageItem",
  props: {
    rotate: Number,
    scale: Number,
    mirror: Number,
    src: [String, Object],
    placementSrc: [String, Object],
    imageReferrerpolicy: String
  },
  setup: function setup(props) {
    var _toRefs = VueCompositionAPI.toRefs(props),
      src = _toRefs.src,
      placementSrc = _toRefs.placementSrc;
    var _useConfig = configProvider_useConfig.useConfig("imageViewer"),
      classPrefix = _useConfig.classPrefix,
      globalConfig = _useConfig.global;
    var error = VueCompositionAPI.ref(false);
    var loaded = VueCompositionAPI.ref(false);
    var _useDrag = imageViewer_hooks.useDrag({
        translateX: 0,
        translateY: 0
      }),
      transform = _useDrag.transform,
      mouseDownHandler = _useDrag.mouseDownHandler;
    var _useImagePreviewUrl = hooks_useImagePreviewUrl.useImagePreviewUrl(src),
      mainImagePreviewUrl = _useImagePreviewUrl.previewUrl;
    var _useImagePreviewUrl2 = hooks_useImagePreviewUrl.useImagePreviewUrl(placementSrc),
      placementImagePreviewUrl = _useImagePreviewUrl2.previewUrl;
    var imgStyle = VueCompositionAPI.computed(function () {
      return _objectSpread(_objectSpread({}, utils_helper.setTransform("rotate(".concat(props.rotate, "deg) scale(").concat(props.scale, ")"))), {}, {
        display: !props.placementSrc || loaded.value ? "block" : "none"
      });
    });
    var placementImgStyle = VueCompositionAPI.computed(function () {
      return _objectSpread(_objectSpread({}, utils_helper.setTransform("rotate(".concat(props.rotate, "deg) scale(").concat(props.scale, ")"))), {}, {
        display: !loaded.value ? "block" : "none"
      });
    });
    var boxStyle = VueCompositionAPI.computed(function () {
      var _transform$value = transform.value,
        translateX = _transform$value.translateX,
        translateY = _transform$value.translateY;
      return utils_helper.setTransform("translate(".concat(translateX, "px, ").concat(translateY, "px) scale(").concat(props.mirror, ", 1)"));
    });
    var resetStatus = function resetStatus() {
      error.value = false;
      loaded.value = false;
    };
    VueCompositionAPI.watch([mainImagePreviewUrl, placementImagePreviewUrl], function () {
      resetStatus();
    });
    return {
      globalConfig: globalConfig,
      classPrefix: classPrefix,
      boxStyle: boxStyle,
      loaded: loaded,
      error: error,
      mouseDownHandler: mouseDownHandler,
      placementImgStyle: placementImgStyle,
      imgStyle: imgStyle,
      mainImagePreviewUrl: mainImagePreviewUrl,
      placementImagePreviewUrl: placementImagePreviewUrl
    };
  },
  render: function render() {
    var _this = this;
    var h = arguments[0];
    return h("div", {
      "class": "".concat(this.classPrefix, "-image-viewer__modal-pic")
    }, [h("div", {
      "class": "".concat(this.classPrefix, "-image-viewer__modal-box"),
      "style": this.boxStyle
    }, [this.error && h("div", {
      "class": "".concat(this.classPrefix, "-image-viewer__img-error")
    }, [h("div", {
      "class": "".concat(this.classPrefix, "-image-viewer__img-error-content")
    }, [h(tdesignIconsVue.ImageErrorIcon, {
      "attrs": {
        "size": "4em"
      }
    }), h("div", {
      "class": "".concat(this.classPrefix, "-image-viewer__img-error-text")
    }, [this.globalConfig.errorText])])]), !this.error && !!this.placementSrc && this.placementImagePreviewUrl && h("img", {
      "class": "".concat(this.classPrefix, "-image-viewer__modal-image"),
      "on": {
        "mousedown": function mousedown(event) {
          event.stopPropagation();
          _this.mouseDownHandler(event);
        }
      },
      "attrs": {
        "src": this.placementImagePreviewUrl,
        "alt": "image",
        "draggable": "false",
        "referrerpolicy": this.imageReferrerpolicy
      },
      "style": this.placementImgStyle
    }), !this.error && this.mainImagePreviewUrl && h("img", {
      "class": "".concat(this.classPrefix, "-image-viewer__modal-image"),
      "on": {
        "mousedown": function mousedown(event) {
          event.stopPropagation();
          _this.mouseDownHandler(event);
        },
        "load": function load() {
          return _this.loaded = true;
        },
        "error": function error() {
          return _this.error = true;
        }
      },
      "attrs": {
        "src": this.mainImagePreviewUrl,
        "alt": "image",
        "draggable": "false",
        "referrerpolicy": this.imageReferrerpolicy
      },
      "style": this.imgStyle
    })])]);
  }
});

exports["default"] = TImageItem;
//# sourceMappingURL=ImageItem.js.map
