/**
 * tdesign v1.12.0
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var helper = require('../_chunks/dep-27ac0b8c.js');
var _slicedToArray = require('@babel/runtime/helpers/slicedToArray');
var VueCompositionAPI = require('@vue/composition-api');
var tdesignIconsVue = require('tdesign-icons-vue');
var _common_js_utils_observe = require('../_common/js/utils/observe.js');
var configProvider_useConfig = require('../config-provider/useConfig.js');
var image_props = require('./props.js');
var utils_renderTnode = require('../utils/render-tnode.js');
var space_index = require('../space/index.js');
var omit = require('../_chunks/dep-11856238.js');
var isFunction = require('../_chunks/dep-1c1cc34f.js');
var hooks_useImagePreviewUrl = require('../hooks/useImagePreviewUrl.js');
require('../_chunks/dep-65c8d021.js');
require('../_common/js/global-config/default-config.js');
require('../_common/js/global-config/locale/zh_CN.js');
require('../_chunks/dep-bc99824f.js');
require('@babel/runtime/helpers/typeof');
require('../_chunks/dep-4effc6c4.js');
require('dayjs');
require('../_chunks/dep-d59c4646.js');
require('../_chunks/dep-11382958.js');
require('../_chunks/dep-c272f99f.js');
require('../_chunks/dep-89b9f4de.js');
require('../_chunks/dep-31fa06d0.js');
require('../_chunks/dep-ba816077.js');
require('../_chunks/dep-852fc6a9.js');
require('../_chunks/dep-c9d43e30.js');
require('../_chunks/dep-f4d07ab0.js');
require('../_chunks/dep-36c57efe.js');
require('../_chunks/dep-23d55f82.js');
require('../_chunks/dep-bc3ec918.js');
require('../_chunks/dep-f97b0058.js');
require('../_chunks/dep-9a119db9.js');
require('../_chunks/dep-49887b48.js');
require('../_chunks/dep-06c569d8.js');
require('../_chunks/dep-4d554a6f.js');
require('../_chunks/dep-7ec0f498.js');
require('../_chunks/dep-fcdc23bb.js');
require('../_chunks/dep-59f3051f.js');
require('../_chunks/dep-b86e0f9e.js');
require('@babel/runtime/helpers/defineProperty');
require('@babel/runtime/helpers/readOnlyError');
require('vue');
require('../_chunks/dep-f0f28315.js');
require('../_chunks/dep-7ed5d19e.js');
require('../_chunks/dep-f8b182e9.js');
require('../_chunks/dep-0f4ac92d.js');
require('../_chunks/dep-2f28fbd7.js');
require('../_chunks/dep-76d8c62c.js');
require('../_chunks/dep-2f0c3d6d.js');
require('../_chunks/dep-b08014cb.js');
require('../space/space.js');
require('../space/props.js');
require('../hooks/useConfig.js');
require('../_common/js/utils/helper.js');
require('@babel/runtime/helpers/toConsumableArray');
require('@babel/runtime/helpers/objectWithoutProperties');
require('../_chunks/dep-caea5f4e.js');
require('../_chunks/dep-1fe4c69b.js');
require('../_chunks/dep-2e662da4.js');
require('../_chunks/dep-260a7245.js');
require('../utils/withInstall.js');
require('../_chunks/dep-b5cedeaa.js');
require('../_chunks/dep-07989e63.js');
require('../_chunks/dep-d3e77112.js');
require('../_chunks/dep-b520fc3a.js');
require('../_chunks/dep-f2e07584.js');
require('../_chunks/dep-76dea031.js');
require('../_chunks/dep-0982adb4.js');
require('../_chunks/dep-bd4b64b6.js');
require('../_common/js/upload/utils.js');
require('../_common/js/log/log.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var _slicedToArray__default = /*#__PURE__*/_interopDefaultLegacy(_slicedToArray);

var _Image = VueCompositionAPI.defineComponent({
  name: "TImage",
  components: {
    Space: space_index.Space
  },
  props: image_props["default"],
  setup: function setup(props2, _ref) {
    var emit = _ref.emit;
    var onLoad = props2.onLoad,
      onError = props2.onError;
    var _toRefs = VueCompositionAPI.toRefs(props2),
      src = _toRefs.src,
      lazy = _toRefs.lazy,
      fallback = _toRefs.fallback,
      overlayTrigger = _toRefs.overlayTrigger;
    var rest = omit.omit(props2, ["className", "src", "style", "alt", "fit", "position", "shape", "placeholder", "loading", "error", "overlayTrigger", "overlayContent", "lazy", "gallery", "onLoad", "onError"]);
    var _useConfig = configProvider_useConfig.useConfig("image"),
      classPrefix = _useConfig.classPrefix,
      globalConfig = _useConfig.globalConfig;
    var imageRef = VueCompositionAPI.ref(null);
    var imageStrSrc = VueCompositionAPI.ref(src.value);
    VueCompositionAPI.watch([src, globalConfig], function (_ref2) {
      var _ref3 = _slicedToArray__default["default"](_ref2, 2),
        src2 = _ref3[0],
        globalConfig2 = _ref3[1];
      var _ref4 = globalConfig2 || {},
        replaceImageSrc = _ref4.replaceImageSrc;
      var tmpUrl = isFunction.isFunction(replaceImageSrc) ? replaceImageSrc(props2) : src2;
      if (tmpUrl === imageStrSrc.value && imageStrSrc.value) return;
      imageStrSrc.value = tmpUrl;
    }, {
      immediate: true
    });
    var _useImagePreviewUrl = hooks_useImagePreviewUrl.useImagePreviewUrl(imageStrSrc),
      previewUrl = _useImagePreviewUrl.previewUrl;
    VueCompositionAPI.watch([previewUrl], function () {
      hasError.value = false;
      isLoaded.value = false;
    });
    var shouldLoad = VueCompositionAPI.ref(!lazy.value);
    var handleLoadImage = function handleLoadImage() {
      shouldLoad.value = true;
    };
    var isLoaded = VueCompositionAPI.ref(false);
    var handleLoad = function handleLoad(e) {
      isLoaded.value = true;
      emit("load", {
        e: e
      });
      onLoad === null || onLoad === void 0 || onLoad({
        e: e
      });
    };
    var hasError = VueCompositionAPI.ref(false);
    var handleError = function handleError(e) {
      hasError.value = true;
      if (fallback.value) {
        imageStrSrc.value = fallback.value;
        hasError.value = false;
      }
      emit("error", {
        e: e
      });
      onError === null || onError === void 0 || onError({
        e: e
      });
    };
    var hasMouseEvent = overlayTrigger.value === "hover";
    var shouldShowOverlay = VueCompositionAPI.ref(!hasMouseEvent);
    var handleToggleOverlay = function handleToggleOverlay() {
      if (hasMouseEvent) {
        shouldShowOverlay.value = !shouldShowOverlay.value;
      }
    };
    var imageClasses = VueCompositionAPI.computed(function () {
      return ["".concat(classPrefix.value, "-image"), "".concat(classPrefix.value, "-image--fit-").concat(props2.fit), "".concat(classPrefix.value, "-image--position-").concat(props2.position)];
    });
    return {
      imageRef: imageRef,
      imageClasses: imageClasses,
      handleLoadImage: handleLoadImage,
      classPrefix: classPrefix,
      globalConfig: globalConfig,
      hasMouseEvent: hasMouseEvent,
      handleToggleOverlay: handleToggleOverlay,
      shouldShowOverlay: shouldShowOverlay,
      imageStrSrc: imageStrSrc,
      previewUrl: previewUrl,
      hasError: hasError,
      shouldLoad: shouldLoad,
      handleError: handleError,
      handleLoad: handleLoad,
      isLoaded: isLoaded,
      rest: rest
    };
  },
  mounted: function mounted() {
    if (!this.lazy || !this.imageRef) return;
    var io = _common_js_utils_observe["default"](this.imageRef, null, this.handleLoadImage, 0);
    this.io = io;
  },
  destroyed: function destroyed() {
    this.imageRef && this.io && this.io.unobserve(this.imageRef);
  },
  methods: {
    renderPlaceholder: function renderPlaceholder() {
      var h = this.$createElement;
      var placeholder = utils_renderTnode.renderTNodeJSX(this, "placeholder");
      if (!placeholder) return;
      return h("div", {
        "class": "".concat(this.classPrefix, "-image__placeholder")
      }, [placeholder]);
    },
    renderGalleryShadow: function renderGalleryShadow() {
      var h = this.$createElement;
      if (!this.gallery) return null;
      return h("div", {
        "class": "".concat(this.classPrefix, "-image__gallery-shadow")
      });
    },
    renderOverlay: function renderOverlay() {
      var h = this.$createElement;
      var overlay = utils_renderTnode.renderTNodeJSX(this, "overlayContent");
      if (!overlay) return null;
      return h("div", {
        "class": ["".concat(this.classPrefix, "-image__overlay-content"), !this.shouldShowOverlay && "".concat(this.classPrefix, "-image__overlay-content--hidden")]
      }, [overlay]);
    },
    renderImageSrcset: function renderImageSrcset() {
      var h = this.$createElement;
      return h("picture", [Object.entries(this.srcset).map(function (_ref5) {
        var _ref6 = _slicedToArray__default["default"](_ref5, 2),
          type = _ref6[0],
          url = _ref6[1];
        return h("source", {
          "attrs": {
            "type": type,
            "srcset": url
          }
        });
      }), this.renderImage()]);
    },
    renderImage: function renderImage() {
      var h = this.$createElement;
      var url = typeof this.imageStrSrc === "string" ? this.imageStrSrc : this.previewUrl;
      return h("img", {
        "attrs": {
          "src": url,
          "alt": this.alt,
          "referrerpolicy": this.referrerpolicy
        },
        "on": {
          "error": this.handleError,
          "load": this.handleLoad
        },
        "class": this.imageClasses
      });
    }
  },
  render: function render() {
    var h = arguments[0];
    return h("div", helper.helper([{
      "ref": "imageRef",
      "class": ["".concat(this.classPrefix, "-image__wrapper"), "".concat(this.classPrefix, "-image__wrapper--shape-").concat(this.shape), this.gallery && "".concat(this.classPrefix, "-image__wrapper--gallery"), this.hasMouseEvent && "".concat(this.classPrefix, "-image__wrapper--need-hover"), this.className],
      "on": {
        "mouseenter": this.handleToggleOverlay,
        "mouseleave": this.handleToggleOverlay
      }
    }, this.rest, {}, {
      "on": this.$listeners
    }]), [this.renderPlaceholder(), this.renderGalleryShadow(), (this.hasError || !this.shouldLoad) && h("div", {
      "class": "".concat(this.classPrefix, "-image")
    }), !(this.hasError || !this.shouldLoad) && (this.srcset && Object.keys(this.srcset).length ? this.renderImageSrcset() : this.renderImage()), !(this.hasError || !this.shouldLoad) && !this.isLoaded && h("div", {
      "class": "".concat(this.classPrefix, "-image__loading")
    }, [utils_renderTnode.renderTNodeJSX(this, "loading") || h(space_index.Space, {
      "attrs": {
        "direction": "vertical",
        "size": 8,
        "align": "center"
      }
    }, [h(tdesignIconsVue.ImageIcon, {
      "attrs": {
        "size": "24px"
      }
    }), typeof this.loading === "string" ? this.loading : this.globalConfig.loadingText])]), this.hasError && h("div", {
      "class": "".concat(this.classPrefix, "-image__error")
    }, [utils_renderTnode.renderTNodeJSX(this, "error") || h(space_index.Space, {
      "attrs": {
        "direction": "vertical",
        "size": 8,
        "align": "center"
      }
    }, [h(tdesignIconsVue.ImageErrorIcon, {
      "attrs": {
        "size": "24px"
      }
    }), typeof this.error === "string" ? this.error : this.globalConfig.errorText])]), this.renderOverlay()]);
  }
});

exports["default"] = _Image;
//# sourceMappingURL=image.js.map
