/**
 * tdesign v1.12.0
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var _defineProperty = require('@babel/runtime/helpers/defineProperty');
var utils_renderTnode = require('../utils/render-tnode.js');
var link_props = require('./props.js');
var configProvider_configReceiver = require('../config-provider/config-receiver.js');
var utils_mixins = require('../utils/mixins.js');
require('@babel/runtime/helpers/readOnlyError');
require('@babel/runtime/helpers/typeof');
require('vue');
require('@vue/composition-api');
require('../_chunks/dep-f0f28315.js');
require('../_chunks/dep-7ed5d19e.js');
require('../_chunks/dep-f8b182e9.js');
require('../_chunks/dep-31fa06d0.js');
require('../_chunks/dep-36c57efe.js');
require('../_chunks/dep-0f4ac92d.js');
require('../_chunks/dep-f4d07ab0.js');
require('../_chunks/dep-2f28fbd7.js');
require('../_chunks/dep-76d8c62c.js');
require('../_chunks/dep-2f0c3d6d.js');
require('../_chunks/dep-b08014cb.js');
require('../_chunks/dep-65c8d021.js');
require('../_common/js/global-config/default-config.js');
require('../_common/js/global-config/locale/zh_CN.js');
require('../_chunks/dep-bc99824f.js');
require('../_chunks/dep-4effc6c4.js');
require('dayjs');
require('../_chunks/dep-d59c4646.js');
require('../_chunks/dep-11382958.js');
require('../_chunks/dep-c272f99f.js');
require('../_chunks/dep-89b9f4de.js');
require('../_chunks/dep-1c1cc34f.js');
require('../_chunks/dep-ba816077.js');
require('../_chunks/dep-852fc6a9.js');
require('../_chunks/dep-c9d43e30.js');
require('../_chunks/dep-23d55f82.js');
require('../_chunks/dep-bc3ec918.js');
require('../_chunks/dep-f97b0058.js');
require('../_chunks/dep-9a119db9.js');
require('../_chunks/dep-49887b48.js');
require('../_chunks/dep-06c569d8.js');
require('../_chunks/dep-4d554a6f.js');
require('../_chunks/dep-7ec0f498.js');
require('../_chunks/dep-fcdc23bb.js');
require('../_chunks/dep-59f3051f.js');
require('../_chunks/dep-b86e0f9e.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var _defineProperty__default = /*#__PURE__*/_interopDefaultLegacy(_defineProperty);

var classPrefixMixins = configProvider_configReceiver.getClassPrefixMixins("link");
var _Link = utils_mixins["default"](classPrefixMixins).extend({
  name: "TLink",
  props: link_props["default"],
  methods: {
    handleClick: function handleClick(e) {
      var _this$onClick;
      if (this.disabled) return;
      this.$emit("click", e);
      (_this$onClick = this.onClick) === null || _this$onClick === void 0 || _this$onClick.call(this, e);
    }
  },
  render: function render() {
    var h = arguments[0];
    var linkContent = utils_renderTnode.renderContent(this, "default", "content");
    var prefixContent = utils_renderTnode.renderTNodeJSX(this, "prefixIcon");
    var suffixContent = utils_renderTnode.renderTNodeJSX(this, "suffixIcon");
    var linkClass = [this.componentName, "".concat(this.componentName, "--theme-").concat(this.theme), _defineProperty__default["default"](_defineProperty__default["default"](_defineProperty__default["default"](_defineProperty__default["default"]({}, this.commonSizeClassName[this.size], this.size !== "medium"), this.commonStatusClassName.disabled, this.disabled), "".concat(this.classPrefix, "-is-underline"), this.underline), "".concat(this.componentName, "--hover-").concat(this.hover), !this.disabled)];
    return h("a", {
      "class": linkClass,
      "attrs": {
        "href": this.disabled || !this.href ? void 0 : this.href,
        "target": this.target,
        "download": this.download
      },
      "on": {
        "click": this.handleClick
      }
    }, [prefixContent && h("span", {
      "class": "".concat(this.componentName, "__prefix-icon")
    }, [prefixContent]), linkContent, suffixContent && h("span", {
      "class": "".concat(this.componentName, "__suffix-icon")
    }, [suffixContent])]);
  }
});

exports["default"] = _Link;
//# sourceMappingURL=link.js.map
