/**
 * tdesign v1.12.0
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var VueCompositionAPI = require('@vue/composition-api');
var list_listItemProps = require('./list-item-props.js');
var hooks_useConfig = require('../hooks/useConfig.js');
var utils_renderTnode = require('../utils/render-tnode.js');
require('../config-provider/useConfig.js');
require('../_chunks/dep-65c8d021.js');
require('../_common/js/global-config/default-config.js');
require('../_common/js/global-config/locale/zh_CN.js');
require('../_chunks/dep-bc99824f.js');
require('@babel/runtime/helpers/typeof');
require('../_chunks/dep-4effc6c4.js');
require('dayjs');
require('../_chunks/dep-d59c4646.js');
require('../_chunks/dep-11382958.js');
require('../_chunks/dep-c272f99f.js');
require('../_chunks/dep-89b9f4de.js');
require('../_chunks/dep-1c1cc34f.js');
require('../_chunks/dep-31fa06d0.js');
require('../_chunks/dep-ba816077.js');
require('../_chunks/dep-852fc6a9.js');
require('../_chunks/dep-c9d43e30.js');
require('../_chunks/dep-f4d07ab0.js');
require('../_chunks/dep-36c57efe.js');
require('../_chunks/dep-23d55f82.js');
require('../_chunks/dep-bc3ec918.js');
require('../_chunks/dep-f97b0058.js');
require('../_chunks/dep-9a119db9.js');
require('../_chunks/dep-49887b48.js');
require('../_chunks/dep-06c569d8.js');
require('../_chunks/dep-4d554a6f.js');
require('../_chunks/dep-7ec0f498.js');
require('../_chunks/dep-fcdc23bb.js');
require('../_chunks/dep-59f3051f.js');
require('../_chunks/dep-b86e0f9e.js');
require('@babel/runtime/helpers/defineProperty');
require('@babel/runtime/helpers/readOnlyError');
require('vue');
require('../_chunks/dep-f0f28315.js');
require('../_chunks/dep-7ed5d19e.js');
require('../_chunks/dep-f8b182e9.js');
require('../_chunks/dep-0f4ac92d.js');
require('../_chunks/dep-2f28fbd7.js');
require('../_chunks/dep-76d8c62c.js');
require('../_chunks/dep-2f0c3d6d.js');
require('../_chunks/dep-b08014cb.js');

var _ListItem = VueCompositionAPI.defineComponent({
  name: "TListItem",
  props: list_listItemProps["default"],
  setup: function setup(props2, _ref) {
    var emit = _ref.emit;
    var componentName = hooks_useConfig.usePrefixClass("list-item");
    var handleClick = function handleClick(e) {
      var _props2$onClick;
      emit("click", {
        e: e
      });
      (_props2$onClick = props2.onClick) === null || _props2$onClick === void 0 || _props2$onClick.call(props2, {
        e: e
      });
    };
    return {
      componentName: componentName,
      handleClick: handleClick
    };
  },
  render: function render() {
    var h = arguments[0];
    var componentName = this.componentName,
      handleClick = this.handleClick;
    var content = utils_renderTnode.renderContent(this, "default", "content");
    var propsActionContent = utils_renderTnode.renderTNodeJSX(this, "action");
    return h("li", {
      "class": componentName,
      "on": {
        "click": handleClick
      }
    }, [h("div", {
      "class": "".concat(componentName, "-main")
    }, [h("div", {
      "class": "".concat(componentName, "__content")
    }, [content]), propsActionContent && h("li", {
      "class": "".concat(componentName, "__action")
    }, [propsActionContent])])]);
  }
});

exports["default"] = _ListItem;
//# sourceMappingURL=list-item.js.map
