/**
 * tdesign v1.12.0
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var helper = require('../_chunks/dep-27ac0b8c.js');
var _defineProperty = require('@babel/runtime/helpers/defineProperty');
var VueCompositionAPI = require('@vue/composition-api');
var loading_index = require('../loading/index.js');
var list_listItem = require('./list-item.js');
var list_props = require('./props.js');
var list_const = require('./const.js');
var hooks_useConfig = require('../hooks/useConfig.js');
var list_hooks_useListVirtualScroll = require('./hooks/useListVirtualScroll.js');
var utils_renderTnode = require('../utils/render-tnode.js');
var list_hooks_useListItem = require('./hooks/useListItem.js');
var configProvider_useConfig = require('../config-provider/useConfig.js');
var isString = require('../_chunks/dep-2e662da4.js');
var omit = require('../_chunks/dep-11856238.js');
require('../loading/directive.js');
require('../loading/plugin.js');
require('vue');
require('../loading/loading.js');
require('../loading/icon/gradient.js');
require('../_common/js/loading/circle-adapter.js');
require('../_common/js/utils/setStyle.js');
require('../_common/js/utils/helper.js');
require('@babel/runtime/helpers/toConsumableArray');
require('@babel/runtime/helpers/objectWithoutProperties');
require('@babel/runtime/helpers/slicedToArray');
require('../_chunks/dep-caea5f4e.js');
require('../_chunks/dep-1fe4c69b.js');
require('../_chunks/dep-36c57efe.js');
require('../_chunks/dep-260a7245.js');
require('../_chunks/dep-31fa06d0.js');
require('@babel/runtime/helpers/typeof');
require('../_chunks/dep-f4d07ab0.js');
require('../config-provider/config-receiver.js');
require('../_chunks/dep-65c8d021.js');
require('../_common/js/global-config/default-config.js');
require('../_common/js/global-config/locale/zh_CN.js');
require('../_chunks/dep-bc99824f.js');
require('../_chunks/dep-4effc6c4.js');
require('dayjs');
require('../_chunks/dep-d59c4646.js');
require('../_chunks/dep-11382958.js');
require('../_chunks/dep-c272f99f.js');
require('../_chunks/dep-89b9f4de.js');
require('../_chunks/dep-1c1cc34f.js');
require('../_chunks/dep-ba816077.js');
require('../_chunks/dep-852fc6a9.js');
require('../_chunks/dep-c9d43e30.js');
require('../_chunks/dep-23d55f82.js');
require('../_chunks/dep-bc3ec918.js');
require('../_chunks/dep-f97b0058.js');
require('../_chunks/dep-9a119db9.js');
require('../_chunks/dep-49887b48.js');
require('../_chunks/dep-06c569d8.js');
require('../_chunks/dep-4d554a6f.js');
require('../_chunks/dep-7ec0f498.js');
require('../_chunks/dep-fcdc23bb.js');
require('../_chunks/dep-59f3051f.js');
require('../_chunks/dep-b86e0f9e.js');
require('../utils/mixins.js');
require('../utils/dom.js');
require('raf');
require('../utils/easing.js');
require('../utils/transfer-dom.js');
require('../loading/props.js');
require('../config.js');
require('@babel/runtime/helpers/readOnlyError');
require('../_chunks/dep-f0f28315.js');
require('../_chunks/dep-7ed5d19e.js');
require('../_chunks/dep-f8b182e9.js');
require('../_chunks/dep-0f4ac92d.js');
require('../_chunks/dep-2f28fbd7.js');
require('../_chunks/dep-76d8c62c.js');
require('../_chunks/dep-2f0c3d6d.js');
require('../_chunks/dep-b08014cb.js');
require('../_chunks/dep-029c3522.js');
require('../_chunks/dep-c63385b6.js');
require('../_chunks/dep-ab17e69e.js');
require('../_chunks/dep-87dae4a0.js');
require('../_chunks/dep-07989e63.js');
require('../_chunks/dep-d3e77112.js');
require('../_chunks/dep-b520fc3a.js');
require('../_chunks/dep-f2e07584.js');
require('../_chunks/dep-9a183e68.js');
require('../_chunks/dep-5c93d051.js');
require('../_chunks/dep-76dea031.js');
require('../_chunks/dep-56240b5e.js');
require('../_chunks/dep-81ddbae0.js');
require('../utils/withInstall.js');
require('./list-item-props.js');
require('../hooks/useVirtualScrollNew.js');
require('../hooks/useResizeObserver.js');
require('../utils/helper.js');
require('../_chunks/dep-b5cedeaa.js');
require('../_chunks/dep-0982adb4.js');
require('../_chunks/dep-bd4b64b6.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var _defineProperty__default = /*#__PURE__*/_interopDefaultLegacy(_defineProperty);

var _List = VueCompositionAPI.defineComponent({
  name: "TList",
  props: list_props["default"],
  setup: function setup(props2, _ref) {
    var emit = _ref.emit;
    var listRef = VueCompositionAPI.ref();
    var _useConfig = configProvider_useConfig.useConfig("list"),
      globalConfig = _useConfig.globalConfig;
    var componentName = hooks_useConfig.usePrefixClass("list");
    var _useCommonClassName = hooks_useConfig.useCommonClassName(),
      SIZE = _useCommonClassName.SIZE;
    var _useListItems = list_hooks_useListItem["default"](),
      listItems = _useListItems.listItems;
    var listClass = VueCompositionAPI.computed(function () {
      return ["".concat(componentName.value), SIZE.value[props2.size], _defineProperty__default["default"](_defineProperty__default["default"](_defineProperty__default["default"]({}, "".concat(componentName.value, "--split"), props2.split), "".concat(componentName.value, "--stripe"), props2.stripe), "".concat(componentName.value, "--vertical-action"), props2.layout === "vertical")];
    });
    var loadingClass = VueCompositionAPI.computed(function () {
      return isString.isString(props2.asyncLoading) && ["loading", "load-more"].includes(props2.asyncLoading) ? "".concat(componentName.value, "__load ").concat(componentName.value, "__load--").concat(props2.asyncLoading) : "".concat(componentName.value, "__load");
    });
    var _useListVirtualScroll = list_hooks_useListVirtualScroll["default"](props2.scroll, listRef, listItems),
      virtualConfig = _useListVirtualScroll.virtualConfig,
      cursorStyle = _useListVirtualScroll.cursorStyle,
      listStyle = _useListVirtualScroll.listStyle,
      isVirtualScroll = _useListVirtualScroll.isVirtualScroll,
      onInnerVirtualScroll = _useListVirtualScroll.onInnerVirtualScroll;
    var handleScroll = function handleScroll(e) {
      var _props2$onScroll;
      var listElement = e.target;
      var scrollTop = listElement.scrollTop,
        scrollHeight = listElement.scrollHeight,
        clientHeight = listElement.clientHeight;
      if (isVirtualScroll.value) onInnerVirtualScroll(e);
      var scrollParams = {
        e: e,
        scrollTop: scrollTop,
        scrollBottom: scrollHeight - clientHeight - scrollTop
      };
      emit("scroll", scrollParams);
      (_props2$onScroll = props2.onScroll) === null || _props2$onScroll === void 0 || _props2$onScroll.call(props2, scrollParams);
    };
    var handleLoadMore = function handleLoadMore(e) {
      var _props2$onLoadMore;
      if (isString.isString(props2.asyncLoading) && props2.asyncLoading !== list_const.LOAD_MORE) return;
      emit("load-more", {
        e: e
      });
      (_props2$onLoadMore = props2.onLoadMore) === null || _props2$onLoadMore === void 0 || _props2$onLoadMore.call(props2, {
        e: e
      });
    };
    return {
      componentName: componentName,
      listClass: listClass,
      loadingClass: loadingClass,
      handleScroll: handleScroll,
      handleLoadMore: handleLoadMore,
      listRef: listRef,
      globalConfig: globalConfig,
      virtualConfig: virtualConfig,
      cursorStyle: cursorStyle,
      listStyle: listStyle,
      isVirtualScroll: isVirtualScroll
    };
  },
  render: function render() {
    var _this = this;
    var h = arguments[0];
    var isVirtualScroll = this.isVirtualScroll,
      cursorStyle = this.cursorStyle,
      listStyle = this.listStyle,
      componentName = this.componentName,
      globalConfig = this.globalConfig,
      virtualConfig = this.virtualConfig;
    var propsHeaderContent = utils_renderTnode.renderTNodeJSX(this, "header");
    var propsFooterContent = utils_renderTnode.renderTNodeJSX(this, "footer");
    var renderLoading = function renderLoading() {
      if (_this.asyncLoading && isString.isString(_this.asyncLoading)) {
        if (_this.asyncLoading === list_const.LOADING) {
          return h("div", [h(loading_index.Loading), h("span", [globalConfig.loadingText])]);
        }
        if (_this.asyncLoading === list_const.LOAD_MORE) {
          return h("span", [globalConfig.loadingMoreText]);
        }
      }
      return utils_renderTnode.renderTNodeJSX(_this, "asyncLoading");
    };
    return h("div", {
      "class": this.listClass,
      "on": {
        "scroll": this.handleScroll
      },
      "ref": "listRef",
      "style": isVirtualScroll ? "position:relative" : void 0
    }, [propsHeaderContent ? h("div", {
      "class": "".concat(componentName, "__header")
    }, [propsHeaderContent]) : null, isVirtualScroll ? h("div", [h("div", {
      "style": cursorStyle
    }), h("ul", {
      "class": "".concat(componentName, "__inner"),
      "style": listStyle
    }, [virtualConfig.visibleData.value.map(function (item) {
      return h(list_listItem["default"], helper.helper([{}, omit.omit(item, "slots"), {
        "scopedSlots": {
          "default": item.slots
        }
      }]));
    })])]) : h("ul", {
      "class": "".concat(componentName, "__inner")
    }, [utils_renderTnode.renderTNodeJSX(this, "default")]), propsFooterContent ? h("div", {
      "class": "".concat(componentName, "__footer")
    }, [propsFooterContent]) : null, h("div", {
      "class": this.loadingClass,
      "on": {
        "click": this.handleLoadMore
      }
    }, [renderLoading()])]);
  }
});

exports["default"] = _List;
//# sourceMappingURL=list.js.map
