/**
 * tdesign v1.12.0
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var _toConsumableArray = require('@babel/runtime/helpers/toConsumableArray');
var VueCompositionAPI = require('@vue/composition-api');
var menu_headMenuProps = require('./head-menu-props.js');
var tabs_index = require('../tabs/index.js');
var utils_renderTnode = require('../utils/render-tnode.js');
var menu_vMenu = require('./v-menu.js');
var hooks_useConfig = require('../hooks/useConfig.js');
require('../tabs/tabs.js');
require('../_chunks/dep-27ac0b8c.js');
require('@babel/runtime/helpers/defineProperty');
require('vue');
require('../utils/helper.js');
require('@babel/runtime/helpers/objectWithoutProperties');
require('@babel/runtime/helpers/slicedToArray');
require('../_chunks/dep-f0f28315.js');
require('../_chunks/dep-7ed5d19e.js');
require('../_chunks/dep-f8b182e9.js');
require('../_chunks/dep-31fa06d0.js');
require('@babel/runtime/helpers/typeof');
require('../_chunks/dep-36c57efe.js');
require('../_chunks/dep-0f4ac92d.js');
require('../_chunks/dep-f4d07ab0.js');
require('../_chunks/dep-2f28fbd7.js');
require('../_chunks/dep-76d8c62c.js');
require('../_chunks/dep-2f0c3d6d.js');
require('../tabs/props.js');
require('../tabs/tab-panel.js');
require('../tabs/tab-panel-props.js');
require('../hooks/useDestroyOnClose.js');
require('../config-provider/config-receiver.js');
require('../_chunks/dep-65c8d021.js');
require('../_common/js/global-config/default-config.js');
require('../_common/js/global-config/locale/zh_CN.js');
require('../_chunks/dep-bc99824f.js');
require('../_chunks/dep-4effc6c4.js');
require('dayjs');
require('../_chunks/dep-d59c4646.js');
require('../_chunks/dep-11382958.js');
require('../_chunks/dep-c272f99f.js');
require('../_chunks/dep-89b9f4de.js');
require('../_chunks/dep-1c1cc34f.js');
require('../_chunks/dep-ba816077.js');
require('../_chunks/dep-852fc6a9.js');
require('../_chunks/dep-c9d43e30.js');
require('../_chunks/dep-23d55f82.js');
require('../_chunks/dep-bc3ec918.js');
require('../_chunks/dep-f97b0058.js');
require('../_chunks/dep-9a119db9.js');
require('../_chunks/dep-49887b48.js');
require('../_chunks/dep-06c569d8.js');
require('../_chunks/dep-4d554a6f.js');
require('../_chunks/dep-7ec0f498.js');
require('../_chunks/dep-fcdc23bb.js');
require('../_chunks/dep-59f3051f.js');
require('../_chunks/dep-b86e0f9e.js');
require('../utils/mixins.js');
require('../tabs/tab-nav.js');
require('tdesign-icons-vue');
require('../tabs/tab-nav-item.js');
require('../utils/event.js');
require('../utils/ripple.js');
require('../_common/js/utils/setStyle.js');
require('../config.js');
require('../_common/js/tabs/base.js');
require('../_chunks/dep-e9318595.js');
require('../_chunks/dep-50b0a969.js');
require('../utils/map-props.js');
require('../utils/withInstall.js');
require('@babel/runtime/helpers/readOnlyError');
require('../_chunks/dep-b08014cb.js');
require('@babel/runtime/helpers/classCallCheck');
require('@babel/runtime/helpers/createClass');
require('../config-provider/useConfig.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var _toConsumableArray__default = /*#__PURE__*/_interopDefaultLegacy(_toConsumableArray);

var _HeadMenu = VueCompositionAPI.defineComponent({
  name: "THeadMenu",
  props: menu_headMenuProps["default"],
  model: {
    prop: "value",
    event: "change"
  },
  components: {
    Tabs: tabs_index.Tabs,
    TabPanel: tabs_index.TabPanel
  },
  setup: function setup(props2, ctx) {
    var activeValue = VueCompositionAPI.ref(props2.defaultValue || props2.value);
    var activeValues = VueCompositionAPI.ref([]);
    var expandValues = VueCompositionAPI.ref(props2.defaultExpanded || props2.expanded || []);
    var classPrefix = hooks_useConfig.usePrefixClass();
    var theme = VueCompositionAPI.computed(function () {
      return props2.theme;
    });
    var menuClass = VueCompositionAPI.computed(function () {
      return ["".concat(classPrefix.value, "-menu"), "".concat(classPrefix.value, "-head-menu"), "".concat(classPrefix.value, "-menu--").concat(props2.theme)];
    });
    var mode = VueCompositionAPI.ref(props2.expandType);
    var submenu = VueCompositionAPI.reactive([]);
    var deliver = function deliver(evt) {
      var func = "on".concat(evt[0].toUpperCase() + evt.slice(1));
      return function (val) {
        if (typeof props2[func] === "function") {
          props2[func](val);
        }
        ctx.emit(evt, val);
      };
    };
    var emitChange = deliver("change");
    var emitExpand = deliver("expand");
    var vMenu = new menu_vMenu["default"]({
      isMutex: true,
      expandValues: expandValues.value
    });
    VueCompositionAPI.provide("TdMenu", {
      mode: mode,
      theme: theme,
      vMenu: vMenu,
      isHead: true,
      expandValues: expandValues,
      activeValue: activeValue,
      activeValues: activeValues,
      select: function select(value) {
        emitChange(value);
      },
      open: function open(value, type) {
        var expanded = _toConsumableArray__default["default"](expandValues.value);
        var index = expanded.indexOf(value);
        if (mode.value === "popup") {
          if (type === "add") {
            if (index === -1) {
              expanded.push(value);
            }
          } else if (type === "remove") {
            expanded.splice(index, 1);
          }
        } else {
          expanded.splice(0, 1);
          if (index === -1) {
            expanded.push(value);
          }
        }
        emitExpand(expanded);
      }
    });
    var handleTabChange = function handleTabChange(value) {
      emitChange(value);
    };
    var handleSubmenuExpand = function handleSubmenuExpand(value) {
      var ans = vMenu.getChild(value);
      submenu.length = 0;
      submenu.push.apply(submenu, _toConsumableArray__default["default"](ans));
    };
    VueCompositionAPI.watch(function () {
      return props2.expanded;
    }, function (value) {
      expandValues.value = value;
      if (mode.value === "normal") {
        handleSubmenuExpand(value[0]);
      }
    });
    var updateActiveValues = function updateActiveValues(value) {
      activeValue.value = value;
      activeValues.value = vMenu.select(value);
    };
    VueCompositionAPI.watch(function () {
      return props2.value;
    }, updateActiveValues);
    VueCompositionAPI.watch(function () {
      return props2.defaultValue;
    }, updateActiveValues);
    VueCompositionAPI.watch(function () {
      return props2.expandType;
    }, function (value) {
      mode.value = value;
    });
    VueCompositionAPI.onMounted(function () {
      var _expandValues$value;
      activeValues.value = vMenu.select(activeValue.value);
      if (((_expandValues$value = expandValues.value) === null || _expandValues$value === void 0 ? void 0 : _expandValues$value.length) > 0) {
        handleSubmenuExpand(expandValues.value[0]);
      }
    });
    return {
      mode: mode,
      menuClass: menuClass,
      expandValues: expandValues,
      activeValue: activeValue,
      activeValues: activeValues,
      submenu: submenu,
      handleTabChange: handleTabChange,
      classPrefix: classPrefix
    };
  },
  methods: {
    renderNormalSubmenu: function renderNormalSubmenu(node, depth) {
      var _this = this;
      var h = this.$createElement;
      if (node.length === 0) return null;
      return h("ul", {
        "class": ["".concat(this.classPrefix, "-head-menu__submenu"), "".concat(this.classPrefix, "-submenu")]
      }, [h("t-tabs", {
        "attrs": {
          "value": this.activeValues[depth]
        },
        "on": {
          "change": this.handleTabChange
        }
      }, [node.map(function (item) {
        return h("t-tab-panel", {
          "attrs": {
            "value": item.value,
            "label": typeof item.vnode === "string" ? item.vnode : item.vnode[0].text
          }
        }, [item.children && item.children.length > 0 ? _this.renderNormalSubmenu(item.children, depth + 1) : null]);
      })])]);
    }
  },
  render: function render() {
    var h = arguments[0];
    if (this.$slots.options) {
      console.warn("TDesign Warn: `options` slot is going to be deprecated, please use `operations` for slot instead.");
    }
    var operations = utils_renderTnode.renderContent(this, "operations", "options");
    var logo = utils_renderTnode.renderTNodeJSX(this, "logo");
    return h("div", {
      "class": this.menuClass
    }, [h("div", {
      "class": "".concat(this.classPrefix, "-head-menu__inner")
    }, [logo && h("div", {
      "class": "".concat(this.classPrefix, "-menu__logo")
    }, [logo]), h("ul", {
      "class": "".concat(this.classPrefix, "-menu")
    }, [utils_renderTnode.renderContent(this, "default", "content")]), operations && h("div", {
      "class": "".concat(this.classPrefix, "-menu__operations")
    }, [operations])]), this.mode === "normal" && this.renderNormalSubmenu(this.submenu, 1)]);
  }
});

exports["default"] = _HeadMenu;
//# sourceMappingURL=head-menu.js.map
