/**
 * tdesign v1.12.0
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var _defineProperty = require('@babel/runtime/helpers/defineProperty');
var VueCompositionAPI = require('@vue/composition-api');
var menu_menuItemProps = require('./menu-item-props.js');
var utils_ripple = require('../utils/ripple.js');
var utils_renderTnode = require('../utils/render-tnode.js');
var configProvider_configReceiver = require('../config-provider/config-receiver.js');
var hooks_useConfig = require('../hooks/useConfig.js');
var tooltip_index = require('../tooltip/index.js');
require('../_common/js/utils/setStyle.js');
require('../config.js');
require('@babel/runtime/helpers/readOnlyError');
require('@babel/runtime/helpers/typeof');
require('vue');
require('../_chunks/dep-f0f28315.js');
require('../_chunks/dep-7ed5d19e.js');
require('../_chunks/dep-f8b182e9.js');
require('../_chunks/dep-31fa06d0.js');
require('../_chunks/dep-36c57efe.js');
require('../_chunks/dep-0f4ac92d.js');
require('../_chunks/dep-f4d07ab0.js');
require('../_chunks/dep-2f28fbd7.js');
require('../_chunks/dep-76d8c62c.js');
require('../_chunks/dep-2f0c3d6d.js');
require('../_chunks/dep-b08014cb.js');
require('../_chunks/dep-65c8d021.js');
require('../_common/js/global-config/default-config.js');
require('../_common/js/global-config/locale/zh_CN.js');
require('../_chunks/dep-bc99824f.js');
require('../_chunks/dep-4effc6c4.js');
require('dayjs');
require('../_chunks/dep-d59c4646.js');
require('../_chunks/dep-11382958.js');
require('../_chunks/dep-c272f99f.js');
require('../_chunks/dep-89b9f4de.js');
require('../_chunks/dep-1c1cc34f.js');
require('../_chunks/dep-ba816077.js');
require('../_chunks/dep-852fc6a9.js');
require('../_chunks/dep-c9d43e30.js');
require('../_chunks/dep-23d55f82.js');
require('../_chunks/dep-bc3ec918.js');
require('../_chunks/dep-f97b0058.js');
require('../_chunks/dep-9a119db9.js');
require('../_chunks/dep-49887b48.js');
require('../_chunks/dep-06c569d8.js');
require('../_chunks/dep-4d554a6f.js');
require('../_chunks/dep-7ec0f498.js');
require('../_chunks/dep-fcdc23bb.js');
require('../_chunks/dep-59f3051f.js');
require('../_chunks/dep-b86e0f9e.js');
require('../config-provider/useConfig.js');
require('../tooltip/tooltip.js');
require('../_chunks/dep-27ac0b8c.js');
require('../tooltip/props.js');
require('../popup/props.js');
require('../popup/popup.js');
require('@popperjs/core');
require('../utils/dom.js');
require('raf');
require('../utils/easing.js');
require('../_chunks/dep-2e662da4.js');
require('../utils/helper.js');
require('@babel/runtime/helpers/objectWithoutProperties');
require('@babel/runtime/helpers/slicedToArray');
require('../popup/container.js');
require('../utils/mixins.js');
require('../utils/event.js');
require('../popup/utils.js');
require('../_chunks/dep-e9318595.js');
require('../_chunks/dep-50b0a969.js');
require('../utils/map-props.js');
require('../utils/withInstall.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var _defineProperty__default = /*#__PURE__*/_interopDefaultLegacy(_defineProperty);

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty__default["default"](e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var keepAnimationMixins = configProvider_configReceiver.getKeepAnimationMixins();
var _MenuItem = VueCompositionAPI.defineComponent({
  name: "TMenuItem",
  mixins: [keepAnimationMixins],
  props: _objectSpread({}, menu_menuItemProps["default"]),
  directives: {
    ripple: utils_ripple["default"]
  },
  setup: function setup(props2, ctx) {
    var menu = VueCompositionAPI.inject("TdMenu");
    var submenu = VueCompositionAPI.inject("TdSubmenu", null);
    var active = VueCompositionAPI.computed(function () {
      return menu.activeValue.value === props2.value;
    });
    var collapsed = VueCompositionAPI.computed(function () {
      var _menu$collapsed;
      return (_menu$collapsed = menu.collapsed) === null || _menu$collapsed === void 0 ? void 0 : _menu$collapsed.value;
    });
    var classPrefix = hooks_useConfig.usePrefixClass();
    var classes = VueCompositionAPI.computed(function () {
      return ["".concat(classPrefix.value, "-menu__item"), _defineProperty__default["default"](_defineProperty__default["default"](_defineProperty__default["default"](_defineProperty__default["default"]({}, "".concat(classPrefix.value, "-is-active"), active.value), "".concat(classPrefix.value, "-is-disabled"), props2.disabled), "".concat(classPrefix.value, "-menu__item--plain"), !ctx.slots.icon && !props2.icon), "".concat(classPrefix.value, "-submenu__item"), !!submenu && !menu.isHead)];
    });
    var handleClick = function handleClick(e) {
      var _props2$onClick, _submenu$closeParentP;
      e.stopPropagation();
      if (props2.disabled) return;
      if (menu.activeValue.value !== props2.value) {
        menu.select(props2.value);
      }
      ctx.emit("click", {
        e: e,
        value: props2.value
      });
      (_props2$onClick = props2.onClick) === null || _props2$onClick === void 0 || _props2$onClick.call(props2, {
        e: e,
        value: props2.value
      });
      if (props2.to || props2.routerLink && props2.href) {
        var router = props2.router || ctx.root.$router;
        var methods = props2.replace ? "replace" : "push";
        router[methods](props2.to || props2.href)["catch"](function (err) {
          if (err.name !== "NavigationDuplicated" && !err.message.includes("Avoided redundant navigation to current location")) {
            throw err;
          }
        });
      }
      submenu === null || submenu === void 0 || (_submenu$closeParentP = submenu.closeParentPopup) === null || _submenu$closeParentP === void 0 || _submenu$closeParentP.call(submenu, e);
    };
    VueCompositionAPI.onMounted(function () {
      var _menu$vMenu;
      menu === null || menu === void 0 || (_menu$vMenu = menu.vMenu) === null || _menu$vMenu === void 0 || _menu$vMenu.add({
        value: props2.value,
        parent: submenu === null || submenu === void 0 ? void 0 : submenu.value,
        vnode: ctx.slots["default"] && ctx.slots["default"]()
      });
    });
    return {
      menu: menu,
      active: active,
      collapsed: collapsed,
      classes: classes,
      handleClick: handleClick,
      classPrefix: classPrefix
    };
  },
  render: function render() {
    var _this = this,
      _this$$parent$$vnode;
    var h = arguments[0];
    var router = this.router || this.$router;
    var liContent = h("li", {
      "directives": [{
        name: "ripple",
        value: this.keepAnimation.ripple
      }],
      "class": this.classes,
      "on": {
        "click": this.handleClick
      }
    }, [utils_renderTnode.renderTNodeJSX(this, "icon"), this.routerLink ? h("a", {
      "attrs": {
        "href": this.href ? this.href : this.to ? router === null || router === void 0 ? void 0 : router.resolve(this.to).href : "",
        "target": this.target
      },
      "class": "".concat(this.classPrefix, "-menu__item-link"),
      "on": {
        "click": function click(e) {
          return e.preventDefault();
        }
      }
    }, [h("span", {
      "class": "".concat(this.classPrefix, "-menu__content")
    }, [utils_renderTnode.renderContent(this, "default", "content")])]) : this.href ? h("a", {
      "attrs": {
        "href": this.href,
        "target": this.target
      },
      "class": "".concat(this.classPrefix, "-menu__item-link"),
      "on": {
        "click": function click(e) {
          return _this.disabled && e.preventDefault();
        }
      }
    }, [h("span", {
      "class": "".concat(this.classPrefix, "-menu__content")
    }, [utils_renderTnode.renderContent(this, "default", "content")])]) : h("span", {
      "class": "".concat(this.classPrefix, "-menu__content")
    }, [utils_renderTnode.renderContent(this, "default", "content")])]);
    if (this.collapsed && /tmenu/i.test((_this$$parent$$vnode = this.$parent.$vnode) === null || _this$$parent$$vnode === void 0 ? void 0 : _this$$parent$$vnode.tag)) {
      return h(tooltip_index.Tooltip, {
        "attrs": {
          "content": function content() {
            return utils_renderTnode.renderContent(_this, "default", "content");
          },
          "placement": "right"
        }
      }, [liContent]);
    }
    return liContent;
  }
});

exports["default"] = _MenuItem;
//# sourceMappingURL=menu-item.js.map
