/**
 * tdesign v1.12.0
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var _asyncToGenerator = require('@babel/runtime/helpers/asyncToGenerator');
var helper = require('../_chunks/dep-27ac0b8c.js');
var _defineProperty = require('@babel/runtime/helpers/defineProperty');
var _regeneratorRuntime = require('@babel/runtime/regenerator');
var VueCompositionAPI = require('@vue/composition-api');
var hooks_useResizeObserver = require('../hooks/useResizeObserver.js');
var radio_radioGroupProps = require('./radio-group-props.js');
var radio_radio = require('./radio.js');
var radio_radioButton = require('./radio-button.js');
var utils_event = require('../utils/event.js');
var configProvider_configReceiver = require('../config-provider/config-receiver.js');
var utils_mixins = require('../utils/mixins.js');
var utils_dom = require('../utils/dom.js');
var _common_js_common = require('../_common/js/common.js');
var isNumber = require('../_chunks/dep-260a7245.js');
var isString = require('../_chunks/dep-2e662da4.js');
var throttle = require('../_chunks/dep-b286149a.js');
require('vue');
require('../utils/helper.js');
require('@babel/runtime/helpers/objectWithoutProperties');
require('@babel/runtime/helpers/slicedToArray');
require('../_chunks/dep-f0f28315.js');
require('../_chunks/dep-7ed5d19e.js');
require('../_chunks/dep-f8b182e9.js');
require('../_chunks/dep-31fa06d0.js');
require('@babel/runtime/helpers/typeof');
require('../_chunks/dep-36c57efe.js');
require('../_chunks/dep-0f4ac92d.js');
require('../_chunks/dep-f4d07ab0.js');
require('../_chunks/dep-2f28fbd7.js');
require('../_chunks/dep-76d8c62c.js');
require('../_chunks/dep-2f0c3d6d.js');
require('../utils/render-tnode.js');
require('@babel/runtime/helpers/readOnlyError');
require('../_chunks/dep-b08014cb.js');
require('./props.js');
require('../_chunks/dep-65c8d021.js');
require('../_common/js/global-config/default-config.js');
require('../_common/js/global-config/locale/zh_CN.js');
require('../_chunks/dep-bc99824f.js');
require('../_chunks/dep-4effc6c4.js');
require('dayjs');
require('../_chunks/dep-d59c4646.js');
require('../_chunks/dep-11382958.js');
require('../_chunks/dep-c272f99f.js');
require('../_chunks/dep-89b9f4de.js');
require('../_chunks/dep-1c1cc34f.js');
require('../_chunks/dep-ba816077.js');
require('../_chunks/dep-852fc6a9.js');
require('../_chunks/dep-c9d43e30.js');
require('../_chunks/dep-23d55f82.js');
require('../_chunks/dep-bc3ec918.js');
require('../_chunks/dep-f97b0058.js');
require('../_chunks/dep-9a119db9.js');
require('../_chunks/dep-49887b48.js');
require('../_chunks/dep-06c569d8.js');
require('../_chunks/dep-4d554a6f.js');
require('../_chunks/dep-7ec0f498.js');
require('../_chunks/dep-fcdc23bb.js');
require('../_chunks/dep-59f3051f.js');
require('../_chunks/dep-b86e0f9e.js');
require('raf');
require('../utils/easing.js');
require('../_chunks/dep-e9318595.js');
require('../_chunks/dep-50b0a969.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var _asyncToGenerator__default = /*#__PURE__*/_interopDefaultLegacy(_asyncToGenerator);
var _defineProperty__default = /*#__PURE__*/_interopDefaultLegacy(_defineProperty);
var _regeneratorRuntime__default = /*#__PURE__*/_interopDefaultLegacy(_regeneratorRuntime);

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty__default["default"](e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var classPrefixMixins = configProvider_configReceiver.getClassPrefixMixins("radio-group");
var _RadioGroup = utils_mixins["default"](classPrefixMixins).extend({
  name: "TRadioGroup",
  props: _objectSpread({}, radio_radioGroupProps["default"]),
  components: {
    Radio: radio_radio["default"]
  },
  provide: function provide() {
    return {
      radioGroup: this
    };
  },
  data: function data() {
    return {
      radioGroupEl: VueCompositionAPI.ref(null),
      barStyle: {
        width: "0px",
        left: "0px"
      }
    };
  },
  computed: {
    checkedClassName: function checkedClassName() {
      return ".".concat(this.classPrefix, "-radio-button.").concat(this.commonStatusClassName.checked);
    }
  },
  render: function render(h) {
    var _this = this;
    var $scopedSlots = this.$scopedSlots;
    var children = $scopedSlots["default"] && $scopedSlots["default"](null);
    if (this.options && this.options.length) {
      children = this.options.map(function (option, index) {
        var opt = option;
        if (isNumber.isNumber(option) || isString.isString(option)) {
          opt = {
            value: option,
            label: option.toString()
          };
        }
        var RadioComponent = _this.theme === "button" ? radio_radioButton["default"] : radio_radio["default"];
        return h(RadioComponent, helper.helper([{}, {
          "props": option
        }, {
          "key": "radio-group-options-".concat(opt.value, "-").concat(index),
          "attrs": {
            "name": _this.name,
            "checked": _this.value === opt.value,
            "disabled": "disabled" in opt ? opt.disabled : _this.disabled,
            "value": opt.value
          }
        }]), [typeof opt.label === "function" ? opt.label(h) : opt.label]);
      });
    }
    var groupClass = ["".concat(this.componentName), this.commonSizeClassName[this.size], _defineProperty__default["default"](_defineProperty__default["default"](_defineProperty__default["default"]({}, "".concat(this.componentName, "__outline"), this.variant === "outline"), "".concat(this.componentName, "--filled"), this.variant.includes("filled")), "".concat(this.componentName, "--primary-filled"), this.variant === "primary-filled")];
    if (this.variant.includes("filled")) {
      children && children.push(h("div", {
        "style": this.barStyle,
        "class": "".concat(this.componentName, "__bg-block")
      }));
    }
    return h("div", {
      "class": groupClass
    }, [children]);
  },
  watch: {
    value: function value() {
      var _this2 = this;
      this.$nextTick(function () {
        return _this2.calcBarStyle();
      });
    }
  },
  mounted: function mounted() {
    var _this3 = this;
    this.calcBarStyle();
    this.radioGroupEl.value = this.$el;
    hooks_useResizeObserver["default"](this.radioGroupEl, throttle.throttle(/*#__PURE__*/_asyncToGenerator__default["default"](/*#__PURE__*/_regeneratorRuntime__default["default"].mark(function _callee() {
      return _regeneratorRuntime__default["default"].wrap(function (_context) {
        while (1) switch (_context.prev = _context.next) {
          case 0:
            _this3.$nextTick(function () {
              return _this3.calcBarStyle();
            });
          case 1:
          case "end":
            return _context.stop();
        }
      }, _callee);
    })), 300));
    this.addKeyboardListeners();
  },
  beforeDestroy: function beforeDestroy() {
    this.removeKeyboardListeners();
  },
  methods: {
    addKeyboardListeners: function addKeyboardListeners() {
      utils_dom.on(this.$el, "keydown", this.checkRadioInGroup);
    },
    removeKeyboardListeners: function removeKeyboardListeners() {
      utils_dom.off(this.$el, "keydown", this.checkRadioInGroup);
    },
    checkRadioInGroup: function checkRadioInGroup(e) {
      var isCheckedCode = _common_js_common.CHECKED_CODE_REG.test(e.key) || _common_js_common.CHECKED_CODE_REG.test(e.code);
      if (isCheckedCode) {
        e.preventDefault();
        var inputNode = e.target.querySelector("input");
        var data = inputNode.dataset;
        if (inputNode.checked && data.allowUncheck) {
          this.handleRadioChange(void 0, {
            e: e
          });
        } else {
          var value = !isNaN(Number(data.value)) ? Number(data.value) : data.value;
          value = typeof value === "string" && {
            "true": true,
            "false": false
          }[value] || value;
          value = typeof value === "string" && value[0] === "'" ? value.replace(/'/g, "") : value;
          this.handleRadioChange(value, {
            e: e
          });
        }
      }
    },
    handleRadioChange: function handleRadioChange(value, context) {
      utils_event.emitEvent(this, "change", value, context);
    },
    calcDefaultBarStyle: function calcDefaultBarStyle() {
      var defaultNode = this.$el.cloneNode(true);
      var div = document.createElement("div");
      div.setAttribute("style", "position: absolute; visibility: hidden;");
      div.appendChild(defaultNode);
      document.body.appendChild(div);
      var defaultCheckedRadio = div.querySelector(this.checkedClassName);
      var offsetWidth = defaultCheckedRadio.offsetWidth,
        offsetLeft = defaultCheckedRadio.offsetLeft;
      document.body.removeChild(div);
      return {
        offsetWidth: offsetWidth,
        offsetLeft: offsetLeft
      };
    },
    calcBarStyle: function calcBarStyle() {
      if (this.variant === "outline") return;
      var checkedRadio = this.$el.querySelector(this.checkedClassName);
      if (!checkedRadio) return;
      var offsetWidth = checkedRadio.offsetWidth,
        offsetLeft = checkedRadio.offsetLeft;
      if (!offsetWidth) {
        var _this$calcDefaultBarS = this.calcDefaultBarStyle(),
          width2 = _this$calcDefaultBarS.offsetWidth,
          left2 = _this$calcDefaultBarS.offsetLeft;
        offsetWidth = width2;
        offsetLeft = left2;
      }
      var width = "".concat(offsetWidth, "px");
      var left = "".concat(offsetLeft, "px");
      if (this.barStyle.width === width && this.barStyle.left === left) return;
      this.barStyle = {
        width: width,
        left: left
      };
    }
  }
});

exports["default"] = _RadioGroup;
//# sourceMappingURL=group.js.map
