/**
 * tdesign v1.12.0
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var _toConsumableArray = require('@babel/runtime/helpers/toConsumableArray');
var _slicedToArray = require('@babel/runtime/helpers/slicedToArray');
var _defineProperty = require('@babel/runtime/helpers/defineProperty');
var VueCompositionAPI = require('@vue/composition-api');
var tdesignIconsVue = require('tdesign-icons-vue');
var hooks_useVModel = require('../hooks/useVModel.js');
var rate_props = require('./props.js');
var configProvider_useConfig = require('../config-provider/useConfig.js');
var tooltip_index = require('../tooltip/index.js');
var utils_renderTnode = require('../utils/render-tnode.js');
require('../_chunks/dep-b08014cb.js');
require('../_chunks/dep-2f0c3d6d.js');
require('../_chunks/dep-f8b182e9.js');
require('../_chunks/dep-31fa06d0.js');
require('@babel/runtime/helpers/typeof');
require('../_chunks/dep-36c57efe.js');
require('../_chunks/dep-0f4ac92d.js');
require('../_chunks/dep-f4d07ab0.js');
require('../_chunks/dep-65c8d021.js');
require('../_common/js/global-config/default-config.js');
require('../_common/js/global-config/locale/zh_CN.js');
require('../_chunks/dep-bc99824f.js');
require('../_chunks/dep-4effc6c4.js');
require('dayjs');
require('../_chunks/dep-d59c4646.js');
require('../_chunks/dep-11382958.js');
require('../_chunks/dep-c272f99f.js');
require('../_chunks/dep-89b9f4de.js');
require('../_chunks/dep-1c1cc34f.js');
require('../_chunks/dep-ba816077.js');
require('../_chunks/dep-852fc6a9.js');
require('../_chunks/dep-c9d43e30.js');
require('../_chunks/dep-23d55f82.js');
require('../_chunks/dep-bc3ec918.js');
require('../_chunks/dep-f97b0058.js');
require('../_chunks/dep-9a119db9.js');
require('../_chunks/dep-49887b48.js');
require('../_chunks/dep-06c569d8.js');
require('../_chunks/dep-4d554a6f.js');
require('../_chunks/dep-7ec0f498.js');
require('../_chunks/dep-fcdc23bb.js');
require('../_chunks/dep-59f3051f.js');
require('../_chunks/dep-b86e0f9e.js');
require('../tooltip/tooltip.js');
require('../_chunks/dep-27ac0b8c.js');
require('../tooltip/props.js');
require('../popup/props.js');
require('../popup/popup.js');
require('@popperjs/core');
require('../utils/dom.js');
require('vue');
require('raf');
require('../utils/easing.js');
require('../_chunks/dep-2e662da4.js');
require('../utils/helper.js');
require('@babel/runtime/helpers/objectWithoutProperties');
require('../_chunks/dep-f0f28315.js');
require('../_chunks/dep-7ed5d19e.js');
require('../_chunks/dep-2f28fbd7.js');
require('../_chunks/dep-76d8c62c.js');
require('../_common/js/utils/setStyle.js');
require('../popup/container.js');
require('../config-provider/config-receiver.js');
require('../utils/mixins.js');
require('../utils/event.js');
require('../popup/utils.js');
require('../_chunks/dep-e9318595.js');
require('../_chunks/dep-50b0a969.js');
require('@babel/runtime/helpers/readOnlyError');
require('../utils/map-props.js');
require('../utils/withInstall.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var _toConsumableArray__default = /*#__PURE__*/_interopDefaultLegacy(_toConsumableArray);
var _slicedToArray__default = /*#__PURE__*/_interopDefaultLegacy(_slicedToArray);
var _defineProperty__default = /*#__PURE__*/_interopDefaultLegacy(_defineProperty);

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty__default["default"](e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var _Rate = VueCompositionAPI.defineComponent({
  name: "TRate",
  props: _objectSpread({}, rate_props["default"]),
  setup: function setup(props2) {
    var activeColor = Array.isArray(props2.color) ? props2.color[0] : props2.color;
    var defaultColor = Array.isArray(props2.color) ? props2.color[1] : "var(--td-bg-color-component)";
    var _toRefs = VueCompositionAPI.toRefs(props2),
      inputValue = _toRefs.value;
    var _useVModel = hooks_useVModel.useVModel(inputValue, props2.defaultValue, props2.onChange, "change"),
      _useVModel2 = _slicedToArray__default["default"](_useVModel, 2),
      starValue = _useVModel2[0],
      setStarValue = _useVModel2[1];
    var hoverValue = VueCompositionAPI.ref(void 0);
    var rootRef = VueCompositionAPI.ref();
    var _useConfig = configProvider_useConfig.useConfig("classPrefix"),
      classPrefix = _useConfig.classPrefix;
    var _useConfig2 = configProvider_useConfig.useConfig("rate"),
      global = _useConfig2.global;
    var displayValue = VueCompositionAPI.computed(function () {
      return Number(hoverValue.value || starValue.value);
    });
    var displayText = VueCompositionAPI.computed(function () {
      return props2.texts.length === 0 ? global.value.rateText : props2.texts;
    });
    var getStarValue = function getStarValue(event, index) {
      if (props2.allowHalf) {
        var _rootRef$value, _rootRef$value$getBou2, _firstStar$getBoundin2;
        var _rootRef$value$getBou = (_rootRef$value = rootRef.value) === null || _rootRef$value === void 0 || (_rootRef$value$getBou2 = _rootRef$value.getBoundingClientRect) === null || _rootRef$value$getBou2 === void 0 ? void 0 : _rootRef$value$getBou2.call(_rootRef$value),
          left = _rootRef$value$getBou.left;
        var firstStar = rootRef.value.firstChild.nextSibling;
        var _firstStar$getBoundin = firstStar === null || firstStar === void 0 || (_firstStar$getBoundin2 = firstStar.getBoundingClientRect) === null || _firstStar$getBoundin2 === void 0 ? void 0 : _firstStar$getBoundin2.call(firstStar),
          width = _firstStar$getBoundin.width;
        var clientX = event.clientX;
        var starMiddle = width * (index - 0.5) + props2.gap * (index - 1);
        if (clientX - left >= starMiddle) return index;
        if (clientX - left < starMiddle) return index - 0.5;
      }
      return index;
    };
    var mouseEnterHandler = function mouseEnterHandler(event, index) {
      if (props2.disabled) return;
      hoverValue.value = getStarValue(event, index);
    };
    var mouseLeaveHandler = function mouseLeaveHandler() {
      if (props2.disabled) return;
      hoverValue.value = void 0;
    };
    var clickHandler = function clickHandler(event, index) {
      if (props2.disabled) return;
      var value = getStarValue(event, index);
      if (props2.clearable && value === starValue.value) {
        hoverValue.value = void 0;
        setStarValue(0);
      } else {
        setStarValue(value);
      }
    };
    var getStarCls = function getStarCls(index) {
      if (props2.allowHalf && index + 0.5 === displayValue.value) return "".concat(classPrefix.value, "-rate__item--half");
      if (index >= displayValue.value) return "";
      if (index < displayValue.value) return "".concat(classPrefix.value, "-rate__item--full");
    };
    var activeIconStyle = VueCompositionAPI.computed(function () {
      return {
        fontSize: props2.size,
        color: activeColor
      };
    });
    var inactiveIconStyle = VueCompositionAPI.computed(function () {
      return {
        fontSize: props2.size,
        color: defaultColor
      };
    });
    return {
      classPrefix: classPrefix,
      mouseLeaveHandler: mouseLeaveHandler,
      getStarCls: getStarCls,
      clickHandler: clickHandler,
      mouseEnterHandler: mouseEnterHandler,
      activeColor: activeColor,
      defaultColor: defaultColor,
      displayText: displayText,
      displayValue: displayValue,
      rootRef: rootRef,
      activeIconStyle: activeIconStyle,
      inactiveIconStyle: inactiveIconStyle
    };
  },
  methods: {
    renderRateIcon: function renderRateIcon() {
      var h = this.$createElement;
      return utils_renderTnode.renderTNodeJSXDefault(this, "icon", h(tdesignIconsVue.StarFilledIcon));
    }
  },
  render: function render() {
    var _this = this;
    var h = arguments[0];
    var classPrefix = this.classPrefix,
      mouseLeaveHandler = this.mouseLeaveHandler,
      getStarCls = this.getStarCls,
      clickHandler = this.clickHandler,
      mouseEnterHandler = this.mouseEnterHandler,
      displayText = this.displayText,
      displayValue = this.displayValue;
    return h("div", {
      "class": "".concat(classPrefix, "-rate"),
      "on": {
        "mouseleave": mouseLeaveHandler
      }
    }, [h("ul", {
      "class": "".concat(classPrefix, "-rate__list"),
      "style": {
        gap: "".concat(this.gap, "px")
      },
      "ref": "rootRef"
    }, [_toConsumableArray__default["default"](Array(Number(this.count))).map(function (_, index) {
      return h("li", {
        "key": index,
        "class": ["".concat(classPrefix, "-rate__item"), getStarCls(index)],
        "on": {
          "click": function click(event) {
            return clickHandler(event, index + 1);
          },
          "mousemove": function mousemove(event) {
            return mouseEnterHandler(event, index + 1);
          }
        }
      }, [_this.showText ? h(tooltip_index.Tooltip, {
        "key": index,
        "attrs": {
          "content": displayText[displayValue - 1]
        }
      }, [h("div", {
        "class": "".concat(classPrefix, "-rate__star-top"),
        "style": _objectSpread({}, _this.activeIconStyle)
      }, [_this.renderRateIcon()]), h("div", {
        "class": "".concat(classPrefix, "-rate__star-bottom"),
        "style": _objectSpread({}, _this.inactiveIconStyle)
      }, [_this.renderRateIcon()])]) : h("div", [h("div", {
        "class": "".concat(classPrefix, "-rate__star-top"),
        "style": _objectSpread({}, _this.activeIconStyle)
      }, [_this.renderRateIcon()]), h("div", {
        "class": "".concat(classPrefix, "-rate__star-bottom"),
        "style": _objectSpread({}, _this.inactiveIconStyle)
      }, [_this.renderRateIcon()])])]);
    })]), this.showText && h("div", {
      "class": "".concat(classPrefix, "-rate__text")
    }, [displayText[displayValue - 1]])]);
  }
});

exports["default"] = _Rate;
//# sourceMappingURL=rate.js.map
