/**
 * tdesign v1.12.0
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var _defineProperty = require('@babel/runtime/helpers/defineProperty');
var VueCompositionAPI = require('@vue/composition-api');
var utils_helper = require('../../utils/helper.js');
var select_option = require('../option.js');
var select_optionGroup = require('../optionGroup.js');
var omit = require('../../_chunks/dep-11856238.js');
var get = require('../../_chunks/dep-5c93d051.js');
require('@babel/runtime/helpers/objectWithoutProperties');
require('@babel/runtime/helpers/slicedToArray');
require('../../_chunks/dep-f0f28315.js');
require('../../_chunks/dep-7ed5d19e.js');
require('../../_chunks/dep-f8b182e9.js');
require('../../_chunks/dep-31fa06d0.js');
require('@babel/runtime/helpers/typeof');
require('../../_chunks/dep-36c57efe.js');
require('../../_chunks/dep-0f4ac92d.js');
require('../../_chunks/dep-f4d07ab0.js');
require('../../_chunks/dep-2f28fbd7.js');
require('../../_chunks/dep-76d8c62c.js');
require('../../_chunks/dep-2f0c3d6d.js');
require('../../utils/render-tnode.js');
require('@babel/runtime/helpers/readOnlyError');
require('vue');
require('../../_chunks/dep-b08014cb.js');
require('../../utils/ripple.js');
require('../../_common/js/utils/setStyle.js');
require('../../config.js');
require('../../config-provider/config-receiver.js');
require('../../_chunks/dep-65c8d021.js');
require('../../_common/js/global-config/default-config.js');
require('../../_common/js/global-config/locale/zh_CN.js');
require('../../_chunks/dep-bc99824f.js');
require('../../_chunks/dep-4effc6c4.js');
require('dayjs');
require('../../_chunks/dep-d59c4646.js');
require('../../_chunks/dep-11382958.js');
require('../../_chunks/dep-c272f99f.js');
require('../../_chunks/dep-89b9f4de.js');
require('../../_chunks/dep-1c1cc34f.js');
require('../../_chunks/dep-ba816077.js');
require('../../_chunks/dep-852fc6a9.js');
require('../../_chunks/dep-c9d43e30.js');
require('../../_chunks/dep-23d55f82.js');
require('../../_chunks/dep-bc3ec918.js');
require('../../_chunks/dep-f97b0058.js');
require('../../_chunks/dep-9a119db9.js');
require('../../_chunks/dep-49887b48.js');
require('../../_chunks/dep-06c569d8.js');
require('../../_chunks/dep-4d554a6f.js');
require('../../_chunks/dep-7ec0f498.js');
require('../../_chunks/dep-fcdc23bb.js');
require('../../_chunks/dep-59f3051f.js');
require('../../_chunks/dep-b86e0f9e.js');
require('../option-props.js');
require('../../checkbox/index.js');
require('../../checkbox/group.js');
require('../../_chunks/dep-27ac0b8c.js');
require('@babel/runtime/helpers/toConsumableArray');
require('../../checkbox/checkbox.js');
require('../../checkbox/props.js');
require('../../checkbox/constants.js');
require('../../checkbox/store.js');
require('@babel/runtime/helpers/classCallCheck');
require('@babel/runtime/helpers/createClass');
require('../../checkbox/hooks/useKeyboardEvent.js');
require('../../_common/js/common.js');
require('../../hooks/useConfig.js');
require('../../config-provider/useConfig.js');
require('../../hooks/useVModel.js');
require('../../hooks/useFormDisabled.js');
require('../../hooks/useElementLazyRender.js');
require('../../_common/js/utils/observe.js');
require('../../checkbox/checkbox-group-props.js');
require('../../_chunks/dep-49944b19.js');
require('../../_chunks/dep-ab17e69e.js');
require('../../_chunks/dep-195eea38.js');
require('../../_chunks/dep-caea5f4e.js');
require('../../hooks/slots.js');
require('../../utils/withInstall.js');
require('../../hooks/useLazyLoad.js');
require('../util.js');
require('../../_chunks/dep-bdfb7a98.js');
require('../../_chunks/dep-b5cedeaa.js');
require('../../_chunks/dep-07989e63.js');
require('../../_chunks/dep-d3e77112.js');
require('../../_chunks/dep-b520fc3a.js');
require('../../_chunks/dep-f2e07584.js');
require('../../hooks/useCommonClassName.js');
require('../option-group-props.js');
require('../../hooks/tnode.js');
require('../../hooks/render-tnode.js');
require('../../_chunks/dep-2e662da4.js');
require('../../_chunks/dep-1974f455.js');
require('../../_chunks/dep-76dea031.js');
require('../../_chunks/dep-0982adb4.js');
require('../../_chunks/dep-bd4b64b6.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var _defineProperty__default = /*#__PURE__*/_interopDefaultLegacy(_defineProperty);

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty__default["default"](e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function useSelectOptions(props, instance, keys) {
  var options = VueCompositionAPI.ref([]);
  var optionsCache = VueCompositionAPI.ref([]);
  var innerSlotRecord = null;
  var getOptions = function getOptions() {
    var _props$options;
    var dynamicIndex = 0;
    var innerOptions = ((_props$options = props.options) === null || _props$options === void 0 ? void 0 : _props$options.map(function (option) {
      var getFormatOption = function getFormatOption(option2) {
        var _keys$value = keys.value,
          value = _keys$value.value,
          label = _keys$value.label,
          disabled = _keys$value.disabled;
        var restOption = omit.omit(option2, [value, label, disabled]);
        var res = _objectSpread(_objectSpread({}, restOption), {}, {
          index: dynamicIndex,
          label: get.get(option2, label),
          value: get.get(option2, value),
          disabled: get.get(option2, disabled)
        });
        dynamicIndex += 1;
        return res;
      };
      if (option.children) {
        return _objectSpread(_objectSpread({}, option), {}, {
          children: option.children.map(function (child) {
            return getFormatOption(child);
          })
        });
      }
      return getFormatOption(option);
    })) || [];
    if (props.options === void 0) {
      innerSlotRecord = instance.proxy.$slots["default"];
      var currentSlots = instance.proxy.$slots["default"] || [];
      currentSlots.forEach(function (child) {
        if (!child.componentOptions) {
          return;
        }
        var componentName = utils_helper.getVNodeComponentName(child);
        if (componentName && componentName === utils_helper.getVueComponentName(select_option["default"])) {
          innerOptions.push(_objectSpread(_objectSpread({
            "class": child.data.staticClass,
            style: child.data.staticStyle
          }, child.componentOptions.propsData), {}, {
            slots: function slots() {
              return child.componentOptions.children;
            },
            index: dynamicIndex
          }));
          dynamicIndex += 1;
        } else if (componentName && componentName === utils_helper.getVueComponentName(select_optionGroup["default"])) {
          var _child$componentOptio, _child$componentOptio2, _child$componentOptio3;
          var groupOption = _objectSpread(_objectSpread({
            group: (_child$componentOptio = child.componentOptions.propsData) === null || _child$componentOptio === void 0 ? void 0 : _child$componentOptio.label
          }, child.componentOptions.propsData), {}, {
            children: []
          });
          (_child$componentOptio2 = child.componentOptions.children) === null || _child$componentOptio2 === void 0 || (_child$componentOptio3 = _child$componentOptio2.forEach) === null || _child$componentOptio3 === void 0 || _child$componentOptio3.call(_child$componentOptio2, function (groupChild) {
            groupOption.children.push(_objectSpread(_objectSpread({
              "class": groupChild.data.staticClass,
              style: groupChild.data.staticStyle
            }, groupChild.componentOptions.propsData), {}, {
              slots: function slots() {
                return groupChild.componentOptions.children;
              },
              index: dynamicIndex
            }));
            dynamicIndex += 1;
          });
          innerOptions.push(groupOption);
        }
      });
    }
    options.value = innerOptions;
  };
  var optionsMap = VueCompositionAPI.computed(function () {
    var res = /* @__PURE__ */new Map();
    optionsCache.value.concat(optionsList.value).forEach(function (option) {
      res.set(option.value, option);
    });
    return res;
  });
  var optionsList = VueCompositionAPI.computed(function () {
    var res = [];
    var _getOptionsList = function getOptionsList(options2) {
      options2.forEach(function (option) {
        if (option.children) {
          _getOptionsList(option.children);
        } else {
          res.push(option);
        }
      });
    };
    _getOptionsList(options.value);
    return res;
  });
  getOptions();
  VueCompositionAPI.watch(function () {
    return props.options;
  }, function () {
    getOptions();
  });
  VueCompositionAPI.onBeforeUpdate(function () {
    if (props.options === void 0 && innerSlotRecord !== instance.proxy.$slots["default"]) {
      getOptions();
    }
  });
  return {
    options: options,
    optionsMap: optionsMap,
    optionsList: optionsList,
    optionsCache: optionsCache
  };
}

exports["default"] = useSelectOptions;
//# sourceMappingURL=useSelectOptions.js.map
