/**
 * tdesign v1.12.0
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var _defineProperty = require('@babel/runtime/helpers/defineProperty');
var VueCompositionAPI = require('@vue/composition-api');
var utils_renderTnode = require('../utils/render-tnode.js');
var utils_ripple = require('../utils/ripple.js');
var configProvider_configReceiver = require('../config-provider/config-receiver.js');
var select_optionProps = require('./option-props.js');
var checkbox_index = require('../checkbox/index.js');
var hooks_useLazyLoad = require('../hooks/useLazyLoad.js');
var select_util = require('./util.js');
var configProvider_useConfig = require('../config-provider/useConfig.js');
var hooks_useCommonClassName = require('../hooks/useCommonClassName.js');
var hooks_useFormDisabled = require('../hooks/useFormDisabled.js');
require('@babel/runtime/helpers/readOnlyError');
require('@babel/runtime/helpers/typeof');
require('vue');
require('../_chunks/dep-f0f28315.js');
require('../_chunks/dep-7ed5d19e.js');
require('../_chunks/dep-f8b182e9.js');
require('../_chunks/dep-31fa06d0.js');
require('../_chunks/dep-36c57efe.js');
require('../_chunks/dep-0f4ac92d.js');
require('../_chunks/dep-f4d07ab0.js');
require('../_chunks/dep-2f28fbd7.js');
require('../_chunks/dep-76d8c62c.js');
require('../_chunks/dep-2f0c3d6d.js');
require('../_chunks/dep-b08014cb.js');
require('../_common/js/utils/setStyle.js');
require('../config.js');
require('../_chunks/dep-65c8d021.js');
require('../_common/js/global-config/default-config.js');
require('../_common/js/global-config/locale/zh_CN.js');
require('../_chunks/dep-bc99824f.js');
require('../_chunks/dep-4effc6c4.js');
require('dayjs');
require('../_chunks/dep-d59c4646.js');
require('../_chunks/dep-11382958.js');
require('../_chunks/dep-c272f99f.js');
require('../_chunks/dep-89b9f4de.js');
require('../_chunks/dep-1c1cc34f.js');
require('../_chunks/dep-ba816077.js');
require('../_chunks/dep-852fc6a9.js');
require('../_chunks/dep-c9d43e30.js');
require('../_chunks/dep-23d55f82.js');
require('../_chunks/dep-bc3ec918.js');
require('../_chunks/dep-f97b0058.js');
require('../_chunks/dep-9a119db9.js');
require('../_chunks/dep-49887b48.js');
require('../_chunks/dep-06c569d8.js');
require('../_chunks/dep-4d554a6f.js');
require('../_chunks/dep-7ec0f498.js');
require('../_chunks/dep-fcdc23bb.js');
require('../_chunks/dep-59f3051f.js');
require('../_chunks/dep-b86e0f9e.js');
require('../checkbox/group.js');
require('../_chunks/dep-27ac0b8c.js');
require('@babel/runtime/helpers/toConsumableArray');
require('@babel/runtime/helpers/slicedToArray');
require('../utils/helper.js');
require('@babel/runtime/helpers/objectWithoutProperties');
require('../checkbox/checkbox.js');
require('../checkbox/props.js');
require('../checkbox/constants.js');
require('../checkbox/store.js');
require('@babel/runtime/helpers/classCallCheck');
require('@babel/runtime/helpers/createClass');
require('../checkbox/hooks/useKeyboardEvent.js');
require('../_common/js/common.js');
require('../hooks/useConfig.js');
require('../hooks/useVModel.js');
require('../hooks/useElementLazyRender.js');
require('../_common/js/utils/observe.js');
require('../checkbox/checkbox-group-props.js');
require('../_chunks/dep-49944b19.js');
require('../_chunks/dep-ab17e69e.js');
require('../_chunks/dep-195eea38.js');
require('../_chunks/dep-caea5f4e.js');
require('../hooks/slots.js');
require('../utils/withInstall.js');
require('../_chunks/dep-bdfb7a98.js');
require('../_chunks/dep-b5cedeaa.js');
require('../_chunks/dep-07989e63.js');
require('../_chunks/dep-d3e77112.js');
require('../_chunks/dep-b520fc3a.js');
require('../_chunks/dep-f2e07584.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var _defineProperty__default = /*#__PURE__*/_interopDefaultLegacy(_defineProperty);

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty__default["default"](e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var keepAnimationMixins = configProvider_configReceiver.getKeepAnimationMixins();
var _Option = VueCompositionAPI.defineComponent({
  name: "TOption",
  props: _objectSpread(_objectSpread({}, select_optionProps["default"]), {}, {
    isCreatedOption: Boolean,
    multiple: Boolean,
    rowIndex: Number,
    trs: Map,
    scrollType: String,
    isVirtual: Boolean,
    bufferSize: Number,
    index: Number
  }),
  components: {
    TCheckbox: checkbox_index.Checkbox
  },
  mixins: [keepAnimationMixins],
  directives: {
    Ripple: utils_ripple["default"]
  },
  setup: function setup(props2, context) {
    var selectProvider = VueCompositionAPI.inject("tSelect");
    var optionNode = VueCompositionAPI.ref(null);
    var _useCommonClassName = hooks_useCommonClassName["default"](),
      sizeClassNames = _useCommonClassName.sizeClassNames,
      statusClassNames = _useCommonClassName.statusClassNames;
    var _useConfig = configProvider_useConfig.useConfig("classPrefix"),
      classPrefix = _useConfig.classPrefix;
    var _toRefs = VueCompositionAPI.toRefs(props2),
      value = _toRefs.value,
      label = _toRefs.label,
      multiple = _toRefs.multiple,
      disabled = _toRefs.disabled,
      panelElement = _toRefs.panelElement,
      scrollType = _toRefs.scrollType,
      bufferSize = _toRefs.bufferSize,
      index = _toRefs.index,
      isCreatedOption = _toRefs.isCreatedOption;
    var _useLazyLoad = hooks_useLazyLoad["default"](panelElement, optionNode, VueCompositionAPI.reactive({
        type: scrollType,
        bufferSize: bufferSize
      })),
      _useLazyLoad$hasLazyL = _useLazyLoad.hasLazyLoadHolder,
      hasLazyLoadHolder = _useLazyLoad$hasLazyL === void 0 ? null : _useLazyLoad$hasLazyL,
      _useLazyLoad$tRowHeig = _useLazyLoad.tRowHeight,
      tRowHeight = _useLazyLoad$tRowHeig === void 0 ? null : _useLazyLoad$tRowHeig;
    var isHover = VueCompositionAPI.ref(false);
    var _useFormDisabled = hooks_useFormDisabled.useFormDisabled(),
      formDisabled = _useFormDisabled.formDisabled;
    var isSelected = VueCompositionAPI.computed(function () {
      if (multiple.value) {
        var _selectProvider$selec;
        if (props2.checkAll) {
          return selectProvider.isAllOptionsChecked.value;
        }
        return (_selectProvider$selec = selectProvider.selectValue.value) === null || _selectProvider$selec === void 0 ? void 0 : _selectProvider$selec.includes(props2.value);
      }
      return selectProvider.selectValue.value === props2.value;
    });
    var isIndeterminate = VueCompositionAPI.computed(function () {
      return multiple.value && !selectProvider.isAllOptionsChecked.value && selectProvider.selectValue.value.length > 0;
    });
    var isDisabled = VueCompositionAPI.computed(function () {
      return disabled.value || formDisabled.value || multiple.value && !isSelected.value && !props2.checkAll && selectProvider.isReachMaxLimit.value;
    });
    var mouseEvent = function mouseEvent(v) {
      isHover.value = v;
    };
    var labelText = VueCompositionAPI.computed(function () {
      return label.value || value.value;
    });
    var classes = VueCompositionAPI.computed(function () {
      return ["".concat(classPrefix.value, "-select-option"), sizeClassNames[selectProvider && selectProvider.size.value], _defineProperty__default["default"](_defineProperty__default["default"](_defineProperty__default["default"]({}, statusClassNames.disabled, isDisabled.value), statusClassNames.selected, isSelected.value), "".concat(classPrefix.value, "-select-option__hover"), (isHover.value || selectProvider.hoverIndex.value === index.value) && !isDisabled.value && !isSelected.value)];
    });
    var handleClick = function handleClick(e) {
      if (isDisabled.value) return;
      e.preventDefault();
      if (isCreatedOption.value) {
        var _selectProvider$handl;
        (_selectProvider$handl = selectProvider.handleCreate) === null || _selectProvider$handl === void 0 || _selectProvider$handl.call(selectProvider, value.value);
      }
      if (multiple.value) {
        if (props2.checkAll) {
          selectProvider.handleCheckAllClick(e);
        } else {
          var newValue = select_util.getNewMultipleValue(selectProvider.selectValue.value, value.value);
          selectProvider.handleValueChange(newValue.value, {
            e: e,
            trigger: newValue.isCheck ? "check" : "uncheck"
          }, value.value);
          if (!selectProvider.reserveKeyword.value) {
            selectProvider.handlerInputChange("");
          }
        }
      } else {
        selectProvider.handleValueChange(value.value, {
          e: e,
          trigger: "check"
        }, value.value);
        selectProvider.handlePopupVisibleChange(false, {
          e: e
        });
      }
    };
    VueCompositionAPI.onMounted(function () {
      var trs = props2.trs,
        rowIndex = props2.rowIndex,
        scrollType2 = props2.scrollType,
        isVirtual = props2.isVirtual;
      if (scrollType2 === "virtual") {
        if (isVirtual) {
          trs.set(rowIndex, optionNode.value);
          context.emit("onRowMounted");
        }
      }
    });
    VueCompositionAPI.onBeforeUnmount(function () {
      if (props2.isVirtual) {
        var trs = props2.trs,
          rowIndex = props2.rowIndex;
        trs["delete"](rowIndex);
      }
    });
    return {
      isHover: isHover,
      isSelected: isSelected,
      isDisabled: isDisabled,
      isIndeterminate: isIndeterminate,
      mouseEvent: mouseEvent,
      classes: classes,
      selectProvider: selectProvider,
      labelText: labelText,
      optionNode: optionNode,
      tRowHeight: tRowHeight,
      hasLazyLoadHolder: hasLazyLoadHolder,
      handleClick: handleClick
    };
  },
  render: function render() {
    var h = arguments[0];
    var classes = this.classes,
      mouseEvent = this.mouseEvent,
      labelText = this.labelText,
      title = this.title;
    var selfDefinedContent = utils_renderTnode.renderContent(this, "default", "content");
    var optionChild = selfDefinedContent || h("span", [labelText]);
    var titleText = title || labelText;
    if (this.hasLazyLoadHolder) {
      return h("li", {
        "ref": "optionNode",
        "class": classes,
        "on": {
          "mouseenter": function mouseenter() {
            return mouseEvent(true);
          },
          "mouseleave": function mouseleave() {
            return mouseEvent(false);
          },
          "click": this.handleClick
        },
        "directives": [{
          name: "ripple",
          value: this.keepAnimation.ripple
        }],
        "attrs": {
          "title": titleText
        }
      }, [h("span", {
        "style": {
          height: "".concat(this.tRowHeight, "px"),
          border: "none"
        }
      })]);
    }
    return h("li", {
      "ref": "optionNode",
      "class": classes,
      "on": {
        "mouseenter": function mouseenter() {
          return mouseEvent(true);
        },
        "mouseleave": function mouseleave() {
          return mouseEvent(false);
        },
        "click": this.handleClick
      },
      "directives": [{
        name: "ripple",
        value: this.keepAnimation.ripple
      }],
      "attrs": {
        "title": titleText
      }
    }, [this.multiple ? h("t-checkbox", {
      "attrs": {
        "checked": this.isSelected,
        "disabled": this.isDisabled,
        "indeterminate": this.checkAll && this.isIndeterminate
      }
    }, [optionChild]) : optionChild]);
  }
});

exports["default"] = _Option;
//# sourceMappingURL=option.js.map
