/**
 * tdesign v1.12.0
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var helper = require('../_chunks/dep-27ac0b8c.js');
var _defineProperty = require('@babel/runtime/helpers/defineProperty');
var steps_props = require('./props.js');
var steps_stepItem = require('./step-item.js');
var utils_mixins = require('../utils/mixins.js');
var configProvider_configReceiver = require('../config-provider/config-receiver.js');
var utils_event = require('../utils/event.js');
require('tdesign-icons-vue');
require('./step-item-props.js');
require('../utils/render-tnode.js');
require('@babel/runtime/helpers/readOnlyError');
require('@babel/runtime/helpers/typeof');
require('vue');
require('@vue/composition-api');
require('../_chunks/dep-f0f28315.js');
require('../_chunks/dep-7ed5d19e.js');
require('../_chunks/dep-f8b182e9.js');
require('../_chunks/dep-31fa06d0.js');
require('../_chunks/dep-36c57efe.js');
require('../_chunks/dep-0f4ac92d.js');
require('../_chunks/dep-f4d07ab0.js');
require('../_chunks/dep-2f28fbd7.js');
require('../_chunks/dep-76d8c62c.js');
require('../_chunks/dep-2f0c3d6d.js');
require('../_chunks/dep-b08014cb.js');
require('../_chunks/dep-1c1cc34f.js');
require('../_chunks/dep-ba816077.js');
require('../_chunks/dep-65c8d021.js');
require('../_common/js/global-config/default-config.js');
require('../_common/js/global-config/locale/zh_CN.js');
require('../_chunks/dep-bc99824f.js');
require('../_chunks/dep-4effc6c4.js');
require('dayjs');
require('../_chunks/dep-d59c4646.js');
require('../_chunks/dep-11382958.js');
require('../_chunks/dep-c272f99f.js');
require('../_chunks/dep-89b9f4de.js');
require('../_chunks/dep-852fc6a9.js');
require('../_chunks/dep-c9d43e30.js');
require('../_chunks/dep-23d55f82.js');
require('../_chunks/dep-bc3ec918.js');
require('../_chunks/dep-f97b0058.js');
require('../_chunks/dep-9a119db9.js');
require('../_chunks/dep-49887b48.js');
require('../_chunks/dep-06c569d8.js');
require('../_chunks/dep-4d554a6f.js');
require('../_chunks/dep-7ec0f498.js');
require('../_chunks/dep-fcdc23bb.js');
require('../_chunks/dep-59f3051f.js');
require('../_chunks/dep-b86e0f9e.js');
require('../utils/helper.js');
require('@babel/runtime/helpers/objectWithoutProperties');
require('@babel/runtime/helpers/slicedToArray');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var _defineProperty__default = /*#__PURE__*/_interopDefaultLegacy(_defineProperty);

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty__default["default"](e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var _Steps = utils_mixins["default"](configProvider_configReceiver["default"]("steps")).extend({
  name: "TSteps",
  components: {
    TStepItem: steps_stepItem["default"]
  },
  props: _objectSpread({}, steps_props["default"]),
  data: function data() {
    return {
      indexMap: {}
    };
  },
  provide: function provide() {
    return {
      steps: this
    };
  },
  watch: {
    options: {
      immediate: true,
      handler: function handler() {
        var _this = this;
        if (!this.options) return;
        this.options.forEach(function (item, index) {
          if (item.value !== void 0) {
            _this.indexMap[item.value] = index;
          }
        });
      }
    }
  },
  computed: {
    baseClass: function baseClass() {
      return [this.componentName, "".concat(this.componentName, "--").concat(this.layout), "".concat(this.componentName, "--").concat(this.sequence), "".concat(this.componentName, "--").concat(this.handleTheme(), "-anchor"), "".concat(this.componentName, "--").concat(this.separator, "-separator")];
    }
  },
  render: function render() {
    var _this$$scopedSlots,
      _this2 = this;
    var h = arguments[0];
    var nodes = ((_this$$scopedSlots = this.$scopedSlots) === null || _this$$scopedSlots === void 0 ? void 0 : _this$$scopedSlots["default"]) && this.$scopedSlots["default"](null);
    var options = this.getOptions();
    var content = options.map(function (item, index) {
      var stepIndex = _this2.sequence === "reverse" ? options.length - index - 1 : index;
      var propsData = _objectSpread(_objectSpread({}, item), {}, {
        index: stepIndex,
        status: _this2.handleStatus(item, index)
      });
      var stepItem = h("t-step-item", helper.helper([{}, {
        "props": _objectSpread(_objectSpread({}, item), {}, {
          index: stepIndex,
          status: _this2.handleStatus(item, index)
        })
      }, {
        "key": item.value || index
      }]));
      if (nodes && nodes[index]) {
        var vnode = nodes[index];
        if (vnode.componentOptions) {
          vnode.componentOptions.propsData = propsData;
          return vnode;
        }
        return stepItem;
      }
      return stepItem;
    });
    return h("div", {
      "class": this.baseClass
    }, [content]);
  },
  methods: {
    getOptions: function getOptions() {
      var _this$$scopedSlots2;
      var nodes = ((_this$$scopedSlots2 = this.$scopedSlots) === null || _this$$scopedSlots2 === void 0 ? void 0 : _this$$scopedSlots2["default"]) && this.$scopedSlots["default"](null);
      var options;
      if (this.options && this.options.length) {
        options = this.sequence === "reverse" ? this.options.reverse() : this.options;
      } else {
        options = this.getOptionListBySlots(nodes);
      }
      return options;
    },
    getOptionListBySlots: function getOptionListBySlots(nodes) {
      var _this3 = this;
      var arr = [];
      nodes === null || nodes === void 0 || nodes.forEach(function (node) {
        var _node$componentOption;
        var option = node === null || node === void 0 || (_node$componentOption = node.componentOptions) === null || _node$componentOption === void 0 ? void 0 : _node$componentOption.propsData;
        if (!option) return;
        _this3.sequence === "reverse" ? arr.unshift(option) : arr.push(option);
      });
      return arr;
    },
    handleTheme: function handleTheme() {
      var theme = this.theme;
      var options = this.getOptions();
      options.forEach(function (item) {
        if ((item === null || item === void 0 ? void 0 : item.icon) !== void 0) {
          theme = "default";
        }
      });
      return theme;
    },
    handleStatus: function handleStatus(item, index) {
      if (item.status && item.status !== "default") return item.status;
      if (this.current === "FINISH") return "finish";
      if (item.value === void 0) {
        if (this.sequence === "positive" && index < this.current) return "finish";
        if (this.sequence === "reverse" && index > this.current) return "finish";
      }
      if (item.value !== void 0) {
        var matchIndex = this.indexMap[this.current];
        if (matchIndex === void 0) {
          console.warn("TDesign Steps Warn: The current `value` is not exist.");
          return "default";
        }
        if (this.sequence === "positive" && index < matchIndex) return "finish";
        if (this.sequence === "reverse" && index > matchIndex) return "finish";
      }
      var key = item.value === void 0 ? index : item.value;
      if (key === this.current) return "process";
      return "default";
    },
    handleChange: function handleChange(cur, prev, e) {
      utils_event.emitEvent(this, "change", cur, prev, {
        e: e
      });
    }
  }
});

exports["default"] = _Steps;
//# sourceMappingURL=steps.js.map
