/**
 * tdesign v1.12.0
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var helper = require('../_chunks/dep-27ac0b8c.js');
var _defineProperty = require('@babel/runtime/helpers/defineProperty');
var stickyTool_stickyItemProps = require('./sticky-item-props.js');
var stickyTool_props = require('./props.js');
var popup_index = require('../popup/index.js');
var utils_renderTnode = require('../utils/render-tnode.js');
var utils_mixins = require('../utils/mixins.js');
var configProvider_configReceiver = require('../config-provider/config-receiver.js');
require('../popup/popup.js');
require('@babel/runtime/helpers/typeof');
require('@popperjs/core');
require('../utils/dom.js');
require('vue');
require('raf');
require('../utils/easing.js');
require('../_chunks/dep-2e662da4.js');
require('../_chunks/dep-31fa06d0.js');
require('../_chunks/dep-36c57efe.js');
require('../_chunks/dep-f4d07ab0.js');
require('../utils/helper.js');
require('@babel/runtime/helpers/objectWithoutProperties');
require('@babel/runtime/helpers/slicedToArray');
require('../_chunks/dep-f0f28315.js');
require('../_chunks/dep-7ed5d19e.js');
require('../_chunks/dep-f8b182e9.js');
require('../_chunks/dep-0f4ac92d.js');
require('../_chunks/dep-2f28fbd7.js');
require('../_chunks/dep-76d8c62c.js');
require('../_chunks/dep-2f0c3d6d.js');
require('../_common/js/utils/setStyle.js');
require('../popup/props.js');
require('../popup/container.js');
require('../_chunks/dep-1c1cc34f.js');
require('../_chunks/dep-ba816077.js');
require('../utils/event.js');
require('../popup/utils.js');
require('../_chunks/dep-e9318595.js');
require('../_chunks/dep-50b0a969.js');
require('../utils/map-props.js');
require('../utils/withInstall.js');
require('../popup/plugin.js');
require('../_common/js/log/log.js');
require('../_chunks/dep-65c8d021.js');
require('../_common/js/global-config/default-config.js');
require('../_common/js/global-config/locale/zh_CN.js');
require('../_chunks/dep-bc99824f.js');
require('../_chunks/dep-4effc6c4.js');
require('dayjs');
require('../_chunks/dep-d59c4646.js');
require('../_chunks/dep-11382958.js');
require('../_chunks/dep-c272f99f.js');
require('../_chunks/dep-89b9f4de.js');
require('../_chunks/dep-852fc6a9.js');
require('../_chunks/dep-c9d43e30.js');
require('../_chunks/dep-23d55f82.js');
require('../_chunks/dep-bc3ec918.js');
require('../_chunks/dep-f97b0058.js');
require('../_chunks/dep-9a119db9.js');
require('../_chunks/dep-49887b48.js');
require('../_chunks/dep-06c569d8.js');
require('../_chunks/dep-4d554a6f.js');
require('../_chunks/dep-7ec0f498.js');
require('../_chunks/dep-fcdc23bb.js');
require('../_chunks/dep-59f3051f.js');
require('../_chunks/dep-b86e0f9e.js');
require('@babel/runtime/helpers/readOnlyError');
require('@vue/composition-api');
require('../_chunks/dep-b08014cb.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var _defineProperty__default = /*#__PURE__*/_interopDefaultLegacy(_defineProperty);

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty__default["default"](e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var _StickyItem = utils_mixins["default"](configProvider_configReceiver["default"]("sticky-item"), configProvider_configReceiver.getGlobalIconMixins()).extend({
  name: "TStickyItem",
  props: _objectSpread(_objectSpread({}, stickyTool_stickyItemProps["default"]), {}, {
    type: stickyTool_props["default"].type,
    shape: stickyTool_props["default"].shape,
    placement: stickyTool_props["default"].placement,
    basePopupProps: Object,
    baseWidth: stickyTool_props["default"].width,
    onClick: stickyTool_props["default"].onClick,
    onHover: stickyTool_props["default"].onHover,
    fatherCompName: String
  }),
  computed: {
    baseClass: function baseClass() {
      return ["".concat(this.componentName), "".concat(this.componentName, "--").concat(this.type), "".concat(this.componentName, "--").concat(this.shape)];
    },
    labelClass: function labelClass() {
      return ["".concat(this.componentName, "__label")];
    },
    popupPlacement: function popupPlacement() {
      return this.placement.indexOf("right") !== -1 ? "left" : "right";
    },
    styles: function styles() {
      var styles = {};
      if (this.baseWidth) {
        var selfWidth = this.type === "normal" ? "56px" : "40px";
        styles.margin = "calc((".concat(this.baseWidth, " - ").concat(selfWidth, ")/2)");
      }
      return styles;
    }
  },
  render: function render() {
    var h = arguments[0];
    var icon = utils_renderTnode.renderTNodeJSX(this, "icon");
    var label = utils_renderTnode.renderTNodeJSX(this, "label");
    var popup = utils_renderTnode.renderTNodeJSX(this, "popup");
    return h(popup_index.Popup, helper.helper([{
      "attrs": {
        "overlayInnerClassName": "".concat(this.fatherCompName, "-popup-content"),
        "trigger": this.trigger,
        "hideEmptyPopup": true,
        "placement": this.popupPlacement,
        "content": function content() {
          return popup;
        }
      }
    }, {
      "props": this.popupProps || this.basePopupProps
    }]), [h("div", {
      "class": this.baseClass,
      "style": this.styles,
      "on": {
        "click": this.handleClickItem,
        "mouseenter": this.handleHoverItem
      }
    }, [icon, this.type === "normal" ? h("div", {
      "class": this.labelClass
    }, [label]) : null])]);
  },
  methods: {
    handleClickItem: function handleClickItem(e) {
      var _this = this;
      var item = {};
      Object.keys(stickyTool_stickyItemProps["default"]).forEach(function (i) {
        return item[i] = _this[i];
      });
      this.onClick({
        e: e,
        item: item
      });
    },
    handleHoverItem: function handleHoverItem(e) {
      var _this2 = this;
      var item = {};
      Object.keys(stickyTool_stickyItemProps["default"]).forEach(function (i) {
        return item[i] = _this2[i];
      });
      this.onHover({
        e: e,
        item: item
      });
    }
  }
});

exports["default"] = _StickyItem;
//# sourceMappingURL=sticky-item.js.map
