/**
 * tdesign v1.12.0
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var helper = require('../../_chunks/dep-27ac0b8c.js');
var table_editableCell = require('../editable-cell.js');
require('@babel/runtime/helpers/slicedToArray');
require('@babel/runtime/helpers/toArray');
require('@babel/runtime/helpers/defineProperty');
require('@babel/runtime/helpers/typeof');
require('@vue/composition-api');
require('tdesign-icons-vue');
require('../../hooks/useGlobalIcon.js');
require('../../config-provider/useConfig.js');
require('../../_chunks/dep-65c8d021.js');
require('../../_common/js/global-config/default-config.js');
require('../../_common/js/global-config/locale/zh_CN.js');
require('../../_chunks/dep-bc99824f.js');
require('../../_chunks/dep-4effc6c4.js');
require('dayjs');
require('../../_chunks/dep-d59c4646.js');
require('../../_chunks/dep-11382958.js');
require('../../_chunks/dep-c272f99f.js');
require('../../_chunks/dep-89b9f4de.js');
require('../../_chunks/dep-1c1cc34f.js');
require('../../_chunks/dep-31fa06d0.js');
require('../../_chunks/dep-ba816077.js');
require('../../_chunks/dep-852fc6a9.js');
require('../../_chunks/dep-c9d43e30.js');
require('../../_chunks/dep-f4d07ab0.js');
require('../../_chunks/dep-36c57efe.js');
require('../../_chunks/dep-23d55f82.js');
require('../../_chunks/dep-bc3ec918.js');
require('../../_chunks/dep-f97b0058.js');
require('../../_chunks/dep-9a119db9.js');
require('../../_chunks/dep-49887b48.js');
require('../../_chunks/dep-06c569d8.js');
require('../../_chunks/dep-4d554a6f.js');
require('../../_chunks/dep-7ec0f498.js');
require('../../_chunks/dep-fcdc23bb.js');
require('../../_chunks/dep-59f3051f.js');
require('../../_chunks/dep-b86e0f9e.js');
require('../tr.js');
require('../utils.js');
require('../../_chunks/dep-5c93d051.js');
require('../../_chunks/dep-76dea031.js');
require('../../_chunks/dep-0f4ac92d.js');
require('../../_chunks/dep-f8b182e9.js');
require('./useFixed.js');
require('../../_common/js/log/log.js');
require('../../_common/js/utils/getScrollbarWidth.js');
require('../../_common/js/utils/helper.js');
require('@babel/runtime/helpers/toConsumableArray');
require('@babel/runtime/helpers/objectWithoutProperties');
require('../../_chunks/dep-caea5f4e.js');
require('../../_chunks/dep-1fe4c69b.js');
require('../../_chunks/dep-2e662da4.js');
require('../../_chunks/dep-260a7245.js');
require('../../utils/dom.js');
require('vue');
require('raf');
require('../../utils/easing.js');
require('../../_chunks/dep-d3e77112.js');
require('../../_chunks/dep-bb90fde6.js');
require('../../_chunks/dep-ab17e69e.js');
require('../../_chunks/dep-195eea38.js');
require('../../_chunks/dep-bd4b64b6.js');
require('../../_chunks/dep-f2e07584.js');
require('../../_chunks/dep-87dae4a0.js');
require('../../_chunks/dep-0982adb4.js');
require('../../_chunks/dep-9a8d9286.js');
require('../../_chunks/dep-27d04ffe.js');
require('../../_chunks/dep-56240b5e.js');
require('../../_chunks/dep-e9318595.js');
require('../../_chunks/dep-50b0a969.js');
require('./useClassName.js');
require('../ellipsis.js');
require('../../utils/render-tnode.js');
require('@babel/runtime/helpers/readOnlyError');
require('../../_chunks/dep-f0f28315.js');
require('../../_chunks/dep-7ed5d19e.js');
require('../../_chunks/dep-2f28fbd7.js');
require('../../_chunks/dep-76d8c62c.js');
require('../../_chunks/dep-2f0c3d6d.js');
require('../../_chunks/dep-b08014cb.js');
require('../../tooltip/index.js');
require('../../tooltip/tooltip.js');
require('../../tooltip/props.js');
require('../../popup/props.js');
require('../../popup/popup.js');
require('@popperjs/core');
require('../../utils/helper.js');
require('../../_common/js/utils/setStyle.js');
require('../../popup/container.js');
require('../../config-provider/config-receiver.js');
require('../../utils/mixins.js');
require('../../utils/event.js');
require('../../popup/utils.js');
require('../../utils/map-props.js');
require('../../utils/withInstall.js');
require('../base-table-props.js');
require('./useRowspanAndColspan.js');
require('../../hooks/useLazyLoad.js');
require('../../_common/js/utils/observe.js');
require('../../form/form-model.js');
require('@babel/runtime/helpers/asyncToGenerator');
require('@babel/runtime/regenerator');
require('../../_chunks/dep-1974f455.js');
require('../../_chunks/dep-b520fc3a.js');
require('../../_chunks/dep-bdfb7a98.js');
require('../../_chunks/dep-b5cedeaa.js');
require('../../_chunks/dep-07989e63.js');
require('../../_chunks/dep-0448cf27.js');

function useEditableCell(props, context, events) {
  var renderEditableCell = function renderEditableCell(h, p) {
    return h(table_editableCell["default"], helper.helper([{}, {
      "props": p
    }, {}, {
      "on": events
    }, {
      "scopedSlots": context.slots
    }]));
  };
  return {
    renderEditableCell: renderEditableCell
  };
}

exports["default"] = useEditableCell;
//# sourceMappingURL=useEditableCell.js.map
