/**
 * tdesign v1.12.0
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var helper = require('../../_chunks/dep-27ac0b8c.js');
var _toConsumableArray = require('@babel/runtime/helpers/toConsumableArray');
var _slicedToArray = require('@babel/runtime/helpers/slicedToArray');
var _defineProperty = require('@babel/runtime/helpers/defineProperty');
var VueCompositionAPI = require('@vue/composition-api');
var configProvider_useConfig = require('../../config-provider/useConfig.js');
var pagination_index = require('../../pagination/index.js');
var _common_js_log_log = require('../../_common/js/log/log.js');
require('../../_chunks/dep-65c8d021.js');
require('../../_common/js/global-config/default-config.js');
require('../../_common/js/global-config/locale/zh_CN.js');
require('../../_chunks/dep-bc99824f.js');
require('@babel/runtime/helpers/typeof');
require('../../_chunks/dep-4effc6c4.js');
require('dayjs');
require('../../_chunks/dep-d59c4646.js');
require('../../_chunks/dep-11382958.js');
require('../../_chunks/dep-c272f99f.js');
require('../../_chunks/dep-89b9f4de.js');
require('../../_chunks/dep-1c1cc34f.js');
require('../../_chunks/dep-31fa06d0.js');
require('../../_chunks/dep-ba816077.js');
require('../../_chunks/dep-852fc6a9.js');
require('../../_chunks/dep-c9d43e30.js');
require('../../_chunks/dep-f4d07ab0.js');
require('../../_chunks/dep-36c57efe.js');
require('../../_chunks/dep-23d55f82.js');
require('../../_chunks/dep-bc3ec918.js');
require('../../_chunks/dep-f97b0058.js');
require('../../_chunks/dep-9a119db9.js');
require('../../_chunks/dep-49887b48.js');
require('../../_chunks/dep-06c569d8.js');
require('../../_chunks/dep-4d554a6f.js');
require('../../_chunks/dep-7ec0f498.js');
require('../../_chunks/dep-fcdc23bb.js');
require('../../_chunks/dep-59f3051f.js');
require('../../_chunks/dep-b86e0f9e.js');
require('../../pagination/pagination.js');
require('tdesign-icons-vue');
require('../../utils/mixins.js');
require('vue');
require('../../config-provider/config-receiver.js');
require('../../input-number/index.js');
require('../../input-number/input-number.js');
require('../../button/index.js');
require('../../button/button.js');
require('../../loading/index.js');
require('../../loading/directive.js');
require('../../loading/plugin.js');
require('../../loading/loading.js');
require('../../loading/icon/gradient.js');
require('../../_common/js/loading/circle-adapter.js');
require('../../_common/js/utils/setStyle.js');
require('../../_common/js/utils/helper.js');
require('@babel/runtime/helpers/objectWithoutProperties');
require('../../_chunks/dep-caea5f4e.js');
require('../../_chunks/dep-1fe4c69b.js');
require('../../_chunks/dep-2e662da4.js');
require('../../_chunks/dep-260a7245.js');
require('../../utils/dom.js');
require('raf');
require('../../utils/easing.js');
require('../../utils/render-tnode.js');
require('@babel/runtime/helpers/readOnlyError');
require('../../_chunks/dep-f0f28315.js');
require('../../_chunks/dep-7ed5d19e.js');
require('../../_chunks/dep-f8b182e9.js');
require('../../_chunks/dep-0f4ac92d.js');
require('../../_chunks/dep-2f28fbd7.js');
require('../../_chunks/dep-76d8c62c.js');
require('../../_chunks/dep-2f0c3d6d.js');
require('../../_chunks/dep-b08014cb.js');
require('../../utils/transfer-dom.js');
require('../../loading/props.js');
require('../../config.js');
require('../../_chunks/dep-029c3522.js');
require('../../_chunks/dep-c63385b6.js');
require('../../_chunks/dep-ab17e69e.js');
require('../../_chunks/dep-87dae4a0.js');
require('../../_chunks/dep-07989e63.js');
require('../../_chunks/dep-d3e77112.js');
require('../../_chunks/dep-b520fc3a.js');
require('../../_chunks/dep-f2e07584.js');
require('../../_chunks/dep-9a183e68.js');
require('../../_chunks/dep-5c93d051.js');
require('../../_chunks/dep-76dea031.js');
require('../../_chunks/dep-56240b5e.js');
require('../../_chunks/dep-81ddbae0.js');
require('../../utils/withInstall.js');
require('../../button/props.js');
require('../../utils/ripple.js');
require('../../input/index.js');
require('../../input/input.js');
require('../../utils/helper.js');
require('../../utils/event.js');
require('../../input/props.js');
require('../../input/input-group.js');
require('../../utils/map-props.js');
require('../../input-number/props.js');
require('../../input-number/useInputNumber.js');
require('../../hooks/useCommonClassName.js');
require('../../hooks/useVModel.js');
require('../../_common/js/input-number/number.js');
require('../../_common/js/input-number/large-number.js');
require('../../hooks/useFormDisabled.js');
require('../../hooks/useGlobalIcon.js');
require('../../select/index.js');
require('../../select/select.js');
require('../../hooks/useDefaultValue.js');
require('../../hooks/tnode.js');
require('../../hooks/render-tnode.js');
require('../../_chunks/dep-1974f455.js');
require('../../select/props.js');
require('../../popup/index.js');
require('../../popup/popup.js');
require('@popperjs/core');
require('../../popup/props.js');
require('../../popup/container.js');
require('../../popup/utils.js');
require('../../_chunks/dep-e9318595.js');
require('../../_chunks/dep-50b0a969.js');
require('../../popup/plugin.js');
require('../../tag/index.js');
require('../../tag/tag.js');
require('tinycolor2');
require('../../tag/props.js');
require('../../tag/check-tag.js');
require('../../tag/check-tag-props.js');
require('../../hooks/useConfig.js');
require('../../_common/js/common.js');
require('../../tag/check-tag-group.js');
require('../../tag/check-tag-group-props.js');
require('../../select-input/index.js');
require('../../select-input/select-input.js');
require('../../select-input/props.js');
require('../../select-input/useSingle.js');
require('../../_chunks/dep-9a8d9286.js');
require('../../_chunks/dep-27d04ffe.js');
require('../../_chunks/dep-bd4b64b6.js');
require('../../select-input/useMultiple.js');
require('../../tag-input/index.js');
require('../../tag-input/tag-input.js');
require('../../tag-input/props.js');
require('../../tag-input/hooks/useTagScroll.js');
require('../../tag-input/useTagList.js');
require('../../tag-input/hooks/useHover.js');
require('../../tag-input/hooks/useDragSorter.js');
require('../../select-input/useOverlayInnerStyle.js');
require('../../common-components/fake-arrow.js');
require('../../select/option.js');
require('../../select/option-props.js');
require('../../checkbox/index.js');
require('../../checkbox/group.js');
require('../../checkbox/checkbox.js');
require('../../checkbox/props.js');
require('../../checkbox/constants.js');
require('../../checkbox/store.js');
require('@babel/runtime/helpers/classCallCheck');
require('@babel/runtime/helpers/createClass');
require('../../checkbox/hooks/useKeyboardEvent.js');
require('../../hooks/useElementLazyRender.js');
require('../../_common/js/utils/observe.js');
require('../../checkbox/checkbox-group-props.js');
require('../../_chunks/dep-49944b19.js');
require('../../_chunks/dep-195eea38.js');
require('../../hooks/slots.js');
require('../../hooks/useLazyLoad.js');
require('../../select/util.js');
require('../../_chunks/dep-bdfb7a98.js');
require('../../_chunks/dep-b5cedeaa.js');
require('../../select/select-panel.js');
require('../../select/optionGroup.js');
require('../../select/option-group-props.js');
require('../../hooks/useVirtualScroll.js');
require('../../select/hooks/useSelectOptions.js');
require('../../_chunks/dep-11856238.js');
require('../../_chunks/dep-0982adb4.js');
require('../../input-adornment/index.js');
require('../../input-adornment/input-adornment.js');
require('../../input-adornment/props.js');
require('../../pagination/props.js');
require('../../pagination/pagination-mini.js');
require('../../pagination/pagination-mini-props.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var _toConsumableArray__default = /*#__PURE__*/_interopDefaultLegacy(_toConsumableArray);
var _slicedToArray__default = /*#__PURE__*/_interopDefaultLegacy(_slicedToArray);
var _defineProperty__default = /*#__PURE__*/_interopDefaultLegacy(_defineProperty);

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty__default["default"](e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var DEFAULT_PAGE_SIZE = 10;
function usePaginationValue(pagination, onPageChange) {
  var _pagination$value, _pagination$value2, _pagination$value3;
  if ((_pagination$value = pagination.value) !== null && _pagination$value !== void 0 && _pagination$value.current && (_pagination$value2 = pagination.value) !== null && _pagination$value2 !== void 0 && _pagination$value2.defaultPageSize || (_pagination$value3 = pagination.value) !== null && _pagination$value3 !== void 0 && _pagination$value3.defaultCurrent && pagination !== null && pagination !== void 0 && pagination.value.pageSize) {
    _common_js_log_log["default"].error("Table", "cannot set both current and defaultPageSize, or defaultCurrent and pagesize. current/pageSize and defaultCurrent/defaultPageSize are allowed.");
  }
  var innerPagination = VueCompositionAPI.ref();
  var setInnerPagination = VueCompositionAPI.ref(onPageChange);
  VueCompositionAPI.watch(function () {
    return _objectSpread({}, pagination.value);
  }, function (pagination2) {
    if (!pagination2) return [innerPagination, setInnerPagination];
    var isControlled = Boolean(pagination2 === null || pagination2 === void 0 ? void 0 : pagination2.current);
    if (isControlled) {
      innerPagination.value = pagination2;
      return;
    }
    if (!innerPagination.value && pagination2.defaultCurrent) {
      innerPagination.value = _objectSpread(_objectSpread({}, pagination2), {}, {
        current: pagination2.defaultCurrent,
        pageSize: pagination2.defaultPageSize || DEFAULT_PAGE_SIZE
      });
    } else if (innerPagination.value && !pagination2.defaultCurrent) {
      innerPagination.value = void 0;
    }
    setInnerPagination.value = function (newPagination, newData) {
      innerPagination.value = _objectSpread(_objectSpread({}, innerPagination.value), newPagination);
      onPageChange === null || onPageChange === void 0 || onPageChange(newPagination, newData);
    };
  }, {
    immediate: true
  });
  return [innerPagination, setInnerPagination];
}
function usePagination(props, context) {
  var _toRefs = VueCompositionAPI.toRefs(props),
    pagination = _toRefs.pagination,
    disableDataPage = _toRefs.disableDataPage,
    data = _toRefs.data;
  var _useConfig = configProvider_useConfig.useConfig(),
    classPrefix = _useConfig.classPrefix;
  var dataSource = VueCompositionAPI.ref([]);
  var onPageChange = function onPageChange(pageInfo, newData) {
    var _props$onPageChange;
    context.emit("page-change", pageInfo, newData);
    (_props$onPageChange = props.onPageChange) === null || _props$onPageChange === void 0 || _props$onPageChange.call(props, pageInfo, newData);
  };
  var _usePaginationValue = usePaginationValue(pagination, onPageChange),
    _usePaginationValue2 = _slicedToArray__default["default"](_usePaginationValue, 2),
    innerPagination = _usePaginationValue2[0],
    setInnerPagination = _usePaginationValue2[1];
  var isPaginateData = VueCompositionAPI.computed(function () {
    var _innerPagination$valu;
    var pageSize = (innerPagination === null || innerPagination === void 0 || (_innerPagination$valu = innerPagination.value) === null || _innerPagination$valu === void 0 ? void 0 : _innerPagination$valu.pageSize) || DEFAULT_PAGE_SIZE;
    return Boolean(!disableDataPage.value && props.data.length > pageSize);
  });
  var getDataSourceAndPaginate = function getDataSourceAndPaginate() {
    var current = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 1;
    var pageSize = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : DEFAULT_PAGE_SIZE;
    var data2 = props.data;
    var paginationData = [];
    if (isPaginateData.value) {
      var start = (current - 1) * pageSize;
      var end = current * pageSize;
      paginationData = data2.slice(start, end);
    } else {
      paginationData = data2;
    }
    return paginationData;
  };
  VueCompositionAPI.watch(function () {
    return [_objectSpread({}, innerPagination.value), _toConsumableArray__default["default"](data.value)];
  }, function (_ref) {
    var _ref2 = _slicedToArray__default["default"](_ref, 2),
      innerPagination2 = _ref2[0],
      data2 = _ref2[1];
    if (!(innerPagination2 !== null && innerPagination2 !== void 0 && innerPagination2.current)) {
      dataSource.value = data2;
      return;
    }
    var current = innerPagination2.current,
      pageSize = innerPagination2.pageSize;
    dataSource.value = getDataSourceAndPaginate(current, pageSize);
  }, {
    immediate: true
  });
  var renderPagination = function renderPagination(h) {
    if (!innerPagination.value) return null;
    return h("div", {
      "class": "".concat(classPrefix.value, "-table__pagination")
    }, [h(pagination_index.Pagination, helper.helper([{}, {
      "props": _objectSpread(_objectSpread({}, props.pagination), innerPagination.value)
    }, {}, {
      "on": {
        change: function change(pageInfo) {
          var _setInnerPagination$v;
          var dataSource2 = getDataSourceAndPaginate(pageInfo.current, pageInfo.pageSize);
          setInnerPagination === null || setInnerPagination === void 0 || (_setInnerPagination$v = setInnerPagination.value) === null || _setInnerPagination$v === void 0 || _setInnerPagination$v.call(setInnerPagination, _objectSpread(_objectSpread({}, innerPagination.value), pageInfo), dataSource2);
        }
      }
    }, {
      "scopedSlots": {
        totalContent: context.slots.totalContent
      }
    }]))]);
  };
  return {
    isPaginateData: isPaginateData,
    dataSource: dataSource,
    innerPagination: innerPagination,
    renderPagination: renderPagination
  };
}

exports["default"] = usePagination;
exports.usePaginationValue = usePaginationValue;
//# sourceMappingURL=usePagination.js.map
