/**
 * tdesign v1.12.0
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var _defineProperty = require('@babel/runtime/helpers/defineProperty');
var VueCompositionAPI = require('@vue/composition-api');
var table_hooks_useClassName = require('./useClassName.js');
var hooks_useCommonClassName = require('../../hooks/useCommonClassName.js');
var configProvider_useConfig = require('../../config-provider/useConfig.js');
require('../../_chunks/dep-65c8d021.js');
require('../../_common/js/global-config/default-config.js');
require('../../_common/js/global-config/locale/zh_CN.js');
require('../../_chunks/dep-bc99824f.js');
require('@babel/runtime/helpers/typeof');
require('../../_chunks/dep-4effc6c4.js');
require('dayjs');
require('../../_chunks/dep-d59c4646.js');
require('../../_chunks/dep-11382958.js');
require('../../_chunks/dep-c272f99f.js');
require('../../_chunks/dep-89b9f4de.js');
require('../../_chunks/dep-1c1cc34f.js');
require('../../_chunks/dep-31fa06d0.js');
require('../../_chunks/dep-ba816077.js');
require('../../_chunks/dep-852fc6a9.js');
require('../../_chunks/dep-c9d43e30.js');
require('../../_chunks/dep-f4d07ab0.js');
require('../../_chunks/dep-36c57efe.js');
require('../../_chunks/dep-23d55f82.js');
require('../../_chunks/dep-bc3ec918.js');
require('../../_chunks/dep-f97b0058.js');
require('../../_chunks/dep-9a119db9.js');
require('../../_chunks/dep-49887b48.js');
require('../../_chunks/dep-06c569d8.js');
require('../../_chunks/dep-4d554a6f.js');
require('../../_chunks/dep-7ec0f498.js');
require('../../_chunks/dep-fcdc23bb.js');
require('../../_chunks/dep-59f3051f.js');
require('../../_chunks/dep-b86e0f9e.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var _defineProperty__default = /*#__PURE__*/_interopDefaultLegacy(_defineProperty);

function formatCSSUnit(unit) {
  if (!unit) return unit;
  return isNaN(Number(unit)) ? unit : "".concat(unit, "px");
}
function useStyle(props) {
  var _toRefs = VueCompositionAPI.toRefs(props),
    bordered = _toRefs.bordered,
    stripe = _toRefs.stripe,
    hover = _toRefs.hover,
    verticalAlign = _toRefs.verticalAlign,
    height = _toRefs.height,
    maxHeight = _toRefs.maxHeight,
    tableContentWidth = _toRefs.tableContentWidth;
  var _useClassName = table_hooks_useClassName["default"](),
    tableBaseClass = _useClassName.tableBaseClass,
    tableAlignClasses = _useClassName.tableAlignClasses;
  var _useCommonClassName = hooks_useCommonClassName["default"](),
    sizeClassNames = _useCommonClassName.sizeClassNames;
  var _useConfig = configProvider_useConfig.useConfig("table", props.locale),
    global = _useConfig.global;
  var tableSize = VueCompositionAPI.computed(function () {
    var _props$size;
    return (_props$size = props.size) !== null && _props$size !== void 0 ? _props$size : global.value.size;
  });
  var tableClasses = VueCompositionAPI.computed(function () {
    return [tableBaseClass.table, _defineProperty__default["default"](_defineProperty__default["default"](_defineProperty__default["default"](_defineProperty__default["default"](_defineProperty__default["default"](_defineProperty__default["default"](_defineProperty__default["default"](_defineProperty__default["default"](_defineProperty__default["default"](_defineProperty__default["default"]({}, sizeClassNames[tableSize.value], tableSize.value !== "medium"), tableBaseClass.bordered, bordered.value), tableBaseClass.striped, stripe.value), tableBaseClass.hover, hover.value), tableBaseClass.loading, props.loading), tableBaseClass.affixedHeader, props.headerAffixedTop), tableBaseClass.rowspanAndColspan, props.rowspanAndColspan), tableBaseClass.horizontalBarAffixed, props.horizontalScrollAffixedBottom), tableBaseClass.footerAffixed, props.footerAffixedBottom), tableAlignClasses[verticalAlign.value], verticalAlign.value !== "middle")];
  });
  var tableContentStyles = VueCompositionAPI.computed(function () {
    return {
      height: formatCSSUnit(height.value),
      maxHeight: formatCSSUnit(maxHeight.value)
    };
  });
  var tableElementStyles = VueCompositionAPI.computed(function () {
    return {
      width: formatCSSUnit(tableContentWidth.value)
    };
  });
  return {
    sizeClassNames: sizeClassNames,
    tableClasses: tableClasses,
    tableElementStyles: tableElementStyles,
    tableContentStyles: tableContentStyles
  };
}

exports["default"] = useStyle;
exports.formatCSSUnit = formatCSSUnit;
//# sourceMappingURL=useStyle.js.map
