/**
 * tdesign v1.12.0
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var _defineProperty = require('@babel/runtime/helpers/defineProperty');
var Vue = require('vue');
var tabs_tabPanelProps = require('./tab-panel-props.js');
var utils_renderTnode = require('../utils/render-tnode.js');
var hooks_useDestroyOnClose = require('../hooks/useDestroyOnClose.js');
var configProvider_configReceiver = require('../config-provider/config-receiver.js');
var utils_mixins = require('../utils/mixins.js');
require('@babel/runtime/helpers/readOnlyError');
require('@babel/runtime/helpers/typeof');
require('@vue/composition-api');
require('../_chunks/dep-f0f28315.js');
require('../_chunks/dep-7ed5d19e.js');
require('../_chunks/dep-f8b182e9.js');
require('../_chunks/dep-31fa06d0.js');
require('../_chunks/dep-36c57efe.js');
require('../_chunks/dep-0f4ac92d.js');
require('../_chunks/dep-f4d07ab0.js');
require('../_chunks/dep-2f28fbd7.js');
require('../_chunks/dep-76d8c62c.js');
require('../_chunks/dep-2f0c3d6d.js');
require('../_chunks/dep-b08014cb.js');
require('../_chunks/dep-65c8d021.js');
require('../_common/js/global-config/default-config.js');
require('../_common/js/global-config/locale/zh_CN.js');
require('../_chunks/dep-bc99824f.js');
require('../_chunks/dep-4effc6c4.js');
require('dayjs');
require('../_chunks/dep-d59c4646.js');
require('../_chunks/dep-11382958.js');
require('../_chunks/dep-c272f99f.js');
require('../_chunks/dep-89b9f4de.js');
require('../_chunks/dep-1c1cc34f.js');
require('../_chunks/dep-ba816077.js');
require('../_chunks/dep-852fc6a9.js');
require('../_chunks/dep-c9d43e30.js');
require('../_chunks/dep-23d55f82.js');
require('../_chunks/dep-bc3ec918.js');
require('../_chunks/dep-f97b0058.js');
require('../_chunks/dep-9a119db9.js');
require('../_chunks/dep-49887b48.js');
require('../_chunks/dep-06c569d8.js');
require('../_chunks/dep-4d554a6f.js');
require('../_chunks/dep-7ec0f498.js');
require('../_chunks/dep-fcdc23bb.js');
require('../_chunks/dep-59f3051f.js');
require('../_chunks/dep-b86e0f9e.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var _defineProperty__default = /*#__PURE__*/_interopDefaultLegacy(_defineProperty);
var Vue__default = /*#__PURE__*/_interopDefaultLegacy(Vue);

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty__default["default"](e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var classPrefixMixins = configProvider_configReceiver.getClassPrefixMixins("tab-panel");
var _TabPanel = utils_mixins["default"](Vue__default["default"], classPrefixMixins).extend({
  name: "TTabPanel",
  props: _objectSpread({}, tabs_tabPanelProps["default"]),
  data: function data() {
    return {
      loaded: false
    };
  },
  inject: {
    parent: {
      "default": null
    }
  },
  computed: {
    active: function active() {
      var _ref = this.parent || {},
        value = _ref.value;
      var result = this.value === value;
      if (result) {
        this.loaded = true;
      }
      return result;
    }
  },
  updated: function updated() {
    var _this$parent,
      _this$parent$updatePa,
      _this = this;
    (_this$parent = this.parent) === null || _this$parent === void 0 || (_this$parent$updatePa = _this$parent.updatePanels) === null || _this$parent$updatePa === void 0 || _this$parent$updatePa.call(_this$parent, {
      force: true
    });
    if (!this.destroyOnHide) {
      var timer = setTimeout(function () {
        hooks_useDestroyOnClose.updateElement(_this);
        clearTimeout(timer);
      }, 0);
    }
  },
  render: function render() {
    var h = arguments[0];
    var destroyOnHide = this.destroyOnHide,
      active = this.active,
      lazy = this.lazy,
      loaded = this.loaded;
    if (destroyOnHide && !active || lazy && !loaded) return null;
    return h("div", {
      "class": this.componentName,
      "directives": [{
        name: "show",
        value: active
      }]
    }, [utils_renderTnode.renderContent(this, "default", "panel")]);
  }
});

exports["default"] = _TabPanel;
//# sourceMappingURL=tab-panel.js.map
