/**
 * tdesign v1.12.0
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var helper = require('../_chunks/dep-27ac0b8c.js');
var _slicedToArray = require('@babel/runtime/helpers/slicedToArray');
var _defineProperty = require('@babel/runtime/helpers/defineProperty');
var VueCompositionAPI = require('@vue/composition-api');
var tdesignIconsVue = require('tdesign-icons-vue');
var input_index = require('../input/index.js');
var tagInput_props = require('./props.js');
var utils_renderTnode = require('../utils/render-tnode.js');
var tagInput_hooks_useTagScroll = require('./hooks/useTagScroll.js');
var tagInput_useTagList = require('./useTagList.js');
var tagInput_hooks_useHover = require('./hooks/useHover.js');
var hooks_useDefaultValue = require('../hooks/useDefaultValue.js');
var tagInput_hooks_useDragSorter = require('./hooks/useDragSorter.js');
var hooks_useGlobalIcon = require('../hooks/useGlobalIcon.js');
var configProvider_useConfig = require('../config-provider/useConfig.js');
require('../input/input.js');
require('@babel/runtime/helpers/toConsumableArray');
require('@babel/runtime/helpers/typeof');
require('../_common/js/utils/helper.js');
require('@babel/runtime/helpers/objectWithoutProperties');
require('../_chunks/dep-caea5f4e.js');
require('../_chunks/dep-1fe4c69b.js');
require('../_chunks/dep-2e662da4.js');
require('../_chunks/dep-31fa06d0.js');
require('../_chunks/dep-36c57efe.js');
require('../_chunks/dep-f4d07ab0.js');
require('../_chunks/dep-260a7245.js');
require('../utils/helper.js');
require('../_chunks/dep-f0f28315.js');
require('../_chunks/dep-7ed5d19e.js');
require('../_chunks/dep-f8b182e9.js');
require('../_chunks/dep-0f4ac92d.js');
require('../_chunks/dep-2f28fbd7.js');
require('../_chunks/dep-76d8c62c.js');
require('../_chunks/dep-2f0c3d6d.js');
require('../config-provider/config-receiver.js');
require('vue');
require('../_chunks/dep-65c8d021.js');
require('../_common/js/global-config/default-config.js');
require('../_common/js/global-config/locale/zh_CN.js');
require('../_chunks/dep-bc99824f.js');
require('../_chunks/dep-4effc6c4.js');
require('dayjs');
require('../_chunks/dep-d59c4646.js');
require('../_chunks/dep-11382958.js');
require('../_chunks/dep-c272f99f.js');
require('../_chunks/dep-89b9f4de.js');
require('../_chunks/dep-1c1cc34f.js');
require('../_chunks/dep-ba816077.js');
require('../_chunks/dep-852fc6a9.js');
require('../_chunks/dep-c9d43e30.js');
require('../_chunks/dep-23d55f82.js');
require('../_chunks/dep-bc3ec918.js');
require('../_chunks/dep-f97b0058.js');
require('../_chunks/dep-9a119db9.js');
require('../_chunks/dep-49887b48.js');
require('../_chunks/dep-06c569d8.js');
require('../_chunks/dep-4d554a6f.js');
require('../_chunks/dep-7ec0f498.js');
require('../_chunks/dep-fcdc23bb.js');
require('../_chunks/dep-59f3051f.js');
require('../_chunks/dep-b86e0f9e.js');
require('../utils/mixins.js');
require('../utils/event.js');
require('../input/props.js');
require('../_common/js/log/log.js');
require('../_chunks/dep-b08014cb.js');
require('@babel/runtime/helpers/readOnlyError');
require('../input/input-group.js');
require('../utils/map-props.js');
require('../utils/withInstall.js');
require('../tag/index.js');
require('../tag/tag.js');
require('tinycolor2');
require('../tag/props.js');
require('../tag/check-tag.js');
require('../tag/check-tag-props.js');
require('../hooks/useConfig.js');
require('../hooks/useVModel.js');
require('../_common/js/common.js');
require('../tag/check-tag-group.js');
require('../tag/check-tag-group-props.js');
require('../hooks/tnode.js');
require('../hooks/render-tnode.js');
require('../_chunks/dep-1974f455.js');
require('../_chunks/dep-b520fc3a.js');
require('../_chunks/dep-f2e07584.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var _slicedToArray__default = /*#__PURE__*/_interopDefaultLegacy(_slicedToArray);
var _defineProperty__default = /*#__PURE__*/_interopDefaultLegacy(_defineProperty);

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty__default["default"](e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var _TagInput = VueCompositionAPI.defineComponent({
  name: "TTagInput",
  props: _objectSpread({}, tagInput_props["default"]),
  setup: function setup(props2, context) {
    var _toRefs = VueCompositionAPI.toRefs(props2),
      inputValue = _toRefs.inputValue,
      inputProps = _toRefs.inputProps;
    var isComposition = VueCompositionAPI.ref(false);
    var COMPONENT_NAME = configProvider_useConfig.usePrefixClass("tag-input");
    var classPrefix = configProvider_useConfig.usePrefixClass();
    var _useDefaultValue = hooks_useDefaultValue["default"](inputValue, props2.defaultInputValue, props2.onInputChange, "inputValue", "input-change"),
      _useDefaultValue2 = _slicedToArray__default["default"](_useDefaultValue, 2),
      tInputValue = _useDefaultValue2[0],
      setTInputValue = _useDefaultValue2[1];
    var _toRefs2 = VueCompositionAPI.toRefs(props2),
      excessTagsDisplayType = _toRefs2.excessTagsDisplayType,
      readonly = _toRefs2.readonly,
      disabled = _toRefs2.disabled,
      clearable = _toRefs2.clearable,
      placeholder = _toRefs2.placeholder;
    var _useHover = tagInput_hooks_useHover["default"]({
        readonly: readonly,
        disabled: disabled,
        onMouseenter: props2.onMouseenter,
        onMouseleave: props2.onMouseleave
      }, context),
      isHover = _useHover.isHover,
      addHover = _useHover.addHover,
      cancelHover = _useHover.cancelHover;
    var _useDragSorter = tagInput_hooks_useDragSorter["default"](_objectSpread(_objectSpread({}, props2), {}, {
        sortOnDraggable: props2.dragSort,
        onDragOverCheck: {
          x: true,
          targetClassNameRegExp: new RegExp("^".concat(classPrefix.value, "-tag"))
        }
      }), context),
      getDragProps = _useDragSorter.getDragProps;
    var _useTagScroll = tagInput_hooks_useTagScroll["default"](props2),
      scrollToRight = _useTagScroll.scrollToRight,
      onWheel = _useTagScroll.onWheel,
      scrollToRightOnEnter = _useTagScroll.scrollToRightOnEnter,
      scrollToLeftOnLeave = _useTagScroll.scrollToLeftOnLeave,
      tagInputRef = _useTagScroll.tagInputRef,
      isScrollable = _useTagScroll.isScrollable;
    var _useTagList = tagInput_useTagList["default"](props2, context, getDragProps),
      tagValue = _useTagList.tagValue,
      onInnerEnter = _useTagList.onInnerEnter,
      onInputBackspaceKeyUp = _useTagList.onInputBackspaceKeyUp,
      onInputBackspaceKeyDown = _useTagList.onInputBackspaceKeyDown,
      clearAll = _useTagList.clearAll,
      renderLabel = _useTagList.renderLabel,
      onClose = _useTagList.onClose;
    var _useGlobalIcon = hooks_useGlobalIcon.useGlobalIcon({
        CloseCircleFilledIcon: tdesignIconsVue.CloseCircleFilledIcon
      }),
      CloseCircleFilledIcon = _useGlobalIcon.CloseCircleFilledIcon;
    var classes = VueCompositionAPI.computed(function () {
      var isEmpty = !(Array.isArray(tagValue.value) && tagValue.value.length);
      return [COMPONENT_NAME.value, _defineProperty__default["default"](_defineProperty__default["default"](_defineProperty__default["default"](_defineProperty__default["default"]({}, "".concat(COMPONENT_NAME.value, "--break-line"), excessTagsDisplayType.value === "break-line"), "".concat(classPrefix.value, "-is-empty"), isEmpty), "".concat(classPrefix.value, "-tag-input--with-tag"), !isEmpty), "".concat(classPrefix.value, "-tag-input--drag-sort"), props2.dragSort && !disabled.value && !readonly.value)];
    });
    var tagInputPlaceholder = VueCompositionAPI.computed(function () {
      var _tagValue$value;
      return !((_tagValue$value = tagValue.value) !== null && _tagValue$value !== void 0 && _tagValue$value.length) ? placeholder.value : "";
    });
    var showClearIcon = VueCompositionAPI.computed(function () {
      var _tagValue$value2;
      return Boolean(!readonly.value && !disabled.value && clearable.value && isHover.value && (((_tagValue$value2 = tagValue.value) === null || _tagValue$value2 === void 0 ? void 0 : _tagValue$value2.length) || tInputValue.value));
    });
    var onInputCompositionstart = function onInputCompositionstart(value, context2) {
      var _inputProps$value, _inputProps$value$onC;
      isComposition.value = true;
      (_inputProps$value = inputProps.value) === null || _inputProps$value === void 0 || (_inputProps$value$onC = _inputProps$value.onCompositionstart) === null || _inputProps$value$onC === void 0 || _inputProps$value$onC.call(_inputProps$value, value, context2);
    };
    var onInputCompositionend = function onInputCompositionend(value, context2) {
      var _inputProps$value2, _inputProps$value2$on;
      isComposition.value = false;
      (_inputProps$value2 = inputProps.value) === null || _inputProps$value2 === void 0 || (_inputProps$value2$on = _inputProps$value2.onCompositionend) === null || _inputProps$value2$on === void 0 || _inputProps$value2$on.call(_inputProps$value2, value, context2);
    };
    var onInputEnter = function onInputEnter(value, context2) {
      var _context2$e;
      (_context2$e = context2.e) === null || _context2$e === void 0 || _context2$e.preventDefault();
      setTInputValue("", {
        e: context2.e,
        trigger: "enter"
      });
      !isComposition.value && onInnerEnter(value, context2);
      VueCompositionAPI.nextTick(function () {
        scrollToRight();
        isComposition.value = false;
      });
    };
    var onInnerClick = function onInnerClick(params) {
      var _props2$onClick;
      (_props2$onClick = props2.onClick) === null || _props2$onClick === void 0 || _props2$onClick.call(props2, params);
      context.emit("click", params);
    };
    var onClearClick = function onClearClick(ctx) {
      var _props2$onClear;
      clearAll(ctx);
      setTInputValue("", {
        e: ctx.e,
        trigger: "clear"
      });
      (_props2$onClear = props2.onClear) === null || _props2$onClear === void 0 || _props2$onClear.call(props2, ctx);
      context.emit("clear", ctx);
    };
    VueCompositionAPI.watch(function () {
      return isScrollable.value;
    }, function (v) {
      if (props2.excessTagsDisplayType !== "scroll") return;
      var scrollElementClass = "".concat(classPrefix.value, "-input__prefix");
      var scrollElement = tagInputRef.value.$el.querySelector(".".concat(scrollElementClass));
      if (v) scrollElement.classList.add("".concat(scrollElementClass, "--scrollable"));else scrollElement.classList.remove("".concat(scrollElementClass, "--scrollable"));
    });
    return {
      tagValue: tagValue,
      tInputValue: tInputValue,
      isHover: isHover,
      tagInputPlaceholder: tagInputPlaceholder,
      showClearIcon: showClearIcon,
      tagInputRef: tagInputRef,
      classPrefix: classPrefix,
      classes: classes,
      componentName: COMPONENT_NAME,
      setTInputValue: setTInputValue,
      addHover: addHover,
      cancelHover: cancelHover,
      onInputEnter: onInputEnter,
      onInnerEnter: onInnerEnter,
      onInputBackspaceKeyUp: onInputBackspaceKeyUp,
      onInputBackspaceKeyDown: onInputBackspaceKeyDown,
      renderLabel: renderLabel,
      onWheel: onWheel,
      scrollToRightOnEnter: scrollToRightOnEnter,
      scrollToLeftOnLeave: scrollToLeftOnLeave,
      onClearClick: onClearClick,
      onInnerClick: onInnerClick,
      onClose: onClose,
      onInputCompositionstart: onInputCompositionstart,
      onInputCompositionend: onInputCompositionend,
      CloseCircleFilledIcon: CloseCircleFilledIcon
    };
  },
  render: function render(h) {
    var _this = this,
      _this$inputProps,
      _this$inputProps2,
      _this$tagValue;
    var CloseCircleFilledIcon = this.CloseCircleFilledIcon;
    var suffixIconNode = this.showClearIcon ? h(CloseCircleFilledIcon, {
      "class": "".concat(this.componentName, "__suffix-clear"),
      "on": {
        "click": this.onClearClick
      }
    }) : utils_renderTnode.renderTNodeJSX(this, "suffixIcon");
    var suffixClass = "".concat(this.classPrefix, "-tag-input__with-suffix-icon");
    if (suffixIconNode && !this.classes.includes(suffixClass)) {
      this.classes.push(suffixClass);
    }
    var prefixIconNode = utils_renderTnode.renderTNodeJSX(this, "prefixIcon");
    var displayNode = utils_renderTnode.renderTNodeJSX(this, "valueDisplay", {
      params: {
        value: this.tagValue,
        onClose: function onClose(index) {
          return _this.onClose({
            index: index
          });
        }
      }
    });
    var _label = utils_renderTnode.renderTNodeJSX(this, "label", {
      silent: true
    });
    var readonly = this.readonly || ((_this$inputProps = this.inputProps) === null || _this$inputProps === void 0 ? void 0 : _this$inputProps.readonly);
    return h(input_index.Input, helper.helper([{
      "ref": "tagInputRef",
      "attrs": {
        "borderless": this.borderless,
        "readonly": readonly,
        "inputClass": (_this$inputProps2 = this.inputProps) === null || _this$inputProps2 === void 0 ? void 0 : _this$inputProps2.inputClass,
        "value": this.tInputValue,
        "showInput": !readonly || !this.tagValue || !((_this$tagValue = this.tagValue) !== null && _this$tagValue !== void 0 && _this$tagValue.length),
        "keepWrapperWidth": !this.autoWidth,
        "autoWidth": true,
        "size": this.size,
        "disabled": this.disabled,
        "label": function label() {
          return _this.renderLabel({
            displayNode: displayNode,
            label: _label
          }, h);
        },
        "tips": this.tips,
        "status": this.status,
        "placeholder": this.tagInputPlaceholder,
        "suffix": this.suffix,
        "suffixIcon": function suffixIcon() {
          return suffixIconNode;
        },
        "prefixIcon": function prefixIcon() {
          return prefixIconNode;
        }
      },
      "class": this.classes
    }, {
      "props": this.inputProps
    }, {
      "scopedSlots": this.$scopedSlots
    }, {
      "on": {
        change: function change(val, context) {
          _this.setTInputValue(val, _objectSpread(_objectSpread({}, context), {}, {
            trigger: "input"
          }));
        },
        enter: this.onInputEnter,
        keyup: this.onInputBackspaceKeyUp,
        keydown: this.onInputBackspaceKeyDown,
        mouseenter: function mouseenter(context) {
          _this.addHover(context);
          _this.scrollToRightOnEnter();
        },
        mouseleave: function mouseleave(context) {
          _this.cancelHover(context);
          _this.scrollToLeftOnLeave();
        },
        focus: function focus(inputValue, context) {
          var _this$onFocus;
          (_this$onFocus = _this.onFocus) === null || _this$onFocus === void 0 || _this$onFocus.call(_this, _this.tagValue, {
            e: context.e,
            inputValue: inputValue
          });
          _this.$emit("focus", _this.tagValue, {
            e: context.e,
            inputValue: inputValue
          });
        },
        blur: function blur(inputValue, context) {
          var _this$onBlur;
          _this.setTInputValue("", {
            e: context.e,
            trigger: "blur"
          });
          (_this$onBlur = _this.onBlur) === null || _this$onBlur === void 0 || _this$onBlur.call(_this, _this.tagValue, {
            e: context.e,
            inputValue: ""
          });
          _this.$emit("blur", _this.tagValue, {
            e: context.e,
            inputValue: ""
          });
        },
        paste: function paste(context) {
          var _this$onPaste;
          (_this$onPaste = _this.onPaste) === null || _this$onPaste === void 0 || _this$onPaste.call(_this, context);
          _this.$emit("paste", context);
        },
        click: this.onInnerClick,
        compositionstart: this.onInputCompositionstart,
        compositionend: this.onInputCompositionend,
        mousewheel: this.onWheel
      }
    }]));
  }
});

exports["default"] = _TagInput;
//# sourceMappingURL=tag-input.js.map
