/**
 * tdesign v1.12.0
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var helper = require('../_chunks/dep-27ac0b8c.js');
var _defineProperty = require('@babel/runtime/helpers/defineProperty');
var _toConsumableArray = require('@babel/runtime/helpers/toConsumableArray');
var _slicedToArray = require('@babel/runtime/helpers/slicedToArray');
var VueCompositionAPI = require('@vue/composition-api');
var tag_index = require('../tag/index.js');
var hooks_useVModel = require('../hooks/useVModel.js');
var hooks_tnode = require('../hooks/tnode.js');
var configProvider_useConfig = require('../config-provider/useConfig.js');
require('../tag/tag.js');
require('@babel/runtime/helpers/typeof');
require('tdesign-icons-vue');
require('tinycolor2');
require('../tag/props.js');
require('../utils/mixins.js');
require('vue');
require('../config-provider/config-receiver.js');
require('../_chunks/dep-65c8d021.js');
require('../_common/js/global-config/default-config.js');
require('../_common/js/global-config/locale/zh_CN.js');
require('../_chunks/dep-bc99824f.js');
require('../_chunks/dep-4effc6c4.js');
require('dayjs');
require('../_chunks/dep-d59c4646.js');
require('../_chunks/dep-11382958.js');
require('../_chunks/dep-c272f99f.js');
require('../_chunks/dep-89b9f4de.js');
require('../_chunks/dep-1c1cc34f.js');
require('../_chunks/dep-31fa06d0.js');
require('../_chunks/dep-ba816077.js');
require('../_chunks/dep-852fc6a9.js');
require('../_chunks/dep-c9d43e30.js');
require('../_chunks/dep-f4d07ab0.js');
require('../_chunks/dep-36c57efe.js');
require('../_chunks/dep-23d55f82.js');
require('../_chunks/dep-bc3ec918.js');
require('../_chunks/dep-f97b0058.js');
require('../_chunks/dep-9a119db9.js');
require('../_chunks/dep-49887b48.js');
require('../_chunks/dep-06c569d8.js');
require('../_chunks/dep-4d554a6f.js');
require('../_chunks/dep-7ec0f498.js');
require('../_chunks/dep-fcdc23bb.js');
require('../_chunks/dep-59f3051f.js');
require('../_chunks/dep-b86e0f9e.js');
require('../utils/render-tnode.js');
require('@babel/runtime/helpers/readOnlyError');
require('../_chunks/dep-f0f28315.js');
require('../_chunks/dep-7ed5d19e.js');
require('../_chunks/dep-f8b182e9.js');
require('../_chunks/dep-0f4ac92d.js');
require('../_chunks/dep-2f28fbd7.js');
require('../_chunks/dep-76d8c62c.js');
require('../_chunks/dep-2f0c3d6d.js');
require('../_chunks/dep-b08014cb.js');
require('../utils/event.js');
require('../utils/helper.js');
require('@babel/runtime/helpers/objectWithoutProperties');
require('../_chunks/dep-2e662da4.js');
require('../tag/check-tag.js');
require('../tag/check-tag-props.js');
require('../hooks/useConfig.js');
require('../_common/js/common.js');
require('../tag/check-tag-group.js');
require('../tag/check-tag-group-props.js');
require('../utils/withInstall.js');
require('../hooks/render-tnode.js');
require('../_chunks/dep-1974f455.js');
require('../_chunks/dep-b520fc3a.js');
require('../_chunks/dep-f2e07584.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var _defineProperty__default = /*#__PURE__*/_interopDefaultLegacy(_defineProperty);
var _toConsumableArray__default = /*#__PURE__*/_interopDefaultLegacy(_toConsumableArray);
var _slicedToArray__default = /*#__PURE__*/_interopDefaultLegacy(_slicedToArray);

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty__default["default"](e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function useTagList(props, context, getDragProps) {
  var renderTNode = hooks_tnode.useTNodeJSX();
  var _useConfig = configProvider_useConfig.useConfig("classPrefix"),
    classPrefix = _useConfig.classPrefix;
  var _toRefs = VueCompositionAPI.toRefs(props),
    value = _toRefs.value,
    onRemove = _toRefs.onRemove,
    max = _toRefs.max,
    minCollapsedNum = _toRefs.minCollapsedNum,
    size = _toRefs.size,
    disabled = _toRefs.disabled,
    readonly = _toRefs.readonly,
    tagProps = _toRefs.tagProps;
  var _useVModel = hooks_useVModel.useVModel(value, props.defaultValue || [], props.onChange, "change"),
    _useVModel2 = _slicedToArray__default["default"](_useVModel, 2),
    tagValue = _useVModel2[0],
    setTagValue = _useVModel2[1];
  var oldInputValue = VueCompositionAPI.ref();
  var onClose = function onClose(p) {
    var _onRemove$value;
    var arr = _toConsumableArray__default["default"](tagValue.value);
    var _arr$splice = arr.splice(p.index, 1),
      _arr$splice2 = _slicedToArray__default["default"](_arr$splice, 1),
      item = _arr$splice2[0];
    setTagValue(arr, _objectSpread({
      trigger: "tag-remove"
    }, p));
    var removeParams = _objectSpread(_objectSpread({}, p), {}, {
      item: item,
      trigger: "tag-remove",
      value: arr
    });
    (_onRemove$value = onRemove.value) === null || _onRemove$value === void 0 || _onRemove$value.call(onRemove, removeParams);
    context.emit("remove", removeParams);
  };
  var clearAll = function clearAll(context2) {
    setTagValue([], {
      trigger: "clear",
      e: context2.e
    });
  };
  var onInnerEnter = function onInnerEnter(value2, params) {
    var _tagValue$value, _props$onEnter;
    var valueStr = String(value2).trim();
    var newValue = tagValue.value;
    var isLimitExceeded = max && ((_tagValue$value = tagValue.value) === null || _tagValue$value === void 0 ? void 0 : _tagValue$value.length) >= max.value;
    if (!isLimitExceeded && valueStr) {
      newValue = tagValue.value instanceof Array ? tagValue.value.concat(String(valueStr)) : [valueStr];
      setTagValue(newValue, {
        trigger: "enter",
        index: newValue.length - 1,
        item: valueStr,
        e: params.e
      });
    }
    var enterEventParams = _objectSpread(_objectSpread({}, params), {}, {
      inputValue: value2
    });
    (_props$onEnter = props.onEnter) === null || _props$onEnter === void 0 || _props$onEnter.call(props, newValue, enterEventParams);
    context.emit("enter", newValue, enterEventParams);
  };
  var onInputBackspaceKeyUp = function onInputBackspaceKeyUp(value2) {
    if (!tagValue.value || !tagValue.value.length) return;
    oldInputValue.value = value2;
  };
  var onInputBackspaceKeyDown = function onInputBackspaceKeyDown(value2, p) {
    var e = p.e;
    if (!tagValue.value || !tagValue.value.length || readonly.value) return;
    var isDelete = /(Backspace|NumpadDelete)/.test(e.code) || /(Backspace|NumpadDelete)/.test(e.key);
    if (!value2 && isDelete) {
      var _onRemove$value2;
      var index = tagValue.value.length - 1;
      var item = tagValue.value[index];
      var trigger = "backspace";
      var newValue = tagValue.value.slice(0, -1);
      var params = {
        e: e,
        index: index,
        item: item,
        trigger: trigger
      };
      setTagValue(newValue, params);
      var removeParams = _objectSpread(_objectSpread({}, params), {}, {
        value: newValue
      });
      (_onRemove$value2 = onRemove.value) === null || _onRemove$value2 === void 0 || _onRemove$value2.call(onRemove, removeParams);
      context.emit("remove", removeParams);
    }
    oldInputValue.value = value2;
  };
  var renderLabel = function renderLabel(_ref, h) {
    var _newList$map;
    var displayNode = _ref.displayNode,
      label = _ref.label;
    var newList = minCollapsedNum.value ? tagValue.value.slice(0, minCollapsedNum.value) : tagValue.value;
    var list = displayNode ? [displayNode] : (newList === null || newList === void 0 || (_newList$map = newList.map) === null || _newList$map === void 0 ? void 0 : _newList$map.call(newList, function (item, index) {
      var tagContent = renderTNode("tag", {
        params: {
          value: item
        }
      });
      var TagNode = h(tag_index.Tag, helper.helper([{
        "key": index,
        "attrs": {
          "size": size.value,
          "disabled": disabled.value,
          "closable": !readonly.value && !disabled.value
        },
        "on": {
          "close": function close(context2) {
            return onClose({
              e: context2.e,
              index: index
            });
          }
        }
      }, {
        "props": tagProps.value
      }]), [tagContent !== null && tagContent !== void 0 ? tagContent : item]);
      var itemDrag = getDragProps === null || getDragProps === void 0 ? void 0 : getDragProps(index, item);
      return itemDrag && itemDrag.draggable ? h("span", {
        "class": "".concat(classPrefix.value, "-tag-input__drag_wrapper"),
        "attrs": {
          "draggable": true
        },
        "on": {
          "dragstart": itemDrag.onDragstart,
          "dragover": itemDrag.onDragover,
          "dragend": itemDrag.onDragend,
          "drop": itemDrag.onDrop
        }
      }, [TagNode]) : TagNode;
    })) || [];
    if (![null, void 0, ""].includes(label)) {
      list.unshift(h("div", {
        "class": "".concat(classPrefix.value, "-tag-input__prefix"),
        "key": "label"
      }, [label]));
    }
    if (newList.length !== tagValue.value.length) {
      var len = tagValue.value.length - newList.length;
      var more = renderTNode("collapsedItems", {
        params: {
          value: tagValue.value,
          count: tagValue.value.length - minCollapsedNum.value,
          collapsedTags: tagValue.value.slice(minCollapsedNum.value, tagValue.value.length),
          collapsedSelectedItems: tagValue.value.slice(minCollapsedNum.value, tagValue.value.length),
          onClose: onClose
        }
      });
      list.push(more !== null && more !== void 0 ? more : h(tag_index.Tag, helper.helper([{
        "key": "more",
        "attrs": {
          "size": size.value
        }
      }, {
        "props": tagProps.value
      }]), ["+", len]));
    }
    return list;
  };
  return {
    tagValue: tagValue,
    clearAll: clearAll,
    onClose: onClose,
    onInnerEnter: onInnerEnter,
    onInputBackspaceKeyUp: onInputBackspaceKeyUp,
    onInputBackspaceKeyDown: onInputBackspaceKeyDown,
    renderLabel: renderLabel
  };
}

exports["default"] = useTagList;
//# sourceMappingURL=useTagList.js.map
