/**
 * tdesign v1.12.0
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var _slicedToArray = require('@babel/runtime/helpers/slicedToArray');
var VueCompositionAPI = require('@vue/composition-api');
var hooks_useConfig = require('../hooks/useConfig.js');
var tag_checkTagGroupProps = require('./check-tag-group-props.js');
var tag_checkTag = require('./check-tag.js');
var hooks_useVModel = require('../hooks/useVModel.js');
var isFunction = require('../_chunks/dep-1c1cc34f.js');
require('../config-provider/useConfig.js');
require('../_chunks/dep-65c8d021.js');
require('../_common/js/global-config/default-config.js');
require('../_common/js/global-config/locale/zh_CN.js');
require('../_chunks/dep-bc99824f.js');
require('@babel/runtime/helpers/typeof');
require('../_chunks/dep-4effc6c4.js');
require('dayjs');
require('../_chunks/dep-d59c4646.js');
require('../_chunks/dep-11382958.js');
require('../_chunks/dep-c272f99f.js');
require('../_chunks/dep-89b9f4de.js');
require('../_chunks/dep-31fa06d0.js');
require('../_chunks/dep-ba816077.js');
require('../_chunks/dep-852fc6a9.js');
require('../_chunks/dep-c9d43e30.js');
require('../_chunks/dep-f4d07ab0.js');
require('../_chunks/dep-36c57efe.js');
require('../_chunks/dep-23d55f82.js');
require('../_chunks/dep-bc3ec918.js');
require('../_chunks/dep-f97b0058.js');
require('../_chunks/dep-9a119db9.js');
require('../_chunks/dep-49887b48.js');
require('../_chunks/dep-06c569d8.js');
require('../_chunks/dep-4d554a6f.js');
require('../_chunks/dep-7ec0f498.js');
require('../_chunks/dep-fcdc23bb.js');
require('../_chunks/dep-59f3051f.js');
require('../_chunks/dep-b86e0f9e.js');
require('../_chunks/dep-27ac0b8c.js');
require('@babel/runtime/helpers/defineProperty');
require('./check-tag-props.js');
require('./tag.js');
require('tdesign-icons-vue');
require('tinycolor2');
require('./props.js');
require('../utils/mixins.js');
require('vue');
require('../config-provider/config-receiver.js');
require('../utils/render-tnode.js');
require('@babel/runtime/helpers/readOnlyError');
require('../_chunks/dep-f0f28315.js');
require('../_chunks/dep-7ed5d19e.js');
require('../_chunks/dep-f8b182e9.js');
require('../_chunks/dep-0f4ac92d.js');
require('../_chunks/dep-2f28fbd7.js');
require('../_chunks/dep-76d8c62c.js');
require('../_chunks/dep-2f0c3d6d.js');
require('../_chunks/dep-b08014cb.js');
require('../utils/event.js');
require('../utils/helper.js');
require('@babel/runtime/helpers/objectWithoutProperties');
require('../_chunks/dep-2e662da4.js');
require('../_common/js/common.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var _slicedToArray__default = /*#__PURE__*/_interopDefaultLegacy(_slicedToArray);

var _CheckTagGroup = VueCompositionAPI.defineComponent({
  name: "TCheckTagGroup",
  props: tag_checkTagGroupProps["default"],
  setup: function setup(props2, context) {
    var _toRefs = VueCompositionAPI.toRefs(props2),
      value = _toRefs.value;
    var componentName = hooks_useConfig.usePrefixClass("check-tag-group");
    var checkTagGroupClasses = VueCompositionAPI.computed(function () {
      return [componentName.value];
    });
    var _useVModel = hooks_useVModel.useVModel(value, props2.defaultValue, props2.onChange),
      _useVModel2 = _slicedToArray__default["default"](_useVModel, 2),
      innerValue = _useVModel2[0],
      setInnerValue = _useVModel2[1];
    var onCheckTagChange = function onCheckTagChange(checked, ctx) {
      var value2 = ctx.value;
      if (checked) {
        if (props2.multiple) {
          setInnerValue(innerValue.value.concat(value2), {
            e: ctx.e,
            type: "check",
            value: value2
          });
        } else {
          setInnerValue([value2], {
            e: ctx.e,
            type: "check",
            value: value2
          });
        }
      } else {
        var newValue = [];
        if (props2.multiple) {
          newValue = innerValue.value.filter(function (t) {
            return t !== value2;
          });
        }
        setInnerValue(newValue, {
          e: ctx.e,
          type: "uncheck",
          value: value2
        });
      }
    };
    var getTagContent = function getTagContent(option) {
      if (context.slots.option) return context.slots.option(option);
      if (context.slots.label) return context.slots.label(option);
      if (option.label) {
        return isFunction.isFunction(option.label) ? option.label(VueCompositionAPI.h) : option.label;
      }
      if (option.content && isFunction.isFunction(option.content)) return option.content(VueCompositionAPI.h);
      if (option["default"] && isFunction.isFunction(option["default"])) return option["default"](VueCompositionAPI.h);
      return option.value;
    };
    return {
      innerValue: innerValue,
      checkTagGroupClasses: checkTagGroupClasses,
      onCheckTagChange: onCheckTagChange,
      getTagContent: getTagContent
    };
  },
  render: function render() {
    var _this = this;
    var h = arguments[0];
    return h("div", {
      "class": this.checkTagGroupClasses
    }, [(this.options || []).map(function (option) {
      return h(tag_checkTag["default"], {
        "key": option.value,
        "attrs": {
          "value": option.value,
          "checkedProps": _this.checkedProps,
          "uncheckedProps": _this.uncheckedProps,
          "checked": _this.innerValue.includes(option.value),
          "disabled": option.disabled,
          "size": option.size,
          "data-value": option.value
        },
        "on": {
          "change": _this.onCheckTagChange
        }
      }, [_this.getTagContent(option)]);
    })]);
  }
});

exports["default"] = _CheckTagGroup;
//# sourceMappingURL=check-tag-group.js.map
