/**
 * tdesign v1.12.0
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var _typeof = require('@babel/runtime/helpers/typeof');
var _defineProperty = require('@babel/runtime/helpers/defineProperty');
var tdesignIconsVue = require('tdesign-icons-vue');
var tinyColor = require('tinycolor2');
var tag_props = require('./props.js');
var utils_mixins = require('../utils/mixins.js');
var configProvider_configReceiver = require('../config-provider/config-receiver.js');
var utils_renderTnode = require('../utils/render-tnode.js');
var utils_event = require('../utils/event.js');
var isString = require('../_chunks/dep-2e662da4.js');
require('vue');
require('../_chunks/dep-65c8d021.js');
require('../_common/js/global-config/default-config.js');
require('../_common/js/global-config/locale/zh_CN.js');
require('../_chunks/dep-bc99824f.js');
require('../_chunks/dep-4effc6c4.js');
require('dayjs');
require('../_chunks/dep-d59c4646.js');
require('../_chunks/dep-11382958.js');
require('../_chunks/dep-c272f99f.js');
require('../_chunks/dep-89b9f4de.js');
require('../_chunks/dep-1c1cc34f.js');
require('../_chunks/dep-31fa06d0.js');
require('../_chunks/dep-ba816077.js');
require('../_chunks/dep-852fc6a9.js');
require('../_chunks/dep-c9d43e30.js');
require('../_chunks/dep-f4d07ab0.js');
require('../_chunks/dep-36c57efe.js');
require('../_chunks/dep-23d55f82.js');
require('../_chunks/dep-bc3ec918.js');
require('../_chunks/dep-f97b0058.js');
require('../_chunks/dep-9a119db9.js');
require('../_chunks/dep-49887b48.js');
require('../_chunks/dep-06c569d8.js');
require('../_chunks/dep-4d554a6f.js');
require('../_chunks/dep-7ec0f498.js');
require('../_chunks/dep-fcdc23bb.js');
require('../_chunks/dep-59f3051f.js');
require('../_chunks/dep-b86e0f9e.js');
require('@babel/runtime/helpers/readOnlyError');
require('@vue/composition-api');
require('../_chunks/dep-f0f28315.js');
require('../_chunks/dep-7ed5d19e.js');
require('../_chunks/dep-f8b182e9.js');
require('../_chunks/dep-0f4ac92d.js');
require('../_chunks/dep-2f28fbd7.js');
require('../_chunks/dep-76d8c62c.js');
require('../_chunks/dep-2f0c3d6d.js');
require('../_chunks/dep-b08014cb.js');
require('../utils/helper.js');
require('@babel/runtime/helpers/objectWithoutProperties');
require('@babel/runtime/helpers/slicedToArray');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var _typeof__default = /*#__PURE__*/_interopDefaultLegacy(_typeof);
var _defineProperty__default = /*#__PURE__*/_interopDefaultLegacy(_defineProperty);
var tinyColor__default = /*#__PURE__*/_interopDefaultLegacy(tinyColor);

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty__default["default"](e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var _Tag = utils_mixins["default"](configProvider_configReceiver["default"]("tag"), configProvider_configReceiver.getGlobalIconMixins()).extend({
  name: "TTag",
  props: _objectSpread({}, tag_props["default"]),
  computed: {
    tagClass: function tagClass() {
      return ["".concat(this.componentName), "".concat(this.componentName, "--").concat(this.theme), "".concat(this.componentName, "--").concat(this.variant), this.shape !== "square" && "".concat(this.componentName, "--").concat(this.shape), _defineProperty__default["default"](_defineProperty__default["default"](_defineProperty__default["default"](_defineProperty__default["default"](_defineProperty__default["default"]({}, this.commonSizeClassName[this.size], this.size !== "medium"), "".concat(this.componentName, "--ellipsis"), this.maxWidth), "".concat(this.componentName, "--close"), this.closable), "".concat(this.classPrefix, "-is-disabled"), this.disabled), "".concat(this.componentName, "--disabled"), this.disabled)];
    },
    textStyle: function textStyle() {
      if (this.maxWidth) {
        return {
          maxWidth: isNaN(Number(this.maxWidth)) ? this.maxWidth : "".concat(this.maxWidth, "px")
        };
      }
      return {};
    },
    tagStyle: function tagStyle() {
      if (this.color) {
        return this.getTagColorStyle();
      }
      return {};
    }
  },
  methods: {
    handleClose: function handleClose(e) {
      if (this.disabled) return;
      utils_event.emitEvent(this, "close", {
        e: e
      });
    },
    handleClick: function handleClick(e) {
      if (this.disabled) return;
      utils_event.emitEvent(this, "click", {
        e: e
      });
    },
    getCloseIcon: function getCloseIcon() {
      var _this = this;
      var h = this.$createElement;
      if (!this.closable) return null;
      var iconClassName = "".concat(this.classPrefix, "-tag__icon-close");
      if (this.global.closeIcon) {
        return this.global.closeIcon(function (component, b) {
          var tProps = _typeof__default["default"](b) === "object" && "attrs" in b ? b.attrs : {};
          return _this.$createElement(component, {
            props: _objectSpread({}, tProps),
            "class": iconClassName,
            nativeOn: {
              click: _this.handleClose
            }
          });
        });
      }
      var _this$useGlobalIcon = this.useGlobalIcon({
          CloseIcon: tdesignIconsVue.CloseIcon
        }),
        CloseIcon = _this$useGlobalIcon.CloseIcon;
      return h(CloseIcon, {
        "nativeOn": {
          "click": this.handleClose
        },
        "class": iconClassName
      });
    },
    getTagColorStyle: function getTagColorStyle() {
      var _this2 = this;
      var luminance = tinyColor__default["default"](this.color).getLuminance();
      var style = {
        color: luminance > 0.5 ? "black" : "white"
      };
      if (this.variant === "outline" || this.variant === "light-outline") {
        style.borderColor = this.color;
      }
      if (this.variant !== "outline") {
        var getLightestShade = function getLightestShade() {
          var _tinycolor$toRgb = tinyColor__default["default"](_this2.color).toRgb(),
            r = _tinycolor$toRgb.r,
            g = _tinycolor$toRgb.g,
            b = _tinycolor$toRgb.b;
          return "rgba(".concat(r, ", ").concat(g, ", ").concat(b, ", 0.1)");
        };
        style.backgroundColor = this.variant === "dark" ? this.color : getLightestShade();
      }
      if (this.variant !== "dark") {
        style.color = this.color;
      }
      return style;
    },
    renderTitle: function renderTitle(tagContent) {
      var vProps = this.$vnode.componentOptions.propsData || {};
      if (Reflect.has(vProps, "title")) {
        return vProps.title || void 0;
      }
      if (tagContent) {
        return tagContent;
      }
      return void 0;
    }
  },
  render: function render() {
    var h = arguments[0];
    var closeIcon = this.getCloseIcon();
    var tagContent = utils_renderTnode.renderContent(this, "default", "content");
    var title = this.renderTitle(isString.isString(tagContent) ? tagContent : "");
    var icon = utils_renderTnode.renderTNodeJSX(this, "icon");
    return h("div", {
      "class": this.tagClass,
      "on": {
        "click": this.handleClick
      },
      "style": this.tagStyle
    }, [icon, h("span", {
      "class": this.maxWidth ? "".concat(this.componentName, "--text") : void 0,
      "style": this.textStyle,
      "attrs": {
        "title": title
      }
    }, [tagContent]), !this.disabled ? closeIcon : void 0]);
  }
});

exports["default"] = _Tag;
//# sourceMappingURL=tag.js.map
