/**
 * tdesign v1.12.0
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var _defineProperty = require('@babel/runtime/helpers/defineProperty');
var VueCompositionAPI = require('@vue/composition-api');
var dayjs = require('dayjs');
var customParseFormat = require('../../_chunks/dep-423cb508.js');
var _common_js_timePicker_const = require('../../_common/js/time-picker/const.js');
var timePicker_panel_props = require('./props.js');
var timePicker_panel_singlePanel = require('./single-panel.js');
var button_button = require('../../button/button.js');
var hooks_useConfig = require('../../hooks/useConfig.js');
var _common_js_log_log = require('../../_common/js/log/log.js');
var configProvider_useConfig = require('../../config-provider/useConfig.js');
require('../../_chunks/dep-4effc6c4.js');
require('../props.js');
require('../../_common/js/time-picker/utils.js');
require('../../_chunks/dep-e9318595.js');
require('../../_chunks/dep-ba816077.js');
require('@babel/runtime/helpers/typeof');
require('../../_chunks/dep-31fa06d0.js');
require('../../_chunks/dep-50b0a969.js');
require('../../_chunks/dep-0f4ac92d.js');
require('../../_chunks/dep-f4d07ab0.js');
require('../../_chunks/dep-b86e0f9e.js');
require('../../_chunks/dep-852fc6a9.js');
require('../../_chunks/dep-bc3ec918.js');
require('../../_chunks/dep-1c1cc34f.js');
require('../../_chunks/dep-9a119db9.js');
require('../../_chunks/dep-2ab94c6c.js');
require('../../_chunks/dep-f8b182e9.js');
require('../../_chunks/dep-36c57efe.js');
require('../../_chunks/dep-2f28fbd7.js');
require('../../_chunks/dep-76d8c62c.js');
require('../../_chunks/dep-81ddbae0.js');
require('../../loading/index.js');
require('../../loading/directive.js');
require('../../loading/plugin.js');
require('vue');
require('../../loading/loading.js');
require('../../loading/icon/gradient.js');
require('../../_common/js/loading/circle-adapter.js');
require('../../_common/js/utils/setStyle.js');
require('../../_common/js/utils/helper.js');
require('@babel/runtime/helpers/toConsumableArray');
require('@babel/runtime/helpers/objectWithoutProperties');
require('@babel/runtime/helpers/slicedToArray');
require('../../_chunks/dep-caea5f4e.js');
require('../../_chunks/dep-1fe4c69b.js');
require('../../_chunks/dep-2e662da4.js');
require('../../_chunks/dep-260a7245.js');
require('../../config-provider/config-receiver.js');
require('../../_chunks/dep-65c8d021.js');
require('../../_common/js/global-config/default-config.js');
require('../../_common/js/global-config/locale/zh_CN.js');
require('../../_chunks/dep-bc99824f.js');
require('../../_chunks/dep-d59c4646.js');
require('../../_chunks/dep-11382958.js');
require('../../_chunks/dep-c272f99f.js');
require('../../_chunks/dep-89b9f4de.js');
require('../../_chunks/dep-c9d43e30.js');
require('../../_chunks/dep-23d55f82.js');
require('../../_chunks/dep-f97b0058.js');
require('../../_chunks/dep-49887b48.js');
require('../../_chunks/dep-06c569d8.js');
require('../../_chunks/dep-4d554a6f.js');
require('../../_chunks/dep-7ec0f498.js');
require('../../_chunks/dep-fcdc23bb.js');
require('../../_chunks/dep-59f3051f.js');
require('../../utils/mixins.js');
require('../../utils/dom.js');
require('raf');
require('../../utils/easing.js');
require('../../utils/render-tnode.js');
require('@babel/runtime/helpers/readOnlyError');
require('../../_chunks/dep-f0f28315.js');
require('../../_chunks/dep-7ed5d19e.js');
require('../../_chunks/dep-2f0c3d6d.js');
require('../../_chunks/dep-b08014cb.js');
require('../../utils/transfer-dom.js');
require('../../loading/props.js');
require('../../config.js');
require('../../_chunks/dep-029c3522.js');
require('../../_chunks/dep-c63385b6.js');
require('../../_chunks/dep-ab17e69e.js');
require('../../_chunks/dep-87dae4a0.js');
require('../../_chunks/dep-07989e63.js');
require('../../_chunks/dep-d3e77112.js');
require('../../_chunks/dep-b520fc3a.js');
require('../../_chunks/dep-f2e07584.js');
require('../../_chunks/dep-9a183e68.js');
require('../../_chunks/dep-5c93d051.js');
require('../../_chunks/dep-76dea031.js');
require('../../_chunks/dep-56240b5e.js');
require('../../utils/withInstall.js');
require('../../button/props.js');
require('../../utils/ripple.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var _defineProperty__default = /*#__PURE__*/_interopDefaultLegacy(_defineProperty);
var dayjs__default = /*#__PURE__*/_interopDefaultLegacy(dayjs);

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty__default["default"](e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
dayjs__default["default"].extend(customParseFormat.customParseFormat);
var _TimePickerPanel = VueCompositionAPI.defineComponent({
  name: "TTimePickerPanel",
  props: _objectSpread(_objectSpread({}, timePicker_panel_props.panelProps()), {}, {
    handleConfirmClick: Function,
    onChange: Function,
    onPick: Function,
    disableTime: Function
  }),
  setup: function setup(props, ctx) {
    var panelClassName = hooks_useConfig.usePrefixClass("time-picker__panel");
    var triggerScroll = VueCompositionAPI.ref(false);
    var _useConfig = configProvider_useConfig.useConfig("timePicker"),
      global = _useConfig.global;
    var showNowTimeBtn = VueCompositionAPI.computed(function () {
      return !!props.steps.filter(function (v) {
        return v > 1;
      }).length;
    });
    var defaultValue = VueCompositionAPI.computed(function () {
      var isStepsSet = showNowTimeBtn.value;
      var formattedValue = dayjs__default["default"](props.value, props.format);
      if (props.value && formattedValue.isValid()) {
        return formattedValue;
      }
      if (isStepsSet) {
        return dayjs__default["default"]().hour(0).minute(0).second(0);
      }
      return dayjs__default["default"]().hour(0).minute(0).second(0).format(props.format);
    });
    var panelColUpdate = function panelColUpdate() {
      VueCompositionAPI.nextTick(function () {
        triggerScroll.value = true;
      });
    };
    var resetTriggerScroll = function resetTriggerScroll() {
      triggerScroll.value = false;
    };
    var handleChange = function handleChange(v, e) {
      var _props$onPick, _props$onChange;
      (_props$onPick = props.onPick) === null || _props$onPick === void 0 || _props$onPick.call(props, v, e);
      ctx.emit("pick", v, e);
      (_props$onChange = props.onChange) === null || _props$onChange === void 0 || _props$onChange.call(props, v);
      ctx.emit("change", v);
    };
    var handlePresetClick = function handlePresetClick(presetValue) {
      var presetVal = typeof presetValue === "function" ? presetValue() : presetValue;
      if (typeof props.activeIndex === "number") {
        if (Array.isArray(presetVal)) {
          props.onChange(presetVal[props.activeIndex]);
        } else {
          _common_js_log_log["default"].error("TimePicker", "preset: ".concat(props.presets, " \u9884\u8BBE\u503C\u5FC5\u987B\u662F\u6570\u7EC4!"));
        }
      } else {
        props.onChange(presetVal);
      }
    };
    VueCompositionAPI.onMounted(function () {
      panelColUpdate();
    });
    VueCompositionAPI.watch(function () {
      return props.isShowPanel;
    }, function () {
      panelColUpdate();
    });
    return {
      showNowTimeBtn: showNowTimeBtn,
      panelClassName: panelClassName,
      triggerScroll: triggerScroll,
      resetTriggerScroll: resetTriggerScroll,
      defaultValue: defaultValue,
      global: global,
      handleChange: handleChange,
      handlePresetClick: handlePresetClick
    };
  },
  render: function render() {
    var _this = this;
    var h = arguments[0];
    return h("div", {
      "class": this.panelClassName
    }, [h("div", {
      "class": "".concat(this.panelClassName, "-section-body")
    }, [h(timePicker_panel_singlePanel["default"], {
      "props": _objectSpread({}, {
        value: dayjs__default["default"](this.value, this.format).isValid() ? this.value : this.defaultValue,
        onChange: this.handleChange,
        onPick: this.onPick,
        format: this.format || _common_js_timePicker_const.DEFAULT_FORMAT,
        steps: this.steps || _common_js_timePicker_const.DEFAULT_STEPS,
        triggerScroll: this.triggerScroll,
        disableTime: this.disableTime,
        position: this.position,
        resetTriggerScroll: this.resetTriggerScroll,
        isShowPanel: this.isShowPanel,
        hideDisabledTime: this.hideDisabledTime
      })
    })]), this.isFooterDisplay ? h("div", {
      "class": "".concat(this.panelClassName, "-section-footer")
    }, [h(button_button["default"], {
      "attrs": {
        "theme": "primary",
        "variant": "base",
        "disabled": !this.value,
        "size": "small"
      },
      "on": {
        "click": function click() {
          return _this.handleConfirmClick(_this.defaultValue);
        }
      }
    }, [this.global.confirm]), h("div", [!this.showNowTimeBtn ? h(button_button["default"], {
      "attrs": {
        "theme": "primary",
        "variant": "text",
        "size": "small"
      },
      "on": {
        "click": function click() {
          return _this.onChange(dayjs__default["default"]().format(_this.format));
        }
      }
    }, [this.global.now]) : null, this.presets && Object.keys(this.presets).map(function (key) {
      return h(button_button["default"], {
        "key": key,
        "attrs": {
          "theme": "primary",
          "size": "small",
          "variant": "text"
        },
        "on": {
          "click": function click() {
            var _this$handlePresetCli;
            return (_this$handlePresetCli = _this.handlePresetClick) === null || _this$handlePresetCli === void 0 ? void 0 : _this$handlePresetCli.call(_this, _this.presets[key]);
          }
        }
      }, [key]);
    })])]) : null]);
  }
});

exports["default"] = _TimePickerPanel;
//# sourceMappingURL=time-picker-panel.js.map
