/**
 * tdesign v1.12.0
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var _defineProperty = require('@babel/runtime/helpers/defineProperty');
var VueCompositionAPI = require('@vue/composition-api');
var loading_index = require('../loading/index.js');
var timeline_utils = require('./utils.js');
var timeline_timelineItemProps = require('./timeline-item-props.js');
var hooks_useConfig = require('../hooks/useConfig.js');
var utils_renderTnode = require('../utils/render-tnode.js');
require('../loading/directive.js');
require('../loading/plugin.js');
require('vue');
require('../loading/loading.js');
require('../loading/icon/gradient.js');
require('../_common/js/loading/circle-adapter.js');
require('../_common/js/utils/setStyle.js');
require('../_common/js/utils/helper.js');
require('@babel/runtime/helpers/toConsumableArray');
require('@babel/runtime/helpers/objectWithoutProperties');
require('@babel/runtime/helpers/slicedToArray');
require('../_chunks/dep-caea5f4e.js');
require('../_chunks/dep-1fe4c69b.js');
require('../_chunks/dep-2e662da4.js');
require('../_chunks/dep-31fa06d0.js');
require('@babel/runtime/helpers/typeof');
require('../_chunks/dep-36c57efe.js');
require('../_chunks/dep-f4d07ab0.js');
require('../_chunks/dep-260a7245.js');
require('../config-provider/config-receiver.js');
require('../_chunks/dep-65c8d021.js');
require('../_common/js/global-config/default-config.js');
require('../_common/js/global-config/locale/zh_CN.js');
require('../_chunks/dep-bc99824f.js');
require('../_chunks/dep-4effc6c4.js');
require('dayjs');
require('../_chunks/dep-d59c4646.js');
require('../_chunks/dep-11382958.js');
require('../_chunks/dep-c272f99f.js');
require('../_chunks/dep-89b9f4de.js');
require('../_chunks/dep-1c1cc34f.js');
require('../_chunks/dep-ba816077.js');
require('../_chunks/dep-852fc6a9.js');
require('../_chunks/dep-c9d43e30.js');
require('../_chunks/dep-23d55f82.js');
require('../_chunks/dep-bc3ec918.js');
require('../_chunks/dep-f97b0058.js');
require('../_chunks/dep-9a119db9.js');
require('../_chunks/dep-49887b48.js');
require('../_chunks/dep-06c569d8.js');
require('../_chunks/dep-4d554a6f.js');
require('../_chunks/dep-7ec0f498.js');
require('../_chunks/dep-fcdc23bb.js');
require('../_chunks/dep-59f3051f.js');
require('../_chunks/dep-b86e0f9e.js');
require('../utils/mixins.js');
require('../utils/dom.js');
require('raf');
require('../utils/easing.js');
require('../utils/transfer-dom.js');
require('../loading/props.js');
require('@babel/runtime/helpers/readOnlyError');
require('../_chunks/dep-f0f28315.js');
require('../_chunks/dep-7ed5d19e.js');
require('../_chunks/dep-f8b182e9.js');
require('../_chunks/dep-0f4ac92d.js');
require('../_chunks/dep-2f28fbd7.js');
require('../_chunks/dep-76d8c62c.js');
require('../_chunks/dep-2f0c3d6d.js');
require('../_chunks/dep-b08014cb.js');
require('../config.js');
require('../_chunks/dep-029c3522.js');
require('../_chunks/dep-c63385b6.js');
require('../_chunks/dep-ab17e69e.js');
require('../_chunks/dep-87dae4a0.js');
require('../_chunks/dep-07989e63.js');
require('../_chunks/dep-d3e77112.js');
require('../_chunks/dep-b520fc3a.js');
require('../_chunks/dep-f2e07584.js');
require('../_chunks/dep-9a183e68.js');
require('../_chunks/dep-5c93d051.js');
require('../_chunks/dep-76dea031.js');
require('../_chunks/dep-56240b5e.js');
require('../_chunks/dep-81ddbae0.js');
require('../utils/withInstall.js');
require('../_common/js/log/log.js');
require('../config-provider/useConfig.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var _defineProperty__default = /*#__PURE__*/_interopDefaultLegacy(_defineProperty);

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty__default["default"](e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var DEFAULT_THEME = ["primary", "warning", "error", "default"];
var _TimelineItem = VueCompositionAPI.defineComponent({
  name: "TTimelineItem",
  components: {
    TLoading: loading_index.Loading
  },
  props: _objectSpread({}, timeline_timelineItemProps["default"]),
  setup: function setup(props, context) {
    var instance = VueCompositionAPI.getCurrentInstance();
    var classPrefix = hooks_useConfig.usePrefixClass();
    var timelineProvider = VueCompositionAPI.inject("TTimeline", {
      layout: "vertical",
      reverse: false,
      theme: void 0,
      labelAlign: "left",
      mode: "alternate"
    });
    var layout = timelineProvider.layout,
      reverse = timelineProvider.reverse,
      theme = timelineProvider.theme,
      labelAlign = timelineProvider.labelAlign,
      mode = timelineProvider.mode;
    var _toRefs = VueCompositionAPI.toRefs(props),
      dotColor = _toRefs.dotColor,
      itemLabelAlign = _toRefs.labelAlign,
      loading = _toRefs.loading;
    var timelineItemAlign = VueCompositionAPI.computed(function () {
      var _itemLabelAlign$value;
      return (_itemLabelAlign$value = itemLabelAlign.value) !== null && _itemLabelAlign$value !== void 0 ? _itemLabelAlign$value : timeline_utils["default"](labelAlign === null || labelAlign === void 0 ? void 0 : labelAlign.value, layout === null || layout === void 0 ? void 0 : layout.value);
    });
    var uidArr = VueCompositionAPI.computed(function () {
      var _instance$parent$slot;
      var defaultSlots = (_instance$parent$slot = instance.parent.slots["default"]) !== null && _instance$parent$slot !== void 0 ? _instance$parent$slot : [null];
      return defaultSlots.map(function (item) {
        var _item$componentInstan;
        return item === null || item === void 0 || (_item$componentInstan = item.componentInstance) === null || _item$componentInstan === void 0 ? void 0 : _item$componentInstan._uid;
      });
    });
    var currentIndex = VueCompositionAPI.computed(function () {
      var index = 0;
      uidArr.value.forEach(function (item, itemIndex) {
        if (item === instance.uid) {
          index = itemIndex;
        }
      });
      return index;
    });
    var positionClassName = VueCompositionAPI.computed(function () {
      var left = (layout === null || layout === void 0 ? void 0 : layout.value) === "horizontal" ? "top" : "left";
      var right = (layout === null || layout === void 0 ? void 0 : layout.value) === "horizontal" ? "bottom" : "right";
      if (timelineItemAlign.value === "alternate") {
        return currentIndex.value % 2 === 0 ? "".concat(classPrefix.value, "-timeline-item-").concat(left) : "".concat(classPrefix.value, "-timeline-item-").concat(right);
      }
      if (timelineItemAlign.value === "left" || timelineItemAlign.value === "top") {
        return "".concat(classPrefix.value, "-timeline-item-").concat(left);
      }
      if (timelineItemAlign.value === "right" || timelineItemAlign.value === "bottom") {
        return "".concat(classPrefix.value, "-timeline-item-").concat(right);
      }
      return "";
    });
    var getItemClassName = VueCompositionAPI.computed(function () {
      var isLastChildren = uidArr.value.length - 1 === currentIndex.value;
      var lastClassName = isLastChildren ? "".concat(classPrefix.value, "-timeline-item--last") : "";
      return "".concat(classPrefix.value, "-timeline-item ").concat(positionClassName.value, " ").concat(lastClassName);
    });
    var tailClassName = VueCompositionAPI.computed(function () {
      var statusClassName = reverse ? "".concat(classPrefix.value, "-timeline-item__tail--status-").concat(dotColor === null || dotColor === void 0 ? void 0 : dotColor.value) : "";
      return "".concat(classPrefix.value, "-timeline-item__tail ").concat(classPrefix.value, "-timeline-item__tail--theme-").concat(theme === null || theme === void 0 ? void 0 : theme.value, " ").concat(statusClassName);
    });
    var dotElement = VueCompositionAPI.computed(function () {
      return Boolean(context.slots.dot || props.dot);
    });
    var dotClassName = VueCompositionAPI.computed(function () {
      var dotCustomClassName = !!dotElement.value || !dotElement.value && loading !== null && loading !== void 0 && loading.value ? "".concat(classPrefix.value, "-timeline-item__dot--custom") : "";
      var docColorClassName = DEFAULT_THEME.includes(dotColor === null || dotColor === void 0 ? void 0 : dotColor.value) ? "".concat(classPrefix.value, "-timeline-item__dot--").concat(dotColor === null || dotColor === void 0 ? void 0 : dotColor.value) : "";
      return "".concat(classPrefix.value, "-timeline-item__dot ").concat(dotCustomClassName, " ").concat(docColorClassName);
    });
    var labelClassName = VueCompositionAPI.computed(function () {
      return "".concat(classPrefix.value, "-timeline-item__label ").concat(classPrefix.value, "-timeline-item__label--").concat(mode === null || mode === void 0 ? void 0 : mode.value);
    });
    return {
      mode: mode,
      currentIndex: currentIndex,
      tailClassName: tailClassName,
      dotClassName: dotClassName,
      labelClassName: labelClassName,
      getItemClassName: getItemClassName,
      classPrefix: classPrefix
    };
  },
  render: function render() {
    var _dotElement$;
    var h = arguments[0];
    var dotColor = this.dotColor,
      dotClassName = this.dotClassName,
      _this$style = this.style,
      style = _this$style === void 0 ? {} : _this$style,
      labelClassName = this.labelClassName,
      mode = this.mode,
      loading = this.loading,
      tailClassName = this.tailClassName,
      getItemClassName = this.getItemClassName,
      _this$classPrefix = this.classPrefix,
      classPrefix = _this$classPrefix === void 0 ? "t" : _this$classPrefix;
    var dotElement = utils_renderTnode.renderTNodeJSX(this, "dot");
    var labelNode = utils_renderTnode.renderTNodeJSX(this, "label");
    var dotContentClass = "".concat(classPrefix, "-timeline-item__dot-content");
    if (Array.isArray(dotElement) && (_dotElement$ = dotElement[0]) !== null && _dotElement$ !== void 0 && _dotElement$.data) {
      var classes = dotElement[0].data["class"];
      dotElement[0].data["class"] = classes ? [classes, dotContentClass].join(" ") : dotContentClass;
    }
    return h("li", {
      "class": getItemClassName,
      "style": style
    }, [mode === "alternate" && labelNode && h("div", {
      "class": labelClassName
    }, [labelNode]), h("div", {
      "class": "".concat(classPrefix, "-timeline-item__wrapper")
    }, [h("div", {
      "class": dotClassName,
      "style": {
        borderColor: !DEFAULT_THEME.includes(dotColor) && dotColor
      }
    }, [!dotElement && loading && h(loading_index.Loading, {
      "attrs": {
        "size": "12px"
      },
      "class": dotContentClass
    }), dotElement]), h("div", {
      "class": tailClassName
    })]), h("div", {
      "class": "".concat(classPrefix, "-timeline-item__content")
    }, [utils_renderTnode.renderContent(this, "content", "default"), mode === "same" && labelNode && h("div", {
      "class": labelClassName
    }, [labelNode])])]);
  }
});

exports["default"] = _TimelineItem;
//# sourceMappingURL=timeline-item.js.map
