/**
 * tdesign v1.12.0
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var _defineProperty = require('@babel/runtime/helpers/defineProperty');
var VueCompositionAPI = require('@vue/composition-api');
var timeline_utils = require('./utils.js');
var timeline_timelineItem = require('./timeline-item.js');
var timeline_props = require('./props.js');
var hooks_useConfig = require('../hooks/useConfig.js');
require('../_common/js/log/log.js');
require('../loading/index.js');
require('../loading/directive.js');
require('../loading/plugin.js');
require('vue');
require('../loading/loading.js');
require('../loading/icon/gradient.js');
require('../_common/js/loading/circle-adapter.js');
require('../_common/js/utils/setStyle.js');
require('../_common/js/utils/helper.js');
require('@babel/runtime/helpers/toConsumableArray');
require('@babel/runtime/helpers/objectWithoutProperties');
require('@babel/runtime/helpers/slicedToArray');
require('../_chunks/dep-caea5f4e.js');
require('../_chunks/dep-1fe4c69b.js');
require('../_chunks/dep-2e662da4.js');
require('../_chunks/dep-31fa06d0.js');
require('@babel/runtime/helpers/typeof');
require('../_chunks/dep-36c57efe.js');
require('../_chunks/dep-f4d07ab0.js');
require('../_chunks/dep-260a7245.js');
require('../config-provider/config-receiver.js');
require('../_chunks/dep-65c8d021.js');
require('../_common/js/global-config/default-config.js');
require('../_common/js/global-config/locale/zh_CN.js');
require('../_chunks/dep-bc99824f.js');
require('../_chunks/dep-4effc6c4.js');
require('dayjs');
require('../_chunks/dep-d59c4646.js');
require('../_chunks/dep-11382958.js');
require('../_chunks/dep-c272f99f.js');
require('../_chunks/dep-89b9f4de.js');
require('../_chunks/dep-1c1cc34f.js');
require('../_chunks/dep-ba816077.js');
require('../_chunks/dep-852fc6a9.js');
require('../_chunks/dep-c9d43e30.js');
require('../_chunks/dep-23d55f82.js');
require('../_chunks/dep-bc3ec918.js');
require('../_chunks/dep-f97b0058.js');
require('../_chunks/dep-9a119db9.js');
require('../_chunks/dep-49887b48.js');
require('../_chunks/dep-06c569d8.js');
require('../_chunks/dep-4d554a6f.js');
require('../_chunks/dep-7ec0f498.js');
require('../_chunks/dep-fcdc23bb.js');
require('../_chunks/dep-59f3051f.js');
require('../_chunks/dep-b86e0f9e.js');
require('../utils/mixins.js');
require('../utils/dom.js');
require('raf');
require('../utils/easing.js');
require('../utils/render-tnode.js');
require('@babel/runtime/helpers/readOnlyError');
require('../_chunks/dep-f0f28315.js');
require('../_chunks/dep-7ed5d19e.js');
require('../_chunks/dep-f8b182e9.js');
require('../_chunks/dep-0f4ac92d.js');
require('../_chunks/dep-2f28fbd7.js');
require('../_chunks/dep-76d8c62c.js');
require('../_chunks/dep-2f0c3d6d.js');
require('../_chunks/dep-b08014cb.js');
require('../utils/transfer-dom.js');
require('../loading/props.js');
require('../config.js');
require('../_chunks/dep-029c3522.js');
require('../_chunks/dep-c63385b6.js');
require('../_chunks/dep-ab17e69e.js');
require('../_chunks/dep-87dae4a0.js');
require('../_chunks/dep-07989e63.js');
require('../_chunks/dep-d3e77112.js');
require('../_chunks/dep-b520fc3a.js');
require('../_chunks/dep-f2e07584.js');
require('../_chunks/dep-9a183e68.js');
require('../_chunks/dep-5c93d051.js');
require('../_chunks/dep-76dea031.js');
require('../_chunks/dep-56240b5e.js');
require('../_chunks/dep-81ddbae0.js');
require('../utils/withInstall.js');
require('./timeline-item-props.js');
require('../config-provider/useConfig.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var _defineProperty__default = /*#__PURE__*/_interopDefaultLegacy(_defineProperty);

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty__default["default"](e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var _Timeline = VueCompositionAPI.defineComponent({
  name: "TTimeline",
  components: {
    TimelineItem: timeline_timelineItem["default"]
  },
  props: _objectSpread({}, timeline_props["default"]),
  setup: function setup(props) {
    var _toRefs = VueCompositionAPI.toRefs(props),
      theme = _toRefs.theme,
      labelAlign = _toRefs.labelAlign,
      reverse = _toRefs.reverse,
      layout = _toRefs.layout,
      mode = _toRefs.mode;
    var instance = VueCompositionAPI.getCurrentInstance();
    var classPrefix = hooks_useConfig.usePrefixClass();
    var hasLabelItem = VueCompositionAPI.computed(function () {
      var defaultSlots = instance.slots["default"] ? instance.slots["default"] : [null];
      return defaultSlots.some(function (item) {
        var _item$componentOption;
        return !!(item !== null && item !== void 0 && (_item$componentOption = item.componentOptions) !== null && _item$componentOption !== void 0 && (_item$componentOption = _item$componentOption.propsData) !== null && _item$componentOption !== void 0 && _item$componentOption.label);
      });
    });
    var timelineClassName = VueCompositionAPI.computed(function () {
      var renderAlign = timeline_utils["default"](labelAlign === null || labelAlign === void 0 ? void 0 : labelAlign.value, layout === null || layout === void 0 ? void 0 : layout.value);
      var classNames = ["".concat(classPrefix.value, "-timeline"), "".concat(classPrefix.value, "-timeline-").concat(renderAlign), "".concat(classPrefix.value, "-timeline-").concat(layout === null || layout === void 0 ? void 0 : layout.value), "".concat(classPrefix.value, "-timeline-label--").concat(mode === null || mode === void 0 ? void 0 : mode.value)];
      if (reverse !== null && reverse !== void 0 && reverse.value) {
        classNames.push("".concat(classPrefix.value, "-timeline-reverse"));
      }
      if (hasLabelItem !== null && hasLabelItem !== void 0 && hasLabelItem.value) {
        classNames.push("".concat(classPrefix.value, "-timeline-label"));
      }
      return classNames.join(" ");
    });
    VueCompositionAPI.provide("TTimeline", {
      theme: theme,
      labelAlign: labelAlign,
      reverse: reverse,
      layout: layout,
      mode: mode,
      timelineClassName: timelineClassName.value
    });
    return {
      timelineClassName: timelineClassName
    };
  },
  render: function render() {
    var h = arguments[0];
    var reverse = this.reverse;
    var defaultSlot = this.$scopedSlots["default"] ? this.$scopedSlots["default"](null) : [null];
    if (reverse) {
      defaultSlot.reverse();
    }
    var timelineClassName = this.timelineClassName,
      style = this.style;
    return h("ul", {
      "class": timelineClassName,
      "style": style
    }, [defaultSlot]);
  }
});

exports["default"] = _Timeline;
//# sourceMappingURL=timeline.js.map
