/**
 * tdesign v1.12.0
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var helper = require('../../_chunks/dep-27ac0b8c.js');
var _defineProperty = require('@babel/runtime/helpers/defineProperty');
var _typeof = require('@babel/runtime/helpers/typeof');
var tdesignIconsVue = require('tdesign-icons-vue');
var input_index = require('../../input/index.js');
var utils_mixins = require('../../utils/mixins.js');
var configProvider_configReceiver = require('../../config-provider/config-receiver.js');
require('../../input/input.js');
require('@babel/runtime/helpers/toConsumableArray');
require('@babel/runtime/helpers/slicedToArray');
require('../../_common/js/utils/helper.js');
require('@babel/runtime/helpers/objectWithoutProperties');
require('../../_chunks/dep-caea5f4e.js');
require('../../_chunks/dep-1fe4c69b.js');
require('../../_chunks/dep-2e662da4.js');
require('../../_chunks/dep-31fa06d0.js');
require('../../_chunks/dep-36c57efe.js');
require('../../_chunks/dep-f4d07ab0.js');
require('../../_chunks/dep-260a7245.js');
require('../../utils/helper.js');
require('../../_chunks/dep-f0f28315.js');
require('../../_chunks/dep-7ed5d19e.js');
require('../../_chunks/dep-f8b182e9.js');
require('../../_chunks/dep-0f4ac92d.js');
require('../../_chunks/dep-2f28fbd7.js');
require('../../_chunks/dep-76d8c62c.js');
require('../../_chunks/dep-2f0c3d6d.js');
require('../../utils/event.js');
require('../../input/props.js');
require('../../utils/render-tnode.js');
require('@babel/runtime/helpers/readOnlyError');
require('vue');
require('@vue/composition-api');
require('../../_chunks/dep-b08014cb.js');
require('../../_common/js/log/log.js');
require('../../_chunks/dep-65c8d021.js');
require('../../_common/js/global-config/default-config.js');
require('../../_common/js/global-config/locale/zh_CN.js');
require('../../_chunks/dep-bc99824f.js');
require('../../_chunks/dep-4effc6c4.js');
require('dayjs');
require('../../_chunks/dep-d59c4646.js');
require('../../_chunks/dep-11382958.js');
require('../../_chunks/dep-c272f99f.js');
require('../../_chunks/dep-89b9f4de.js');
require('../../_chunks/dep-1c1cc34f.js');
require('../../_chunks/dep-ba816077.js');
require('../../_chunks/dep-852fc6a9.js');
require('../../_chunks/dep-c9d43e30.js');
require('../../_chunks/dep-23d55f82.js');
require('../../_chunks/dep-bc3ec918.js');
require('../../_chunks/dep-f97b0058.js');
require('../../_chunks/dep-9a119db9.js');
require('../../_chunks/dep-49887b48.js');
require('../../_chunks/dep-06c569d8.js');
require('../../_chunks/dep-4d554a6f.js');
require('../../_chunks/dep-7ec0f498.js');
require('../../_chunks/dep-fcdc23bb.js');
require('../../_chunks/dep-59f3051f.js');
require('../../_chunks/dep-b86e0f9e.js');
require('../../input/input-group.js');
require('../../utils/map-props.js');
require('../../utils/withInstall.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var _defineProperty__default = /*#__PURE__*/_interopDefaultLegacy(_defineProperty);
var _typeof__default = /*#__PURE__*/_interopDefaultLegacy(_typeof);

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty__default["default"](e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var Search = utils_mixins["default"](configProvider_configReceiver.getGlobalIconMixins()).extend({
  name: "TTransferSearch",
  model: {
    prop: "searchValue",
    event: "change"
  },
  props: {
    searchValue: {
      type: String,
      "default": ""
    },
    search: {
      type: [Boolean, Object]
    },
    placeholder: String,
    classPrefix: String
  },
  render: function render() {
    var _this = this;
    var h = arguments[0];
    var _this$useGlobalIcon = this.useGlobalIcon({
        SearchIcon: tdesignIconsVue.SearchIcon
      }),
      SearchIcon = _this$useGlobalIcon.SearchIcon;
    var searchValue = this.searchValue,
      search = this.search,
      placeholder = this.placeholder,
      classPrefix = this.classPrefix;
    var inputProps = _typeof__default["default"](search) === "object" ? search : {
      clearable: true
    };
    var handleSearch = function handleSearch(value, trigger, changeCtx) {
      _this.$emit("search", {
        value: value,
        trigger: trigger,
        e: changeCtx.e
      });
    };
    var handleChange = function handleChange(value, changeCtx) {
      _this.$emit("change", value);
      handleSearch(value, "input", changeCtx);
    };
    var handleEnter = function handleEnter(value, changeCtx) {
      handleSearch(value, "enter", changeCtx);
    };
    return h("div", {
      "class": "".concat(classPrefix, "-transfer__search-wrapper")
    }, [h(input_index.Input, helper.helper([{}, {
      "props": _objectSpread({}, inputProps)
    }, {
      "attrs": {
        "value": searchValue,
        "placeholder": placeholder
      },
      "on": {
        "change": handleChange,
        "enter": handleEnter
      }
    }]), [h(SearchIcon, {
      "slot": "suffix-icon"
    })])]);
  }
});

exports["default"] = Search;
//# sourceMappingURL=transfer-search.js.map
