/**
 * tdesign v1.12.0
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var VueCompositionAPI = require('@vue/composition-api');
var Vue = require('vue');
var utils_withInstall = require('../utils/withInstall.js');
var hooks_useVModel = require('../hooks/useVModel.js');
var hooks_useDefaultValue = require('../hooks/useDefaultValue.js');
var tdesignIconsVue = require('tdesign-icons-vue');
var checkbox_index = require('../checkbox/index.js');
var loading_index = require('../loading/index.js');
var hooks_useConfig = require('../hooks/useConfig.js');
var hooks_useGlobalIcon = require('../hooks/useGlobalIcon.js');
var hooks_useLazyLoad = require('../hooks/useLazyLoad.js');
var hooks_useVirtualScrollNew = require('../hooks/useVirtualScrollNew.js');
var _common_js_tree_treeNode = require('../_common/js/tree/tree-node.js');
var configProvider_useConfig = require('../config-provider/useConfig.js');
require('@babel/runtime/helpers/defineProperty');
require('../_chunks/dep-7ed5d19e.js');
require('../_chunks/dep-f8b182e9.js');
require('../_chunks/dep-31fa06d0.js');
require('@babel/runtime/helpers/typeof');
require('../_chunks/dep-36c57efe.js');
require('../_chunks/dep-0f4ac92d.js');
require('../_chunks/dep-f4d07ab0.js');
require('../_chunks/dep-2f28fbd7.js');
require('../_chunks/dep-76d8c62c.js');
require('../_chunks/dep-b08014cb.js');
require('../_chunks/dep-2f0c3d6d.js');
require('../checkbox/group.js');
require('../_chunks/dep-27ac0b8c.js');
require('@babel/runtime/helpers/toConsumableArray');
require('@babel/runtime/helpers/slicedToArray');
require('../utils/helper.js');
require('@babel/runtime/helpers/objectWithoutProperties');
require('../_chunks/dep-f0f28315.js');
require('../checkbox/checkbox.js');
require('../checkbox/props.js');
require('../checkbox/constants.js');
require('../checkbox/store.js');
require('@babel/runtime/helpers/classCallCheck');
require('@babel/runtime/helpers/createClass');
require('../checkbox/hooks/useKeyboardEvent.js');
require('../_common/js/common.js');
require('../hooks/useFormDisabled.js');
require('../hooks/useElementLazyRender.js');
require('../_common/js/utils/observe.js');
require('../utils/render-tnode.js');
require('@babel/runtime/helpers/readOnlyError');
require('../_chunks/dep-65c8d021.js');
require('../_common/js/global-config/default-config.js');
require('../_common/js/global-config/locale/zh_CN.js');
require('../_chunks/dep-bc99824f.js');
require('../_chunks/dep-4effc6c4.js');
require('dayjs');
require('../_chunks/dep-d59c4646.js');
require('../_chunks/dep-11382958.js');
require('../_chunks/dep-c272f99f.js');
require('../_chunks/dep-89b9f4de.js');
require('../_chunks/dep-1c1cc34f.js');
require('../_chunks/dep-ba816077.js');
require('../_chunks/dep-852fc6a9.js');
require('../_chunks/dep-c9d43e30.js');
require('../_chunks/dep-23d55f82.js');
require('../_chunks/dep-bc3ec918.js');
require('../_chunks/dep-f97b0058.js');
require('../_chunks/dep-9a119db9.js');
require('../_chunks/dep-49887b48.js');
require('../_chunks/dep-06c569d8.js');
require('../_chunks/dep-4d554a6f.js');
require('../_chunks/dep-7ec0f498.js');
require('../_chunks/dep-fcdc23bb.js');
require('../_chunks/dep-59f3051f.js');
require('../_chunks/dep-b86e0f9e.js');
require('../checkbox/checkbox-group-props.js');
require('../_chunks/dep-49944b19.js');
require('../_chunks/dep-ab17e69e.js');
require('../_chunks/dep-195eea38.js');
require('../_chunks/dep-caea5f4e.js');
require('../hooks/slots.js');
require('../loading/directive.js');
require('../loading/plugin.js');
require('../loading/loading.js');
require('../loading/icon/gradient.js');
require('../_common/js/loading/circle-adapter.js');
require('../_common/js/utils/setStyle.js');
require('../_common/js/utils/helper.js');
require('../_chunks/dep-1fe4c69b.js');
require('../_chunks/dep-2e662da4.js');
require('../_chunks/dep-260a7245.js');
require('../config-provider/config-receiver.js');
require('../utils/mixins.js');
require('../utils/dom.js');
require('raf');
require('../utils/easing.js');
require('../utils/transfer-dom.js');
require('../loading/props.js');
require('../config.js');
require('../_chunks/dep-029c3522.js');
require('../_chunks/dep-c63385b6.js');
require('../_chunks/dep-87dae4a0.js');
require('../_chunks/dep-07989e63.js');
require('../_chunks/dep-d3e77112.js');
require('../_chunks/dep-b520fc3a.js');
require('../_chunks/dep-f2e07584.js');
require('../_chunks/dep-9a183e68.js');
require('../_chunks/dep-5c93d051.js');
require('../_chunks/dep-76dea031.js');
require('../_chunks/dep-56240b5e.js');
require('../_chunks/dep-81ddbae0.js');
require('../hooks/useResizeObserver.js');
require('@babel/runtime/helpers/asyncToGenerator');
require('@babel/runtime/regenerator');
require('../_common/js/tree/tree-node-model.js');
require('../_common/js/log/log.js');
require('../_chunks/dep-a3139c33.js');
require('../_chunks/dep-11856238.js');
require('../_chunks/dep-b5cedeaa.js');
require('../_chunks/dep-0982adb4.js');
require('../_chunks/dep-bd4b64b6.js');
require('../_chunks/dep-a588d57a.js');
require('../_chunks/dep-ebbfcd2e.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var VueCompositionAPI__default = /*#__PURE__*/_interopDefaultLegacy(VueCompositionAPI);
var Vue__default = /*#__PURE__*/_interopDefaultLegacy(Vue);

var isVueNext = false;
var TransitionGroup = Vue__default["default"].component("TransitionGroup");
var onDrag = {
  "default": void 0
};
var TreeItemDefinition = {
  name: "TTreeItem",
  inject: {
    onDrag: onDrag
  }
};
function useRipple(el) {}
function withInstall(construct) {
  return utils_withInstall.withInstall(construct, VueCompositionAPI__default["default"]);
}
function getCreateElement(h) {
  return h;
}
function getScopedSlots(instance) {
  return instance.$scopedSlots;
}
function useVModel(props, refsProps) {
  var propName = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : "value";
  var defaultPropName = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : "defaultValue";
  var eventPropName = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : "onChange";
  var eventName = arguments.length > 5 && arguments[5] !== undefined ? arguments[5] : "change";
  if (propName === "value") {
    return hooks_useVModel.useVModel(refsProps[propName], props[defaultPropName], props[eventPropName], eventName, propName);
  }
  return hooks_useDefaultValue["default"](refsProps[propName], props[defaultPropName], props[eventPropName], propName, eventName);
}

Object.defineProperty(exports, 'computed', {
  enumerable: true,
  get: function () { return VueCompositionAPI.computed; }
});
Object.defineProperty(exports, 'defineComponent', {
  enumerable: true,
  get: function () { return VueCompositionAPI.defineComponent; }
});
Object.defineProperty(exports, 'onMounted', {
  enumerable: true,
  get: function () { return VueCompositionAPI.onMounted; }
});
Object.defineProperty(exports, 'reactive', {
  enumerable: true,
  get: function () { return VueCompositionAPI.reactive; }
});
Object.defineProperty(exports, 'ref', {
  enumerable: true,
  get: function () { return VueCompositionAPI.ref; }
});
Object.defineProperty(exports, 'toRefs', {
  enumerable: true,
  get: function () { return VueCompositionAPI.toRefs; }
});
Object.defineProperty(exports, 'watch', {
  enumerable: true,
  get: function () { return VueCompositionAPI.watch; }
});
Object.defineProperty(exports, 'TdCaretRightSmallIcon', {
  enumerable: true,
  get: function () { return tdesignIconsVue.CaretRightSmallIcon; }
});
exports.TCheckBox = checkbox_index.Checkbox;
exports.TLoading = loading_index.Loading;
exports.usePrefixClass = hooks_useConfig.usePrefixClass;
exports.useGlobalIcon = hooks_useGlobalIcon.useGlobalIcon;
exports.useLazyLoad = hooks_useLazyLoad["default"];
exports.useVirtualScroll = hooks_useVirtualScrollNew["default"];
exports.TreeNode = _common_js_tree_treeNode.TreeNode;
exports.privateKey = _common_js_tree_treeNode.privateKey;
exports.useConfig = configProvider_useConfig.useConfig;
exports.TransitionGroup = TransitionGroup;
exports.TreeItemDefinition = TreeItemDefinition;
exports.getCreateElement = getCreateElement;
exports.getScopedSlots = getScopedSlots;
exports.isVueNext = isVueNext;
exports.useRipple = useRipple;
exports.useVModel = useVModel;
exports.withInstall = withInstall;
//# sourceMappingURL=adapt.js.map
