/**
 * tdesign v1.12.0
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var hooks_useConfig = require('../../hooks/useConfig.js');
require('@vue/composition-api');
require('../../config-provider/useConfig.js');
require('../../_chunks/dep-65c8d021.js');
require('../../_common/js/global-config/default-config.js');
require('../../_common/js/global-config/locale/zh_CN.js');
require('../../_chunks/dep-bc99824f.js');
require('@babel/runtime/helpers/typeof');
require('../../_chunks/dep-4effc6c4.js');
require('dayjs');
require('../../_chunks/dep-d59c4646.js');
require('../../_chunks/dep-11382958.js');
require('../../_chunks/dep-c272f99f.js');
require('../../_chunks/dep-89b9f4de.js');
require('../../_chunks/dep-1c1cc34f.js');
require('../../_chunks/dep-31fa06d0.js');
require('../../_chunks/dep-ba816077.js');
require('../../_chunks/dep-852fc6a9.js');
require('../../_chunks/dep-c9d43e30.js');
require('../../_chunks/dep-f4d07ab0.js');
require('../../_chunks/dep-36c57efe.js');
require('../../_chunks/dep-23d55f82.js');
require('../../_chunks/dep-bc3ec918.js');
require('../../_chunks/dep-f97b0058.js');
require('../../_chunks/dep-9a119db9.js');
require('../../_chunks/dep-49887b48.js');
require('../../_chunks/dep-06c569d8.js');
require('../../_chunks/dep-4d554a6f.js');
require('../../_chunks/dep-7ec0f498.js');
require('../../_chunks/dep-fcdc23bb.js');
require('../../_chunks/dep-59f3051f.js');
require('../../_chunks/dep-b86e0f9e.js');

function useItemEvents(state) {
  var context = state.context;
  var classPrefix = hooks_useConfig.usePrefixClass().value;
  var handleChange = function handleChange(_, ctx) {
    var node = state.node;
    var event = new Event("change");
    var evtContext = {
      event: event,
      node: node
    };
    context.emit("change", evtContext, ctx);
  };
  var clicked = false;
  var handleClick = function handleClick(evt) {
    var _srcTarget$className, _srcTarget$className$;
    var node = state.node,
      treeScope = state.treeScope;
    var _treeScope$treeProps = treeScope.treeProps,
      treeProps = _treeScope$treeProps === void 0 ? {} : _treeScope$treeProps;
    var expandOnClickNode = treeProps.expandOnClickNode;
    var srcTarget = evt.target;
    var isBranchTrigger = node.children && expandOnClickNode && (srcTarget.className === "".concat(classPrefix, "-checkbox__input") || srcTarget.tagName.toLowerCase() === "input");
    if (clicked || isBranchTrigger) return;
    clicked = true;
    setTimeout(function () {
      clicked = false;
    });
    if (expandOnClickNode && node.children && ((_srcTarget$className = srcTarget.className) === null || _srcTarget$className === void 0 || (_srcTarget$className$ = _srcTarget$className.indexOf) === null || _srcTarget$className$ === void 0 ? void 0 : _srcTarget$className$.call(_srcTarget$className, "".concat(classPrefix, "-tree__label"))) !== -1) {
      evt.preventDefault();
    }
    var evtContext = {
      mouseEvent: evt,
      event: evt,
      node: node,
      path: node.getPath()
    };
    context.emit("click", evtContext);
  };
  return {
    handleChange: handleChange,
    handleClick: handleClick
  };
}

exports["default"] = useItemEvents;
//# sourceMappingURL=useItemEvents.js.map
