/**
 * tdesign v1.12.0
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var _defineProperty = require('@babel/runtime/helpers/defineProperty');
var tree_hooks_useItemEvents = require('./useItemEvents.js');
var tree_hooks_useRenderIcon = require('./useRenderIcon.js');
var tree_hooks_useRenderLabel = require('./useRenderLabel.js');
var tree_hooks_useRenderLine = require('./useRenderLine.js');
var tree_hooks_useRenderOperations = require('./useRenderOperations.js');
var tree_hooks_useDraggable = require('./useDraggable.js');
var hooks_useConfig = require('../../hooks/useConfig.js');
var hooks_useLazyLoad = require('../../hooks/useLazyLoad.js');
var VueCompositionAPI = require('@vue/composition-api');
require('../util.js');
require('../../_chunks/dep-f0f28315.js');
require('../../_chunks/dep-7ed5d19e.js');
require('../../_chunks/dep-f8b182e9.js');
require('../../_chunks/dep-31fa06d0.js');
require('@babel/runtime/helpers/typeof');
require('../../_chunks/dep-36c57efe.js');
require('../../_chunks/dep-0f4ac92d.js');
require('../../_chunks/dep-f4d07ab0.js');
require('../../_chunks/dep-2f28fbd7.js');
require('../../_chunks/dep-76d8c62c.js');
require('../../_chunks/dep-2f0c3d6d.js');
require('../../loading/index.js');
require('../../loading/directive.js');
require('../../loading/plugin.js');
require('vue');
require('../../loading/loading.js');
require('../../loading/icon/gradient.js');
require('../../_common/js/loading/circle-adapter.js');
require('../../_common/js/utils/setStyle.js');
require('../../_common/js/utils/helper.js');
require('@babel/runtime/helpers/toConsumableArray');
require('@babel/runtime/helpers/objectWithoutProperties');
require('@babel/runtime/helpers/slicedToArray');
require('../../_chunks/dep-caea5f4e.js');
require('../../_chunks/dep-1fe4c69b.js');
require('../../_chunks/dep-2e662da4.js');
require('../../_chunks/dep-260a7245.js');
require('../../config-provider/config-receiver.js');
require('../../_chunks/dep-65c8d021.js');
require('../../_common/js/global-config/default-config.js');
require('../../_common/js/global-config/locale/zh_CN.js');
require('../../_chunks/dep-bc99824f.js');
require('../../_chunks/dep-4effc6c4.js');
require('dayjs');
require('../../_chunks/dep-d59c4646.js');
require('../../_chunks/dep-11382958.js');
require('../../_chunks/dep-c272f99f.js');
require('../../_chunks/dep-89b9f4de.js');
require('../../_chunks/dep-1c1cc34f.js');
require('../../_chunks/dep-ba816077.js');
require('../../_chunks/dep-852fc6a9.js');
require('../../_chunks/dep-c9d43e30.js');
require('../../_chunks/dep-23d55f82.js');
require('../../_chunks/dep-bc3ec918.js');
require('../../_chunks/dep-f97b0058.js');
require('../../_chunks/dep-9a119db9.js');
require('../../_chunks/dep-49887b48.js');
require('../../_chunks/dep-06c569d8.js');
require('../../_chunks/dep-4d554a6f.js');
require('../../_chunks/dep-7ec0f498.js');
require('../../_chunks/dep-fcdc23bb.js');
require('../../_chunks/dep-59f3051f.js');
require('../../_chunks/dep-b86e0f9e.js');
require('../../utils/mixins.js');
require('../../utils/dom.js');
require('raf');
require('../../utils/easing.js');
require('../../utils/render-tnode.js');
require('@babel/runtime/helpers/readOnlyError');
require('../../_chunks/dep-b08014cb.js');
require('../../utils/transfer-dom.js');
require('../../loading/props.js');
require('../../config.js');
require('../../_chunks/dep-029c3522.js');
require('../../_chunks/dep-c63385b6.js');
require('../../_chunks/dep-ab17e69e.js');
require('../../_chunks/dep-87dae4a0.js');
require('../../_chunks/dep-07989e63.js');
require('../../_chunks/dep-d3e77112.js');
require('../../_chunks/dep-b520fc3a.js');
require('../../_chunks/dep-f2e07584.js');
require('../../_chunks/dep-9a183e68.js');
require('../../_chunks/dep-5c93d051.js');
require('../../_chunks/dep-76dea031.js');
require('../../_chunks/dep-56240b5e.js');
require('../../_chunks/dep-81ddbae0.js');
require('../../utils/withInstall.js');
require('../../hooks/useGlobalIcon.js');
require('../../config-provider/useConfig.js');
require('tdesign-icons-vue');
require('../../_chunks/dep-27ac0b8c.js');
require('../../_chunks/dep-a3139c33.js');
require('../../checkbox/index.js');
require('../../checkbox/group.js');
require('../../utils/helper.js');
require('../../checkbox/checkbox.js');
require('../../checkbox/props.js');
require('../../checkbox/constants.js');
require('../../checkbox/store.js');
require('@babel/runtime/helpers/classCallCheck');
require('@babel/runtime/helpers/createClass');
require('../../checkbox/hooks/useKeyboardEvent.js');
require('../../_common/js/common.js');
require('../../hooks/useVModel.js');
require('../../hooks/useFormDisabled.js');
require('../../hooks/useElementLazyRender.js');
require('../../_common/js/utils/observe.js');
require('../../checkbox/checkbox-group-props.js');
require('../../_chunks/dep-49944b19.js');
require('../../_chunks/dep-195eea38.js');
require('../../hooks/slots.js');
require('../../_chunks/dep-b286149a.js');
require('../../_chunks/dep-e9318595.js');
require('../../_chunks/dep-50b0a969.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var _defineProperty__default = /*#__PURE__*/_interopDefaultLegacy(_defineProperty);

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty__default["default"](e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function useTreeItem(state) {
  var treeScope = state.treeScope,
    treeItemRef = state.treeItemRef;
  var virtualConfig = treeScope.virtualConfig,
    treeContentRef = treeScope.treeContentRef,
    scrollProps = treeScope.scrollProps;
  var classPrefix = hooks_useConfig.usePrefixClass().value;
  var componentName = hooks_useConfig.usePrefixClass("tree").value;
  var _useItemEvents = tree_hooks_useItemEvents["default"](state),
    handleClick = _useItemEvents.handleClick;
  var _useRenderIcon = tree_hooks_useRenderIcon["default"](state),
    renderIcon = _useRenderIcon.renderIcon;
  var _useRenderLabel = tree_hooks_useRenderLabel["default"](state),
    renderLabel = _useRenderLabel.renderLabel;
  var _useRenderLine = tree_hooks_useRenderLine["default"](state),
    renderLine = _useRenderLine.renderLine;
  var _useRenderOperations = tree_hooks_useRenderOperations["default"](state),
    renderOperations = _useRenderOperations.renderOperations;
  var _useDraggable = tree_hooks_useDraggable["default"](state),
    dragStates = _useDraggable.dragStates,
    handleDragStart = _useDraggable.handleDragStart,
    handleDragEnd = _useDraggable.handleDragEnd,
    handleDragOver = _useDraggable.handleDragOver,
    handleDragLeave = _useDraggable.handleDragLeave,
    handleDrop = _useDraggable.handleDrop;
  var _useLazyLoad = hooks_useLazyLoad["default"](treeContentRef, treeItemRef, VueCompositionAPI.reactive(_objectSpread({}, scrollProps === null || scrollProps === void 0 ? void 0 : scrollProps.value))),
    hasLazyLoadHolder = _useLazyLoad.hasLazyLoadHolder,
    tRowHeight = _useLazyLoad.tRowHeight;
  VueCompositionAPI.onMounted(function () {
    var node = state.node;
    var isVirtual = virtualConfig === null || virtualConfig === void 0 ? void 0 : virtualConfig.isVirtualScroll.value;
    if (isVirtual) {
      virtualConfig.handleRowMounted({
        ref: treeItemRef,
        data: node
      });
    }
  });
  var getItemStyles = function getItemStyles() {
    var node = state.node;
    var level = node.level;
    var levelStyle = "--level: ".concat(level, ";");
    var strStyle = "".concat(levelStyle);
    return strStyle;
  };
  var getItemClassList = function getItemClassList() {
    var node = state.node;
    var isDragOver = dragStates.isDragOver,
      isDragging = dragStates.isDragging,
      dropPosition = dragStates.dropPosition;
    var list = [];
    list.push("".concat(componentName, "__item"));
    list.push(_defineProperty__default["default"](_defineProperty__default["default"](_defineProperty__default["default"]({}, "".concat(componentName, "__item--open"), node.expanded), "".concat(classPrefix, "-is-active"), node.isActivable() ? node.actived : false), "".concat(classPrefix, "-is-disabled"), node.isDisabled()));
    list.push(_defineProperty__default["default"]({}, "".concat(componentName, "__item--draggable"), node.isDraggable()));
    if (node.visible) {
      list.push("".concat(componentName, "__item--visible"));
    } else {
      list.push("".concat(componentName, "__item--hidden"));
    }
    if (node.vmIsLocked) {
      list.push("".concat(componentName, "__item--locked"));
    }
    if (node.vmIsRest) {
      list.push("".concat(componentName, "__item--matched"));
    }
    list.push(_defineProperty__default["default"](_defineProperty__default["default"](_defineProperty__default["default"](_defineProperty__default["default"]({}, "".concat(componentName, "__item--dragging"), isDragging), "".concat(componentName, "__item--tip-top"), isDragOver && dropPosition < 0), "".concat(componentName, "__item--tip-bottom"), isDragOver && dropPosition > 0), "".concat(componentName, "__item--tip-highlight"), !isDragging && isDragOver && dropPosition === 0));
    return list;
  };
  var renderItem = function renderItem(h) {
    var itemNodes = [];
    var iconNode = renderIcon(h);
    var lineNode = renderLine(h);
    if (lineNode) {
      itemNodes.push(lineNode);
    }
    if (iconNode) {
      itemNodes.push(iconNode);
    }
    var labelNode = renderLabel(h);
    if (labelNode) {
      itemNodes.push(labelNode);
    }
    var opNode = renderOperations(h);
    if (opNode) {
      itemNodes.push(opNode);
    }
    return itemNodes;
  };
  var renderItemNode = function renderItemNode(h) {
    var node = state.node,
      props = state.props;
    if (!node) return null;
    var level = node.level,
      value = node.value;
    var styles = getItemStyles();
    var classList = getItemClassList();
    var treeState = state;
    treeState.stateId = props.stateId;
    var itemNode = h("div", {
      "ref": "treeItemRef",
      "class": classList,
      "attrs": {
        "data-value": value,
        "data-level": level,
        "draggable": node.isDraggable()
      },
      "style": styles,
      "on": {
        "click": function click(evt) {
          return handleClick(evt);
        },
        "dragstart": function dragstart(evt) {
          return handleDragStart(evt);
        },
        "dragend": function dragend(evt) {
          return handleDragEnd(evt);
        },
        "dragover": function dragover(evt) {
          return handleDragOver(evt);
        },
        "dragleave": function dragleave(evt) {
          return handleDragLeave(evt);
        },
        "drop": function drop(evt) {
          return handleDrop(evt);
        }
      }
    }, [hasLazyLoadHolder.value ? [h("div")] : renderItem(h)]);
    return itemNode;
  };
  return {
    hasLazyLoadHolder: hasLazyLoadHolder,
    tRowHeight: tRowHeight,
    renderItemNode: renderItemNode
  };
}

exports["default"] = useTreeItem;
//# sourceMappingURL=useTreeItem.js.map
