/**
 * tdesign v1.12.0
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var _toConsumableArray = require('@babel/runtime/helpers/toConsumableArray');
var helper = require('../../_chunks/dep-27ac0b8c.js');
var _defineProperty = require('@babel/runtime/helpers/defineProperty');
var VueCompositionAPI = require('@vue/composition-api');
var tdesignIconsVue = require('tdesign-icons-vue');
var _common_js_upload_utils = require('../../_common/js/upload/utils.js');
var button_index = require('../../button/index.js');
var upload_constants = require('../constants.js');
var hooks_useCommonClassName = require('../../hooks/useCommonClassName.js');
var loading_index = require('../../loading/index.js');
var upload_hooks_useDrag = require('../hooks/useDrag.js');
var hooks_useGlobalIcon = require('../../hooks/useGlobalIcon.js');
var imageViewer_index = require('../../image-viewer/index.js');
var utils_renderTnode = require('../../utils/render-tnode.js');
var image_index = require('../../image/index.js');
require('../../_common/js/log/log.js');
require('../../button/button.js');
require('../../button/props.js');
require('../../utils/ripple.js');
require('../../_common/js/utils/setStyle.js');
require('../../config.js');
require('../../config-provider/config-receiver.js');
require('vue');
require('../../_chunks/dep-65c8d021.js');
require('../../_common/js/global-config/default-config.js');
require('../../_common/js/global-config/locale/zh_CN.js');
require('../../_chunks/dep-bc99824f.js');
require('@babel/runtime/helpers/typeof');
require('../../_chunks/dep-4effc6c4.js');
require('dayjs');
require('../../_chunks/dep-d59c4646.js');
require('../../_chunks/dep-11382958.js');
require('../../_chunks/dep-c272f99f.js');
require('../../_chunks/dep-89b9f4de.js');
require('../../_chunks/dep-1c1cc34f.js');
require('../../_chunks/dep-31fa06d0.js');
require('../../_chunks/dep-ba816077.js');
require('../../_chunks/dep-852fc6a9.js');
require('../../_chunks/dep-c9d43e30.js');
require('../../_chunks/dep-f4d07ab0.js');
require('../../_chunks/dep-36c57efe.js');
require('../../_chunks/dep-23d55f82.js');
require('../../_chunks/dep-bc3ec918.js');
require('../../_chunks/dep-f97b0058.js');
require('../../_chunks/dep-9a119db9.js');
require('../../_chunks/dep-49887b48.js');
require('../../_chunks/dep-06c569d8.js');
require('../../_chunks/dep-4d554a6f.js');
require('../../_chunks/dep-7ec0f498.js');
require('../../_chunks/dep-fcdc23bb.js');
require('../../_chunks/dep-59f3051f.js');
require('../../_chunks/dep-b86e0f9e.js');
require('../../utils/mixins.js');
require('../../loading/directive.js');
require('../../loading/plugin.js');
require('../../loading/loading.js');
require('../../loading/icon/gradient.js');
require('../../_common/js/loading/circle-adapter.js');
require('../../_common/js/utils/helper.js');
require('@babel/runtime/helpers/objectWithoutProperties');
require('@babel/runtime/helpers/slicedToArray');
require('../../_chunks/dep-caea5f4e.js');
require('../../_chunks/dep-1fe4c69b.js');
require('../../_chunks/dep-2e662da4.js');
require('../../_chunks/dep-260a7245.js');
require('../../utils/dom.js');
require('raf');
require('../../utils/easing.js');
require('../../utils/transfer-dom.js');
require('../../loading/props.js');
require('@babel/runtime/helpers/readOnlyError');
require('../../_chunks/dep-f0f28315.js');
require('../../_chunks/dep-7ed5d19e.js');
require('../../_chunks/dep-f8b182e9.js');
require('../../_chunks/dep-0f4ac92d.js');
require('../../_chunks/dep-2f28fbd7.js');
require('../../_chunks/dep-76d8c62c.js');
require('../../_chunks/dep-2f0c3d6d.js');
require('../../_chunks/dep-b08014cb.js');
require('../../_chunks/dep-029c3522.js');
require('../../_chunks/dep-c63385b6.js');
require('../../_chunks/dep-ab17e69e.js');
require('../../_chunks/dep-87dae4a0.js');
require('../../_chunks/dep-07989e63.js');
require('../../_chunks/dep-d3e77112.js');
require('../../_chunks/dep-b520fc3a.js');
require('../../_chunks/dep-f2e07584.js');
require('../../_chunks/dep-9a183e68.js');
require('../../_chunks/dep-5c93d051.js');
require('../../_chunks/dep-76dea031.js');
require('../../_chunks/dep-56240b5e.js');
require('../../_chunks/dep-81ddbae0.js');
require('../../utils/withInstall.js');
require('../../config-provider/useConfig.js');
require('../../image-viewer/image-viewer.js');
require('../../image-viewer/props.js');
require('../../image-viewer/base/Container.js');
require('../../image-viewer/base/ImageModalIcon.js');
require('../../hooks/useConfig.js');
require('../../hooks/tnode.js');
require('../../hooks/render-tnode.js');
require('../../_chunks/dep-1974f455.js');
require('../../image-viewer/base/ImageViewerUtils.js');
require('../../tooltip/index.js');
require('../../tooltip/tooltip.js');
require('../../tooltip/props.js');
require('../../popup/props.js');
require('../../popup/popup.js');
require('@popperjs/core');
require('../../utils/helper.js');
require('../../popup/container.js');
require('../../utils/event.js');
require('../../popup/utils.js');
require('../../_chunks/dep-e9318595.js');
require('../../_chunks/dep-50b0a969.js');
require('../../utils/map-props.js');
require('../../_common/js/input-number/large-number.js');
require('../../hooks/useImagePreviewUrl.js');
require('../../image-viewer/base/ImageItem.js');
require('../../image-viewer/hooks.js');
require('../../image-viewer/const.js');
require('../../image-viewer/base/ImageViewerModal.js');
require('../../dialog/index.js');
require('../../dialog/dialog.js');
require('../../dialog/actions.js');
require('../../dialog/props.js');
require('../../hooks/useDestroyOnClose.js');
require('../../dialog/stack.js');
require('../../_common/js/utils/getScrollbarWidth.js');
require('../../_chunks/dep-b286149a.js');
require('../../dialog/plugin.js');
require('../../config-provider/config-provider.js');
require('../../config-provider/props.js');
require('../../_chunks/dep-bdfb7a98.js');
require('../../_chunks/dep-b5cedeaa.js');
require('../../hooks/useVModel.js');
require('../../hooks/useDefaultValue.js');
require('../../image-viewer/utils.js');
require('../../image/image.js');
require('../../_common/js/utils/observe.js');
require('../../image/props.js');
require('../../space/index.js');
require('../../space/space.js');
require('../../space/props.js');
require('../../_chunks/dep-11856238.js');
require('../../_chunks/dep-0982adb4.js');
require('../../_chunks/dep-bd4b64b6.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var _toConsumableArray__default = /*#__PURE__*/_interopDefaultLegacy(_toConsumableArray);
var _defineProperty__default = /*#__PURE__*/_interopDefaultLegacy(_defineProperty);

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty__default["default"](e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var DraggerFile = VueCompositionAPI.defineComponent({
  name: "UploadDraggerFile",
  props: _objectSpread(_objectSpread({}, upload_constants.commonProps), {}, {
    trigger: Function,
    triggerUpload: Function,
    uploadFiles: Function,
    cancelUpload: Function,
    dragEvents: Object
  }),
  setup: function setup(props) {
    var _toRefs = VueCompositionAPI.toRefs(props),
      displayFiles = _toRefs.displayFiles,
      accept = _toRefs.accept;
    var _useCommonClassName = hooks_useCommonClassName["default"](),
      sizeClassNames = _useCommonClassName.sizeClassNames;
    var uploadPrefix = "".concat(props.classPrefix, "-upload");
    var drag = upload_hooks_useDrag["default"](props.dragEvents, accept);
    var dragActive = drag.dragActive;
    var draggerFileRef = VueCompositionAPI.ref();
    var classes = VueCompositionAPI.computed(function () {
      var _displayFiles$value$;
      return ["".concat(uploadPrefix, "__dragger"), _defineProperty__default["default"]({}, "".concat(uploadPrefix, "__dragger-center"), !displayFiles.value[0]), _defineProperty__default["default"]({}, "".concat(uploadPrefix, "__dragger-error"), ((_displayFiles$value$ = displayFiles.value[0]) === null || _displayFiles$value$ === void 0 ? void 0 : _displayFiles$value$.status) === "fail")];
    });
    var icons = hooks_useGlobalIcon.useGlobalIcon({
      CheckCircleFilledIcon: tdesignIconsVue.CheckCircleFilledIcon,
      ErrorCircleFilledIcon: tdesignIconsVue.ErrorCircleFilledIcon
    });
    return {
      drag: drag,
      dragActive: dragActive,
      draggerFileRef: draggerFileRef,
      classes: classes,
      sizeClassNames: sizeClassNames,
      uploadPrefix: uploadPrefix,
      icons: icons
    };
  },
  methods: {
    renderImage: function renderImage() {
      var _file$response;
      var h = this.$createElement;
      if (!this.displayFiles.length) return;
      var file = this.displayFiles[0];
      var url = (file === null || file === void 0 ? void 0 : file.url) || (file === null || file === void 0 || (_file$response = file.response) === null || _file$response === void 0 ? void 0 : _file$response.url);
      return h("div", {
        "class": "".concat(this.uploadPrefix, "__dragger-img-wrap")
      }, [h(imageViewer_index.ImageViewer, helper.helper([{
        "attrs": {
          "images": [url],
          "trigger": function trigger(h2, _ref3) {
            var open = _ref3.open;
            return h(image_index.Image, {
              "attrs": {
                "src": url || file.raw,
                "error": "",
                "loading": ""
              },
              "on": {
                "click": open
              }
            });
          }
        }
      }, {
        "props": this.imageViewerProps
      }]))]);
    },
    renderUploading: function renderUploading() {
      var h = this.$createElement;
      if (!this.displayFiles.length) return;
      var file = this.displayFiles[0];
      if ((file === null || file === void 0 ? void 0 : file.status) === "progress") {
        return h("div", {
          "class": "".concat(this.uploadPrefix, "__single-progress")
        }, [h(loading_index.Loading), h("span", {
          "class": "".concat(this.uploadPrefix, "__single-percent")
        }, [file.percent, "%"])]);
      }
    },
    renderMainPreview: function renderMainPreview() {
      var _this = this,
        _this$locale;
      var h = this.$createElement;
      var file = this.displayFiles[0];
      var _this$icons = this.icons,
        CheckCircleFilledIcon = _this$icons.CheckCircleFilledIcon,
        ErrorCircleFilledIcon = _this$icons.ErrorCircleFilledIcon;
      var fileName = this.abridgeName ? _common_js_upload_utils.abridgeName.apply(void 0, [file.name].concat(_toConsumableArray__default["default"](this.abridgeName))) : file.name;
      var fileInfo = [h("div", {
        "class": "".concat(this.uploadPrefix, "__dragger-text"),
        "key": "info"
      }, [h("span", {
        "class": "".concat(this.uploadPrefix, "__single-name")
      }, [fileName]), file.status === "progress" && this.renderUploading(), file.status === "success" && h(CheckCircleFilledIcon), file.status === "fail" && h(ErrorCircleFilledIcon)]), h("small", {
        "class": "".concat(this.sizeClassNames.small),
        "key": "size"
      }, [this.locale.file.fileSizeText, "\uFF1A", _common_js_upload_utils.getFileSizeText(file.size)]), h("small", {
        "class": "".concat(this.sizeClassNames.small),
        "key": "time"
      }, [this.locale.file.fileOperationDateText, "\uFF1A", file.uploadTime || "-"])];
      return h("div", {
        "class": "".concat(this.uploadPrefix, "__dragger-progress")
      }, [this.theme === "image" && this.renderImage(), h("div", {
        "class": "".concat(this.uploadPrefix, "__dragger-progress-info")
      }, [utils_renderTnode.renderTNodeJSX(this, "fileListDisplay", {
        params: {
          files: this.displayFiles,
          locale: this.locale,
          disabled: this.disabled,
          cancelUpload: this.cancelUpload,
          uploadFiles: this.uploadFiles,
          triggerUpload: this.triggerUpload,
          onDrop: this.drag.handleDrop,
          onDragenter: this.drag.handleDragenter,
          onDragover: this.drag.handleDragover,
          onDragleave: this.drag.handleDragleave
        }
      }) || fileInfo, h("div", {
        "class": "".concat(this.uploadPrefix, "__dragger-btns")
      }, [["progress", "waiting"].includes(file.status) && !this.disabled && h(button_index.Button, {
        "attrs": {
          "theme": "primary",
          "variant": "text"
        },
        "class": "".concat(this.uploadPrefix, "__dragger-progress-cancel"),
        "on": {
          "click": function click(e) {
            var _this$cancelUpload;
            return (_this$cancelUpload = _this.cancelUpload) === null || _this$cancelUpload === void 0 ? void 0 : _this$cancelUpload.call(_this, {
              e: e,
              file: _this.toUploadFiles[0] || _this.files[0]
            });
          }
        }
      }, [(_this$locale = this.locale) === null || _this$locale === void 0 ? void 0 : _this$locale.cancelUploadText]), !this.autoUpload && file.status === "waiting" && h(button_index.Button, {
        "attrs": {
          "theme": "primary",
          "variant": "text",
          "disabled": this.disabled
        },
        "on": {
          "click": function click() {
            var _this$uploadFiles;
            return (_this$uploadFiles = _this.uploadFiles) === null || _this$uploadFiles === void 0 ? void 0 : _this$uploadFiles.call(_this);
          }
        },
        "class": "".concat(this.uploadPrefix, "__dragger-upload-btn")
      }, [this.locale.triggerUploadText.normal])]), ["fail", "success"].includes(file === null || file === void 0 ? void 0 : file.status) && !this.disabled && h("div", {
        "class": "".concat(this.uploadPrefix, "__dragger-btns")
      }, [h(button_index.Button, {
        "attrs": {
          "theme": "primary",
          "variant": "text",
          "disabled": this.disabled
        },
        "class": "".concat(this.uploadPrefix, "__dragger-progress-cancel"),
        "on": {
          "click": this.triggerUpload
        }
      }, [this.locale.triggerUploadText.reupload]), h(button_index.Button, {
        "attrs": {
          "theme": "danger",
          "variant": "text",
          "disabled": this.disabled
        },
        "class": "".concat(this.uploadPrefix, "__dragger-delete-btn"),
        "on": {
          "click": function click(e) {
            var _this$onRemove;
            return (_this$onRemove = _this.onRemove) === null || _this$onRemove === void 0 ? void 0 : _this$onRemove.call(_this, {
              e: e,
              index: 0,
              file: file
            });
          }
        }
      }, [this.locale.triggerUploadText["delete"]])])])]);
    },
    renderDefaultDragElement: function renderDefaultDragElement() {
      var _this$locale$triggerU;
      var h = this.$createElement;
      var unActiveElement = h("div", [h("span", {
        "class": "".concat(this.uploadPrefix, "--highlight")
      }, [(_this$locale$triggerU = this.locale.triggerUploadText) === null || _this$locale$triggerU === void 0 ? void 0 : _this$locale$triggerU.normal]), h("span", ["\xA0\xA0/\xA0\xA0", this.locale.dragger.draggingText])]);
      var activeElement = h("div", [this.locale.dragger.dragDropText]);
      return this.dragActive ? activeElement : unActiveElement;
    },
    getContent: function getContent() {
      var _this$$scopedSlots$de, _this$$scopedSlots;
      var h = this.$createElement;
      var file = this.displayFiles[0];
      if (file && (["progress", "success", "fail", "waiting"].includes(file.status) || !file.status)) {
        return this.renderMainPreview();
      }
      return h("div", {
        "class": "".concat(this.uploadPrefix, "__trigger"),
        "on": {
          "click": this.triggerUpload
        }
      }, [((_this$$scopedSlots$de = (_this$$scopedSlots = this.$scopedSlots)["default"]) === null || _this$$scopedSlots$de === void 0 ? void 0 : _this$$scopedSlots$de.call(_this$$scopedSlots, null)) || this.renderDefaultDragElement()]);
    }
  },
  render: function render() {
    var _this$trigger;
    var h = arguments[0];
    return h("div", {
      "ref": "draggerFileRef",
      "class": this.classes,
      "on": {
        "drop": this.drag.handleDrop,
        "dragenter": this.drag.handleDragenter,
        "dragover": this.drag.handleDragover,
        "dragleave": this.drag.handleDragleave
      }
    }, [((_this$trigger = this.trigger) === null || _this$trigger === void 0 ? void 0 : _this$trigger.call(this, h, {
      files: this.displayFiles,
      dragActive: this.dragActive
    })) || this.getContent()]);
  }
});

exports["default"] = DraggerFile;
//# sourceMappingURL=dragger-file.js.map
