/**
 * tdesign v1.12.0
 * (c) 2025 tdesign
 * @license MIT
 */

import _Radio from './radio.js';
import _RadioGroup from './group.js';
import _RadioButton from './radio-button.js';
import mapProps from '../utils/map-props.js';
import { withInstall } from '../utils/withInstall.js';
import './style/css.js';
import './type.js';
import '../_chunks/dep-3ad6635a.js';
import '@babel/runtime/helpers/defineProperty';
import 'vue';
import '../utils/helper.js';
import '@babel/runtime/helpers/objectWithoutProperties';
import '@babel/runtime/helpers/slicedToArray';
import 'lodash-es';
import '../utils/render-tnode.js';
import '@babel/runtime/helpers/readOnlyError';
import '@babel/runtime/helpers/typeof';
import '@vue/composition-api';
import './props.js';
import '../utils/event.js';
import '../config-provider/config-receiver.js';
import '../config-provider/context.js';
import '../_common/js/global-config/default-config.js';
import '../_common/js/global-config/locale/zh_CN.js';
import '../_chunks/dep-b09592da.js';
import '../_chunks/dep-63bfe5be.js';
import 'dayjs';
import '../_chunks/dep-55f7c5cf.js';
import '../config-provider/type.js';
import '../utils/mixins.js';
import '@babel/runtime/helpers/asyncToGenerator';
import '@babel/runtime/regenerator';
import '../hooks/useResizeObserver.js';
import './radio-group-props.js';
import '../utils/dom.js';
import 'raf';
import '../utils/easing.js';
import '../_common/js/common.js';

var Radio = withInstall(mapProps(["checked"], {
  model: {
    prop: "checked",
    event: "change"
  }
})(_Radio));
var RadioGroup = withInstall(mapProps(["value"], {
  model: {
    prop: "value",
    event: "change"
  }
})(_RadioGroup));
var RadioButton = withInstall(_RadioButton);

export { Radio, RadioButton, RadioGroup, Radio as default };
//# sourceMappingURL=index.js.map
