/**
 * tdesign v1.12.0
 * (c) 2025 tdesign
 * @license MIT
 */

import { renderContent } from '../utils/render-tnode.js';
import { getClassPrefixMixins } from '../config-provider/config-receiver.js';
import mixins from '../utils/mixins.js';
import props from './content-props.js';
import '@babel/runtime/helpers/defineProperty';
import '@babel/runtime/helpers/readOnlyError';
import '@babel/runtime/helpers/typeof';
import 'vue';
import '@vue/composition-api';
import 'lodash-es';
import '../config-provider/context.js';
import '../_common/js/global-config/default-config.js';
import '../_common/js/global-config/locale/zh_CN.js';
import '../_chunks/dep-b09592da.js';
import '../_chunks/dep-63bfe5be.js';
import 'dayjs';
import '../_chunks/dep-55f7c5cf.js';
import '../config-provider/type.js';

var classPrefixMixins = getClassPrefixMixins("content");
var _Content = mixins(classPrefixMixins).extend({
  name: "TContent",
  props: props,
  render: function render() {
    var h = arguments[0];
    return h("main", {
      "class": "".concat(this.classPrefix, "-layout__content")
    }, [renderContent(this, "default", "content")]);
  }
});

export { _Content as default };
//# sourceMappingURL=content.js.map
