/**
 * tdesign v1.12.0
 * (c) 2025 tdesign
 * @license MIT
 */

import _Layout from './layout.js';
import _Header from './header.js';
import _Footer from './footer.js';
import _Aside from './aside.js';
import _Content from './content.js';
import { withInstall } from '../utils/withInstall.js';
import '@babel/runtime/helpers/defineProperty';
import '../utils/render-tnode.js';
import '@babel/runtime/helpers/readOnlyError';
import '@babel/runtime/helpers/typeof';
import 'vue';
import '@vue/composition-api';
import 'lodash-es';
import '../config-provider/config-receiver.js';
import '../config-provider/context.js';
import '../_common/js/global-config/default-config.js';
import '../_common/js/global-config/locale/zh_CN.js';
import '../_chunks/dep-aeca18f4.js';
import '../_chunks/dep-aae288e4.js';
import 'dayjs';
import '../utils/mixins.js';
import './header-props.js';
import './footer-props.js';
import './aside-props.js';
import './content-props.js';

var Aside = withInstall(_Aside);
var Layout = withInstall(_Layout);
var Header = withInstall(_Header);
var Footer = withInstall(_Footer);
var Content = withInstall(_Content);

export { Aside, Content, Footer, Header, Layout, Layout as default };
//# sourceMappingURL=index.js.map
